<?php
	/*
	Plugin Name: iDesign
	Plugin URI: http://www.webfixfast.com/idesign-plugin
	Description: The ultimate in wp web design software - use its blueprint system to conveniently convert your web visions into reality.
	Version: 1.3.0
	Author: Wordpressaholic
	*/
	
	$wmt_debug = false;

	//Enqueue backend
	add_action('admin_enqueue_scripts', 'wmt_admin_scripts');
	function wmt_admin_scripts () {
		global $wmt_debug;
		$nonce = wp_create_nonce( 'wmt-nonce' );
		wmt_front_scripts ($nonce);
		/*--------
			CSS
		----------*/
		//tile customization panel
		wp_register_style('tileSet_cust',  plugins_url( 'css/tileSet_cust.css' , __FILE__ ));
		wp_enqueue_style( 'tileSet_cust' );

		/*----------------
			JavaScripts
		------------------*/
		//overall
		$dep = $wmt_debug ? array('magnific') : array('wmt_front_combined');
		wp_register_script('wmt_js',  plugins_url( 'js/wmt_js.js' , __FILE__ ), $dep);
		wp_localize_script( 'wmt_js', 'wmt_myAjax', array( 'ajaxurl' => admin_url( 'admin-ajax.php' ), 'nonce'=>$nonce ));
		wp_enqueue_script('wmt_js');

		//nicEditor
		wp_register_script('nicedit',  plugins_url( 'js/nicEdit.js' , __FILE__ ), array('jquery'));
		wp_enqueue_script('nicedit');

		//tile customization js
		wp_register_script('tileSet_cust',  plugins_url( 'js/tileSet_cust.js' , __FILE__ ), array('jquery', 'nicedit', 'wmt_js') );
		wp_localize_script( 'tileSet_cust', 'wmt_nic', array( 'icons' => plugins_url( 'imgs/nicEditorIcons.gif' , __FILE__ )));
		wp_enqueue_script( 'tileSet_cust');

		//iris
		wp_enqueue_style( 'wp-color-picker' );
		wp_enqueue_script( 'wp-color-picker' );

		//resizer		
		wp_enqueue_script( 'jquery-ui-resizable' );

		//media uploader
		wp_enqueue_media();
	};
	
	//Enqueue front end
	add_action('wp_enqueue_scripts', 'wmt_front_scripts');
	/*
	function wmt_front_scripts () {
		//CSS
		//google fonts
		wmt_gfonts_load();
		
		//overall css
		wp_register_style('wmt_css',  plugins_url( 'css/wmt_css.css' , __FILE__ ));
		wp_enqueue_style( 'wmt_css' );

		//fontawesome
		wp_register_style('fawesome', '//netdna.bootstrapcdn.com/font-awesome/4.0.3/css/font-awesome.css');
		wp_enqueue_style( 'fawesome' );
		
		//magnific
		wp_register_style('magnific',  plugins_url( 'css/magnific.css' , __FILE__ ));
		wp_enqueue_style('magnific');
		
		//JS		
		//jquery appear
		wp_register_script('wmt_jq_appear',  plugins_url( 'js/wmt_jquery_appear.min.js' , __FILE__ ), array('jquery'));
		wp_enqueue_script('wmt_jq_appear');

		//magnific
		wp_register_script('magnific',  plugins_url( 'js/magnific.min.js' , __FILE__ ), array('jquery') );		
		wp_enqueue_script( 'magnific' );
		
		//unslider
		wp_enqueue_script( 'jquery-ui-core' );
		wp_enqueue_script( 'jquery-ui-widget' );
		wp_enqueue_script( 'jquery-ui-mouse' );
		wp_enqueue_script( 'jquery-ui-draggable' );		
		wp_register_script('unslider',  plugins_url( 'js/unslider.min.js' , __FILE__ ), array('jquery') );
		wp_enqueue_script( 'unslider' );		

		//pixtastic
		wp_register_script('pixastic',  plugins_url( 'js/pixastic.custom.js' , __FILE__ ), array('jquery'));
		wp_enqueue_script( 'pixastic' );

		//pagination
		wp_register_script('wph_paj',  plugins_url( 'js/wph_paj.min.js' , __FILE__ ), array('jquery'));
		$nonce = wp_create_nonce( 'wmt-nonce' );
		wp_localize_script( 'wph_paj', 'wmt_myAjax', array( 'ajaxurl' => admin_url( 'admin-ajax.php' ), 'nonce'=>$nonce ));
		wp_enqueue_script( 'wph_paj' );

		//detect mobile
		wp_register_script('detect-mobile',  plugins_url( 'js/detect-mobile.js' , __FILE__ ), array('jquery'));
		wp_enqueue_script( 'detect-mobile' );

		//tuner
		wp_register_script('wmt_tuner',  plugins_url( 'js/wmt_js_front.min.js' , __FILE__ ), array('detect-mobile' , 'jquery'));
		wp_enqueue_script( 'wmt_tuner' );
	};	
	*/
	function wmt_front_scripts ($nonce) {
		global $wmt_debug;
		/*--------
			CSS
		----------*/
		//google fonts
		wmt_gfonts_load();
		
		//overall css
		wp_register_style('wmt_css',  plugins_url( 'css/wmt_css.css' , __FILE__ ));
		wp_enqueue_style( 'wmt_css' );
		
		//fontawesome
		wp_register_style('fawesome', '//netdna.bootstrapcdn.com/font-awesome/4.0.3/css/font-awesome.css');
		wp_enqueue_style( 'fawesome' );
		
		//magnific
		wp_register_style('magnific',  plugins_url( 'css/magnific.css' , __FILE__ ));
		wp_enqueue_style('magnific');
	
		/*----------------
			JavaScripts
		------------------*/		
		wp_enqueue_script( 'jquery-ui-core' );
		wp_enqueue_script( 'jquery-ui-widget' );
		wp_enqueue_script( 'jquery-ui-mouse' );
		wp_enqueue_script( 'jquery-ui-draggable' );
		if (!$nonce) $nonce = wp_create_nonce( 'wmt-nonce' );
		if (!$wmt_debug) {
			//combined 
			wp_register_script('wmt_front_combined',  plugins_url( 'js/wmt_front_combined.js' , __FILE__ ), array('jquery'));
			wp_localize_script( 'wmt_front_combined', 'wmt_myAjax', array( 'ajaxurl' => admin_url( 'admin-ajax.php' ), 'nonce'=>$nonce ));
			wp_enqueue_script( 'wmt_front_combined');
		} else {
			//pagination
			wp_register_script('wph_paj',  plugins_url( 'js/wph_paj.js' , __FILE__ ), array('jquery'));
			wp_localize_script( 'wph_paj', 'wmt_myAjax', array( 'ajaxurl' => admin_url( 'admin-ajax.php' ), 'nonce'=>$nonce ));
			wp_enqueue_script( 'wph_paj' );
			
			//jquery appear
			wp_register_script('wmt_jq_appear',  plugins_url( 'js/wmt_jquery_appear.js' , __FILE__ ), array('jquery'));
			wp_enqueue_script('wmt_jq_appear');
		
			//detect mobile
			wp_register_script('detect-mobile',  plugins_url( 'js/detect-mobile.js' , __FILE__ ), array('jquery'));
			wp_enqueue_script( 'detect-mobile' );

			//unslider
			wp_register_script('unslider',  plugins_url( 'js/unslider.js' , __FILE__ ), array('jquery') );
			wp_enqueue_script( 'unslider' );

			//magnific
			wp_register_script('magnific',  plugins_url( 'js/magnific.min.js' , __FILE__ ), array('jquery'));
			wp_enqueue_script( 'magnific' );

			//pixtastic
			wp_register_script('pixastic',  plugins_url( 'js/pixastic.custom.js' , __FILE__ ), array('jquery'));
			wp_enqueue_script( 'pixastic' );			
			
			//tuner
			wp_register_script('wmt_tuner',  plugins_url( 'js/wmt_js_front.js' , __FILE__ ), array('jquery', 'detect-mobile'));
			wp_enqueue_script( 'wmt_tuner' );
		}	
	};	
	
	//Google fonts loader
	function wmt_gfonts_load() {
		$g = stripslashes_deep(get_option('idesign_gfonts', false));
		if ($g) {
			$g = stripslashes_deep($g[0]);
			wp_register_style('wmt_gfonts', $g);
			wp_enqueue_style('wmt_gfonts');
		};
	};
	
	//Mobile Detect
	if (class_exists('Mobile_Detect') != true) {
		include_once ( plugin_dir_path( __FILE__ ) . '/php/Mobile_Detect.php');
	}

	$wmt_detect = new Mobile_Detect;
	$wmt_mobile = false;
	$wmt_tablet = false;

	if($wmt_detect->isMobile() && !$wmt_detect->isTablet()) $wmt_mobile = true;	
	if($wmt_detect->isTablet()) $wmt_tablet = true;	
	
	//Add menu item
	add_action ('admin_menu', 'adding_wmt_menu');

	//Menu page creator
	function adding_wmt_menu (){
		add_menu_page( 'iDesign', 'iDesign', 'manage_options', 'idesign', 'wmt_setupPage', plugin_dir_url('__DIR__' ). 'idesign/imgs/idesign-dashboard-menu-logo.png');
	};

	//Database Handler
	include_once ( plugin_dir_path( __FILE__ ) . '/php/wph_db.php');
	$wmt_db = new wph_db ();
	
	//Setup page
	function wmt_setupPage () {
		include_once ( plugin_dir_path( __FILE__ ) . '/php/tile_customization_section.php');
	};

	//Add 'History' menu item
	add_action ('admin_menu', 'adding_wmt_history');
	function adding_wmt_history () {
		add_submenu_page(  'idesign', 'History', 'History', 'manage_options', 'idesign-history', 'wmt_historyPage');
	};

	//History page creator
	function wmt_historyPage () {
		include_once ( plugin_dir_path( __FILE__ ) . '/php/history.php');
	};
	
	//Add 'Resource' menu item
	add_action ('admin_menu', 'adding_wmt_resources');
	function adding_wmt_resources (){
		add_submenu_page(  'idesign', 'Resources', 'Resources', 'manage_options', 'idesign-resources', 'wmt_resourcesPage');
	};

	//Resource page creator
	function wmt_resourcesPage () {
		include_once ( plugin_dir_path( __FILE__ ) . '/php/resources.php');
	};

	//Add 'Support' menu item
	add_action ('admin_menu', 'adding_wmt_support');
	function adding_wmt_support(){
		add_submenu_page(  'idesign', 'Support', 'Support', 'manage_options', 'idesign-support', 'wmt_supportPage');
	};

	//Support page creator
	function wmt_supportPage () {
		include_once ( plugin_dir_path( __FILE__ ) . '/php/support.php');
	};
	
	//Limiting word count
	function wmt_limWords($string, $word_limit) {
		if ($word_limit == 0) return "";
		$words = explode(' ', $string, ($word_limit + 1));
		array_pop($words);
		if(count($words) > ($word_limit-1)) $words[] = "...";
		return implode(' ', $words);
	};
	
	/*---------
		AJAX
	----------*/
	
	//Ajax for saving google fonts	
	add_action('wp_ajax_wmt_ajax_gfonts', 'wmt_ajax_gfonts');
	function wmt_ajax_gfonts () {
		if ( ! isset( $_REQUEST['nonce'] ) || ! wp_verify_nonce( $_REQUEST['nonce'], 'wmt-nonce' ) ) die ( 'You do not have permission for this.' );	
		$arr = $_REQUEST['wmt_arr'];
		$h = 'http://fonts.googleapis.com/css?family=';
		$arr_ = json_decode(stripslashes_deep($arr), true);
		foreach ($arr_ as $v) {
			$s_arr = array();
			$h .= str_replace(" ", "+", ucwords($v['name']));
			if (!isset($v['thickness'])) $v['thickness'] = array('400');
			if (!isset($v['slant'])) $v['slant'] = array('normal');
			if (isset($v['slant'])) {
				foreach ($v['slant'] as $s) {
					if ($s === 'normal')  $s = "";
					foreach ($v['thickness'] as $t) {
						$s_arr[] = $t . $s;
					}
				}
			};
			$h.= ':'.implode(',',$s_arr);
			$h .= "|";
		};
		$h = substr($h, 0 , -1);
		update_option('idesign_gfonts', array($h,$arr) );
		$settings = get_option('idesign_settings', false);
		if (!$settings) $settings = array();
		$settings['gfonts'] = array($h,$arr);
		update_option('idesign_settings', $settings);
		echo json_encode(array("result"=>"success", "array"=>$arr, "h" => $h));
		die();
	}

	//Ajax for saving grids
	add_action('wp_ajax_wmt_ajax_save_grid', 'wmt_ajax_save_grid');
	function wmt_ajax_save_grid () {
		if (!(isset( $_REQUEST['nonce'] ) && wp_verify_nonce( $_REQUEST['nonce'], 'wmt-nonce' ))) die ('You do not have permission for this.');
		$grid = stripslashes_deep($_REQUEST['wmt_arr']);
		$grid = json_decode($grid, true);
		global $wmt_db;
		$t = $wmt_db->get_total();
		$i = isset($grid['sc_index']) ? $grid['sc_index'] : "";
		if (!isset($i) || $i === null || $i==="") $i = $t+1;
		$i = $wmt_db->set_sc($grid, $i);
		$response = array("result"=>"success", "currSet"=>$i, "grid" =>$grid);
		$response = json_encode($response);
		echo $response;
		die();
	};
	
	//Ajax for copying grids
	add_action('wp_ajax_wmt_ajax_copy_grid', 'wmt_ajax_copy_grid');
	function wmt_ajax_copy_grid () {
		if (!isset( $_REQUEST['nonce'] ) || !wp_verify_nonce( $_REQUEST['nonce'], 'wmt-nonce' ) ) die ('You do not have permission for this.');	
		$index = preg_replace("/[^0-9]/","",$_REQUEST['wmt_arr']);
		global $wmt_db;
		$t = $wmt_db->get_total();
		if (!is_numeric($index) || $index > $t) $index = $t;
		$iGrid = $wmt_db->get_sc($index);
		$response = stripslashes_deep(array("result"=>"success", "iGrid"=>$iGrid));
		$response = json_encode($response);
		echo $response;
		die();
	};
	
	//Ajax for importing entire grid database
	add_action('wp_ajax_wmt_ajax_import_total', 'wmt_ajax_import_total');
	function wmt_ajax_import_total () {
		if ( !isset( $_REQUEST['nonce'] ) || !wp_verify_nonce( $_REQUEST['nonce'], 'wmt-nonce' ) ) die ( 'You do not have permission for this.' );	
		if (isset($_FILES['wmt_upload'])) {
			$result = 'success';
			$old = $_FILES['wmt_upload']['tmp_name'];
			$new = plugin_dir_path( __FILE__ ) . '/database/idesign_database.zip';
			copy($old, $new);
			$modify = false;
			if (!empty($_REQUEST['replace_with'])) {
				$modify = array(array("type"=>"modify_addresses", "param"=>array("replace_this"=>stripslashes($_REQUEST['replace_this']), "replace_with"=>stripslashes($_REQUEST['replace_with']))));
			}
			//write to options database
			global $wmt_db;
			$wmt_db->read_backup($new, $modify);
		} else {
			$result = 'fail';
		}

		$response = array("result"=>$result, array($_REQUEST['replace_this'], $_REQUEST['replace_with']));
		$response = json_encode($response);
		echo $response;
		die();
	};

	//Ajax for exporting entire grid database
	add_action('wp_ajax_wmt_ajax_export_total', 'wmt_ajax_export_total');
	function wmt_ajax_export_total () {
		if ( ! isset( $_REQUEST['nonce'] ) || ! wp_verify_nonce( $_REQUEST['nonce'], 'wmt-nonce' ) ) die ( 'You do not have permission for this.' );
		global $wmt_db;
		$wmt_db->new_backup(plugin_dir_path( __FILE__ ) . '/database/idesign_database.zip');
		$response = array("result"=>"success");
		$response = json_encode($response);
		echo $response;
		die();
	}

	//Ajax for creating sets markup from data
	add_action( 'wp_ajax_wmt_ajax_get_set', 'wmt_ajax_get_set');
	add_action( 'wp_ajax_nopriv_wmt_ajax_get_set', 'wmt_ajax_get_set');
	function wmt_ajax_get_set () {
		if ( ! isset( $_REQUEST['nonce'] ) || ! wp_verify_nonce( $_REQUEST['nonce'], 'wmt-nonce' ) ) die ( 'You do not have permission for this.' );
		$arr = stripslashes_deep($_REQUEST['wmt_arr']);
		$arr = json_decode($arr, true);
		$arr = stripslashes_deep($arr);
		$set_index = isset($arr['set']['set-index']) ? $arr['set']['set-index'] : false;
		$combo_index = isset($arr['set']['combo-index']) ? $arr['set']['combo-index'] : false;
		$set = wmt_makeSet($arr);
		$set = stripslashes_deep($set);
		$response = array('set-html'=>$set, 'set-index' => $set_index,  'combo-index' => $combo_index );
		if (!$set) {
			$response['issue'] = "No content here, amigo!";
		} else {
			$response["result"] = "success";
		}
		$response = json_encode($response);
		echo $response;
		die();
	}
	
	//Ajax for deleting all data
	add_action( 'wp_ajax_wmt_ajax_delete_all', 'wmt_ajax_delete_all');
	function wmt_ajax_delete_all () {
		if ( ! isset( $_REQUEST['nonce'] ) || ! wp_verify_nonce( $_REQUEST['nonce'], 'wmt-nonce' ) ) die ( 'You do not have permission for this.' );	
		global $wmt_db;
		$wmt_db->del_all_scs();
		echo json_encode(array("result"=>"success"));
		die();
	}

	//create set markup
	function wmt_makeSet($arr) {
		//case for needing query
		if (isset($arr['set']['content-generation']) && $arr['set']['content-generation'] === 'automatic') {
			$arr = wmt_query($arr);
			$html = $arr; 
		};
		if (!isset($arr['set']['request'])) {//skin in case of pagination
			$dummy = isset($arr['dummy']) ? true : false;
			wmt_refine_set_arr($arr, $dummy);
			$html = wmt_generate_set_markup($arr);
		}
		return $html;		
	}

	//include the query function
	include_once ( plugin_dir_path( __FILE__ ) . '/php/query.php');

	$wmt_mk = array();
	
	//include the generate set markup function
	include_once ( plugin_dir_path( __FILE__ ) . '/php/generate_markup.php');
	
	//include file containing codes for generating different tile markups
	include_once ( plugin_dir_path( __FILE__ ) . '/php/markup_array.php');	
	
	//browser detect
	$wmt_other_browser = false;
	if(isset($_SERVER['HTTP_USER_AGENT'])){
		$agent = $_SERVER['HTTP_USER_AGENT'];
		if(!strpos($agent, 'Firefox') && !strpos($agent, 'Chrome') && !strpos($agent, 'Safari')){
			$wmt_other_browser = true;
		}
	};
	
	//dummy images
	function wmt_dummy_images (&$arr, $type) {
		/*
		if (!$arr) return;
		if ($type === "set") {
			foreach ($arr['tiles'] as $key => &$val) {
				if($val['image']['content']) $val['image']['content'] = plugin_dir_url('__DIR__').'idesign/imgs/dummy.jpg';
				if($val['image-hover']['content']) $val['image-hover']['content'] = plugin_dir_url('__DIR__').'idesign/imgs/dummy.jpg';
			}
		}
		if ($type==="design") {
			foreach($arr['sets'] as $key_1=>&$val_1) {
				foreach ($val_1['tiles'] as $key_2 => &$val_2) {
					if($val_2['image']['content']) $val_2['image']['content'] = plugin_dir_url('__DIR__').'idesign/imgs/dummy.jpg';
					if($val_2['image-hover']['content']) $val_2['image-hover']['content'] = plugin_dir_url('__DIR__').'idesign/imgs/dummy.jpg';
				}
			}
		}
		*/
		return $arr;
	}

	
/*------------------------------------
Reproduce on Front End via ShortCode
--------------------------------------*/

//Printing out the HTML on the front end
add_shortcode ('wmt_sc', 'wmt_sc');
add_shortcode ('iDesign', 'wmt_sc');
add_shortcode ('idesign', 'wmt_sc');
function wmt_sc ($atts)  {
	extract ( shortcode_atts ( array (
							'id' => false,
							'export'=>false,
							'device'=>false,
							), $atts
						)
			);
	
	//Export dummy data
	$dummy = ($_SERVER['HTTP_HOST'] === "webfixfast.com") ? true : false;

	//Get the grid data
	global $wmt_db;
	$t = $wmt_db->get_total();
	if (!$id || !is_numeric($id) || $id<1 || $id>$t) return "Please enter a valid id for your iDesign plugin shortcode";
	
	//Decide whether to display
	global $wmt_mobile;
	global $wmt_tablet;
	
	if (!$device) {
		//Display below
		$wmt_below = isset($iGrid['display-below']) ? $iGrid['display-below'] : false;
		if ($wmt_below && ($wmt_below === "pc" || $wmt_below === "tablet" ) ) {
			if ($wmt_below=== "tablet" && $wmt_tablet) return;
			if (!$wmt_mobile) return;
		};

		//Display above
		$wmt_above = isset($iGrid['display-above']) ? $iGrid['display-above'] : false;
		if ($wmt_above && ($wmt_above === "phone" || $wmt_above === "tablet" ) ) {
			if ($wmt_above=== "tablet" && $wmt_tablet) return;
			if ($wmt_mobile) return;
		};
	} else {
		if (strpos(strtolower($device), 'mobile') !== false && !$wmt_mobile) return;
		if (strpos(strtolower($device), 'pc') !== false && ($wmt_tablet || $wmt_mobile)) return;
		if (strpos(strtolower($device), 'tablet') !== false && !$wmt_tablet) return;
	}
	
	//prepare for printing
	$iGrid = $wmt_db->get_sc($id);
	$sets = $iGrid['sets'];
	$iGrid['align'] = (isset($iGrid['align'])) ?  $iGrid['align'] : 'center';

	$mobile = $wmt_mobile ? "wmt_tiles_squeezed" : "wmt_loading";//sets responsive or else loading class
	$tablet = $wmt_tablet ? "wmt_tablet_view" : "";

	if (isset($iGrid['no-resp']) && $iGrid['no-resp'] !== "" && $iGrid['no-resp'] !== "undefined") $mobile = "wmt_loading";
	
	if (isset($iGrid['bg-enabled']) && $iGrid['bg-enabled'] === "true") {
		$bgi = $iGrid['bg-image'];
		$bga = $iGrid['bg-attachment'];
		$bgp = $iGrid['bg-position'];
		$bgc = $iGrid['bg-color'];
		$bgr = $iGrid['bg-repeat'];	
	} else {
		$bgi = $bga = $bgp = $bgc = $bgr = "";
	};
	
	$h ='<div class="wmt_align_container wmt_align_'.$iGrid['align'].' '.$mobile.' '.$tablet.'" style="background-image:url('.$bgi.') ; background-attachment:'.$bga.' ; background-position: '.$bgp.'; background-color: '.$bgc.'; background-repeat: '.$bgr.'; ">';

	$h.='<div class="wmt_container_front_end wmt_container" data-wmt-container="'.$id.'" style="height:'.$iGrid['height'].'; width:'.$iGrid['width'].'" data-wmt-width="'.$iGrid['width'].'" data-wmt-height="'.$iGrid['height'].'" data-wmt-flex="'.$iGrid['flex'].'%" data-wmt-display-above="'.$iGrid['display-above'].'" data-wmt-display-below="'.$iGrid['display-below'].'">';

	if ($export) $i = 0;//set export

	foreach($sets as $c_set) {
		$c_set = stripslashes_deep($c_set);
		$set = $c_set['set'];

		$appear_classes = "";
		if (!empty($set['appear_animation_type'])) $appear_classes.= $set['appear_animation_type']." ";
		if (!empty($set['appear_animation_direction'])) $appear_classes.= $set['appear_animation_direction']." ";
		if (!empty($set['appear_animation_speed'])) $appear_classes.= $set['appear_animation_speed'];
		
		$appear ="";
		if (!empty($set['appear_animation_type'])) $appear = " wmt_appear wmt_animation";
		if ($wmt_mobile) $appear_classes = "";
		
		$disp = isset($set['mobile']) ? '' : 'wmt_hide_on_r ';
		
		$set_width_beyond_flex = isset($set['set-width-beyond-flex']) ? $set['set-width-beyond-flex'] : '100%';
		
		$style = $set['style'];
		if ($style !== '') {
			wmt_parse_for_style($set);
			$style=$set['style'];
			$style=str_replace(array('{' , '}', '"') , ' ', $style);
			$style=str_replace(',', ';', $style);
		}
		
		$force_set_full_width = (empty($set['force-set-full-width'])) ? "" : "wmt_force_set_full_width";
		
		//At this point I will be defining size and position in percentage terms
		$h .= '<div class="wmt_combined wmt_tiles_normal wmt_triggerable fa '.$disp.' '.$appear.' '.$force_set_full_width.'" data-wmt-appear="'.$appear_classes.'" data-wmt-tc=".wmt_set_title" style="height:'.$set['height'] / $iGrid['height'] * 100 .'%; min-height:'.$set['height'].'; width:'.$set['width'] / $iGrid['width'] * 100 .'%; left:'.$set['left'] / $iGrid['width'] * 100 .'%; top:'.$set['top'] / $iGrid['height'] * 100 .'%; '.$style.' " data-wmt-orig-style="'.$style.'" data-wmt-width="'.$set['width'].'" data-wmt-height="'.$set['height'].'" data-wmt-left="'.$set['left'].'" data-wmt-top="'.$set['top'].'" data-wmt-flex="'.$set['flex'].'%" data-wmt-width-m="'.(isset($set['width_m'])? $set['width_m'] : "").'" data-wmt-combo="'.$set['combo-index'].'" data-wmt-set-width-beyond-flex="'.$set_width_beyond_flex.'">';
		$h .= wmt_makeSet($c_set);		
		if ($export) {
			$c_set['v'] = "1.3.0";
			if ($dummy) $c_set = wmt_dummy_images($c_set, "set");
			$x = $id.'_'.$i;
			$h .='<a class="fa fa-copy wmt_set_export" href="#wmt_lb_'.$x.'"><div id="wmt_lb_'.$x.'" class="wmt_set_export_lightbox_content white-popup mfp-hide"><div class="wmt_set_import_lightbox"><h2>Paste this export code in the \'Import\' section of your set to copy it onto your blueprint:</h2><textarea>'.json_encode($c_set)."</textarea></div></div></a>";
			$i++;
		}
		$h .= '</div>';
	};
	
	if ($export) {//design export
		$c_set['v'] = "1.3.0";
		if ($dummy) $iGrid = wmt_dummy_images($iGrid, "design");
		$h .='<a class="fa fa-copy wmt_set_export wmt_design_export" href="#wmt_lb_'.$id.'"><div id="wmt_lb_'.$id.'" class="wmt_set_export_lightbox_content white-popup mfp-hide"><div class="wmt_set_import_lightbox"><h2>Paste this export code in the \'Import Design\' text area to get the entire design on your blueprint:</h2><textarea>'.json_encode($iGrid)."</textarea></div></div></a>";
	};
	
	$h.='</div></div>';
	return $h;
}

?>