//nicEditor
function wmt_nicEdit_init (c) {
	if (!c) c = jQuery('.wmt_TsetContainer');//init all
	c.each(function () {
		var  id ='wmt_nic_'+ Math.floor(Math.random() * 1000000),
				t = jQuery(this);
		if (!t.index() && t.find('.nicEdit-main').length) return;
		t.find('.wmt_TsetDescription').attr('id', id).siblings().not('input').remove();//remove prev instance
		new nicEditor({
								iconsPath : wmt_nic.icons, 
								buttonList : ['bold','italic','underline','strikeThrough','subscript','superscript', 'indent','outdent', 'left', 'center','right', 'justify','ol','ul','forecolor', 'link', 'unlink', 'xhtml','removeformat'],
								maxHeight: 147
							}).panelInstance(id);
	})
}

/*--color presets--*/
var wmt_preset_colors = {};
jQuery(function ($) {

    var wmt_extend_sub_objects = {
        subs: false,
        extend: function (target, subs, mod, exception) {
            if (subs === true && this.subs) subs = this.subs;
            else if (!this.subs) alert('there was no subs array passed to fn wmt_extend_sub_objects');
            for (var i = 0; i < subs.length; i++) {
                if (!target[subs[i]]) target[subs[i]] = {};
                $.extend(target[subs[i]], mod);
            }
            //$.extend(true,..) directly overwrites all subs
            if (exception) return $.extend(true, {}, target, exception);
            else return target;
        },
        convert_obj: function (obj) {
            $.each(obj, function (key, val) {
                obj[key] = wmt_extend_sub_objects.extend({}, true, obj[key]['theme'], obj[key]['exception']);
            })
            return obj;
        }
    };

    var wmt_color_themes = {
		//NONE
		0: {
            'theme': {
                "background-color": " "
            }
		},
        //BLACK
        1: {
            'theme': {
				"style":{
					"background-color": "#000000",
					"color":"#dddddd"
				},
				"style-hover":{
					"background-color": "#000000",
					"color":"#fefefe"
				},
            },
            'exception': {
                    "apply_to_multi_keys": {
                    "multi_keys": ["tagline", "description"],
					"style":{
						"background-color": "#000000",
						"color":"#999999"
					},
					"style-hover":{
						"background-color": "#000000",
						"color":"#dddddd"
					}
                }
            }
        },
        //WHITE
        2: {
            'theme': {
                    "background-color": "#ffffff",
					"color":"#222"
            },
            'exception': {
                "link": {
                        "background-color": "#333333",
                            "background-color-opacity": " ",
				},
                    "apply_to_multi_keys": {
                    "multi_keys": ["tagline", "description"],
                        "color": "#666"
                }
            }
        },
		//PURPLE (METRO)
        3: {
            'theme': {
                "background-color": "#5133AB"
            },
            'exception': {
                    "apply_to_multi_keys": {
                    "multi_keys": ["tagline", "description"],
                        "color": "#E3DAFD"
                }
            }
        },		
		//ORANGE (METRO)
        4: {
            'theme': {
                "background-color": "#D24726"
            },
            'exception': {
                    "apply_to_multi_keys": {
                    "multi_keys": ["tagline", "description"],
                        "color": "#ffffff"
                }
            }
        },
		//BLUE (METRO)
        5: {
            'theme': {
                "background-color": "#2672EC"
            },
                'exception': {
                    "apply_to_multi_keys": {
                    "multi_keys": ["tagline", "description"],
                        "color": "#D1E1FC"
                }
            }
        },
		//GREEN (METRO)
        6: {
            'theme': {
                "background-color": "#008A00"
            },
                'exception': {
                    "apply_to_multi_keys": {
                    "multi_keys": ["tagline", "description"],
                        "color": "#D8FDD8"
                }
            }
        },
		//LIGHT PURPLE
        7: {
            'theme': {
                "background-color": "#852b99",
				"color": "#ffffff"
            }
        },
		//LIGHT ORANGE
        8: {
            'theme': {
                "background-color": "#ff8d47",
				"color": "#ffffff"
            }
        },
		//LIGHT BLUE
        9: {
            'theme': {
                "background-color": "#4b8df8",
				"color": "#ffffff"
            }
        },
		//LIGHT GREEN
        10: {
            'theme': {
                "background-color": "#35aa47",
				"color": "#ffffff"
            }
        },
		//LIGHT RED
        11: {
            'theme': {
                "background-color": "#e02222",
				"color": "#ffffff"
            }
        },
		//RED
        12: {
            'theme': {
                "background-color": "#dd3333"
            },
                'exception': {
                    "apply_to_multi_keys": {
                    "multi_keys": ["tagline", "description"],
                        "color": "#FFD5D5"
                }
            }
        },
		//GREY
        13: {
            'theme': {
                "background-color": "#777777",
            },
                'exception': {
                    "apply_to_multi_keys": {
                    "multi_keys": ["tagline", "description"],
                        "color": "#dddddd"
                }
            }
        },
		//LIME
        14: {
            'theme': {
                "background-color": "#58C918"
            },
                'exception': {
                    "apply_to_multi_keys": {
                    "multi_keys": ["tagline", "description"],
                        "color": "#EFFDD0"
                }
            }
        },
		//WHITE GLASS
        15: {
            'theme': {
				"color":"#ffffff",
				"background-color": "#eeeeee",
            },
            'exception': {
                "overall": {
                    "background-color-opacity": "30",
				},
                "apply_to_multi_keys": {
                    "multi_keys": ["title", "tagline", "description"],
						"background-color": "transparent",
						"background-color-opacity": " "
                }
            }
        },
		//BLACK GLASS
        16: {
            'theme': {
				"color":"#ffffff",
				"background-color": "#000000"
            },
            'exception': {
                "overall": {
					"background-color-opacity": "70"
				},
                "apply_to_multi_keys": {
                    "multi_keys": ["title", "tagline", "description"],
						"background-color": "transparent",
						"background-color-opacity": " "
                }
            }
        },
		//GLASSIFY
        17: {
            'theme': {
				"background-color-opacity": " "
            },
            'exception': {
                "overall": {
					"background-color-opacity": "40"
				},
                "apply_to_multi_keys": {
                    "multi_keys": ["title", "tagline", "description"],
						"background-color": "transparent",
						"background-color-opacity": " "
                }
            }
        },
		//TRANSPARENT
        18: {
            'theme': {
                "background-color": "transparent",
				"background-color-opacity": " ",
				"color": "#ffffff"
            },
                'exception': {
                "link": {
                    "background-color": "#000",
					"color": "#ffffff",
					"background-color-opacity": " "
                }
            }
        }
    }


    for (var key in wmt_color_themes) {
        if (wmt_color_themes.hasOwnProperty(key)) {
            if (!wmt_color_themes[key]['theme']['style']) {// create style if it was taken for granted
                wmt_color_themes[key]['theme'] = {
                    'style': wmt_color_themes[key]['theme']
                };
            }
            if (!wmt_color_themes[key]['theme']['style']['color']) wmt_color_themes[key]['theme']['style']['color'] = "#ffffff";
            if (!wmt_color_themes[key]['theme']['style-hover']) {
                wmt_color_themes[key]['theme']['style-hover'] = jQuery.extend(true, {}, wmt_color_themes[key]['theme']['style']);
            }
			/*
            if (!wmt_color_themes[key]['theme']['style']['background-color-opacity']) {
                wmt_color_themes[key]['theme']['style']['background-color-opacity'] = "40";
                wmt_color_themes[key]['theme']['style-hover']['background-color-opacity'] = "80";
            }
			*/

            if (wmt_color_themes[key]['exception']) {

                if (wmt_color_themes[key]['exception']['apply_to_multi_keys']) {
                    if (!wmt_color_themes[key]['exception']['apply_to_multi_keys']['multi_keys']) alert('There was no multi-key array for wmt_color_themes');
                    var multi_keys = wmt_color_themes[key]['exception']['apply_to_multi_keys']['multi_keys'];
                    delete wmt_color_themes[key]['exception']['apply_to_multi_keys']['multi_keys'];
                    if (!wmt_color_themes[key]['exception']['apply_to_multi_keys']['style']) {
                        wmt_color_themes[key]['exception']['apply_to_multi_keys'] = {
                            "style": wmt_color_themes[key]['exception']['apply_to_multi_keys']
                        };
                    }
                    if (!wmt_color_themes[key]['exception']['apply_to_multi_keys']['style-hover']) {
                        wmt_color_themes[key]['exception']['apply_to_multi_keys']['style-hover'] = wmt_color_themes[key]['exception']['apply_to_multi_keys']['style'];
                    }
                    for (var i = 0; i < multi_keys.length; i++) {
                        wmt_color_themes[key]['exception'][multi_keys[i]] = wmt_color_themes[key]['exception']['apply_to_multi_keys'];
                    }
                    delete wmt_color_themes[key]['exception']['apply_to_multi_keys'];
                }

                for (var key2 in wmt_color_themes[key]['exception']) {
                    if (wmt_color_themes[key]['exception'].hasOwnProperty(key2)) {
                        if (wmt_color_themes[key]['exception'][key2]) {
                            if (!wmt_color_themes[key]['exception'][key2]['style']) {
                                wmt_color_themes[key]['exception'][key2] = {
                                    "style": wmt_color_themes[key]['exception'][key2]
                                };
                            }
                            if (!wmt_color_themes[key]['exception'][key2]['style-hover']) {
                                wmt_color_themes[key]['exception'][key2]['style-hover'] = wmt_color_themes[key]['exception'][key2]['style'];
                            }
                        };
                    }
                };

                if (!wmt_color_themes[key]['exception']['overall']) {
                    wmt_color_themes[key]['exception']['overall'] = {
                        "style": {
                            "background-color-opacity": ""
                        },
                            "style-hover": {
                            "background-color-opacity": ""
                        }
                    }
                };
            }
        }
    };

    wmt_extend_sub_objects.subs = ['title', 'tagline', 'description', 'overall', 'image'];
	wmt_preset_colors = wmt_extend_sub_objects.convert_obj(wmt_color_themes);
});
