/*--Memorize and Reproduce Blueprint---*/

var wmt_bpMem = {}, wmt_grid ={}, wmt_scroll_permission = true;

function wmt_bp_collect() {

	wmt_bpMem.min = {'row':1,'col':1};

	if (wmt_grid['sets']) {

		for(var set in wmt_grid['sets']) {

			if(wmt_grid['sets'].hasOwnProperty(set)) {

				if (wmt_grid['sets'][set]['set']['last-tile']) {

					var x = wmt_grid['sets'][set]['set']['last-tile'];

					if (wmt_bpMem.min['row'] < x['row']) wmt_bpMem.min['row'] = x['row'];

					if (wmt_bpMem.min['col'] < x['col']) wmt_bpMem.min['col'] = x['col'];

					//console.log('attempting to iterate over last tiles for dims');

				}

			}

		}

	}



	jQuery('.wmt_tile').each(function () {

		var  t = jQuery(this),

				c = parseInt(t.attr('data-wmt-col')),

				r = parseInt(t.attr('data-wmt-row'));



		t.removeClass('wmt_startTile wmt_endTile wmt_selectedTile ');

		var classes = t.attr('class');

		

		if (!wmt_bpMem[r]) wmt_bpMem[r] = {};

		if (!wmt_bpMem[r][c]) wmt_bpMem[r][c] = {};

		wmt_bpMem[r][c] = {

			'classes': classes

		}

	});



	return wmt_bpMem;	

};



function wmt_reproduce(c,r,s,g,n,al, da, db, res, bge, bgi, bgc, bga, bgp, bgr) {

	//reverse tile-geometry-tool locks 
	jQuery('.wmt_disabled').removeClass('wmt_disabled');
	jQuery('.next_combo_id').val(n);//next combo id transferred 

	var  a = wmt_bpMem,
			col = 0,
			row = 0,
			size = s || 46,
			gap = g || 2;

	for (var i in a) { //necessary to ensure user given col/row isn't lower than min required 
		if (a.hasOwnProperty(i) && i !== "min") {
			row++;
		}
	}

	for (var i in a[1]) {
		if (a[1].hasOwnProperty(i)) {
			col++;
		}
	}

	col = c || col;
	row = r || row;
	align = al || 'center';

	if (parseInt(col) < a.min['col']) col = a.min['col'];
	if (parseInt(row) < a.min['row']) row = a.min['row'];
	
//	console.log('c,r,s,g,n,al, da, db, bge, bgi, bgc, bga, bgp, bgr');
//	console.log(c+' ' + r+' ' + s+' ' + g+' ' + n+' ' + al+' ' + da+' ' + db+' ' + bge+' ' + bgi+' ' + bgc+' ' + bga+' ' + bgp+' ' + bgr);
	//update grid setting values
	jQuery('.wmt_selDimsc').val(col);//columns
	jQuery('.wmt_selDimsr').val(row);//rows
	jQuery('.wmt_bpTileSize').val(size);//cell size
	jQuery('.wmt_bpTileGap').val(gap);//cell gap
	jQuery('.wmt_grid_alignment').val(align);//alignment
	jQuery('.wmt_grid_displayAbove').val(da);//display above
	jQuery('.wmt_grid_displayBelow').val(db);//display below
	jQuery('.wmt_grid input:checked').click();//neutralize checkboxes
	if (res !== undefined) jQuery('.wmt_grid_noResp[value="'+res+'"]').not(':checked').click();//enabled
	if (bge !== undefined) jQuery('.wmt_grid_bg_enabled[value="'+bge+'"]').click();//enabled
	jQuery('.wmt_grid_bg_image').val(bgi),//image
	jQuery('.wmt_grid_bg_color').val(bgc);//color
	jQuery('.wmt_grid_bg_attachment').val(bga);//attachment
	jQuery('.wmt_grid_bg_position').val(bgp);//position
	jQuery('.wmt_grid_bg_repeat').val(bgr);//repeat

	var  t = col * row,
			w = parseInt(size)+(2*gap),
			cw = col * w,
			h = '',
			col_c = 1,
			row_c = 1;
		
	for (var i = 1; i <= t; i++) {
		if (!wmt_bpMem[row_c] || !wmt_bpMem[row_c][col_c]) {
			classes = "wmt_tile";
		} else {
			classes = wmt_bpMem[row_c][col_c]['classes'];
		}
		h += '<div class="'+classes+'" data-wmt-row="' + row_c + '" data-wmt-col="' + col_c + '" style="width:'+size+'px; height:'+size+'px; border-width:'+gap+'px;"></div>';
		col_c++;
		if (col_c > col) {
			col_c = 1;
			row_c++;
		}
	}

	jQuery('.wmt_container').find('.wmt_tile').remove().end().prepend(h).width(cw).attr({'data-wmt-cols': col, 'data-wmt-rows' : row});
	wmt.blueprint.resize.conform();
}

//Feed position data of the set
function wmt_update_set_pos_data (t, setArr) {
	var ret = true;
	if (!setArr) {
		var setArr;
		t.data('wmt') ? setArr= t.data('wmt') : setArr= {};
		ret = false;
	}
	if (!setArr['set']) setArr['set'] = {};
	var  si = (jQuery('.wmt_combined').index(t) === -1) ? 0 : jQuery('.wmt_combined').index(t),
			ci = t.attr('data-wmt-combo');
	setArr['set']['set-index'] = si;
	setArr['set']['combo-index'] = ci;			
	setArr['set']['first-tile'] = {'row':jQuery('.wmt_lockedSet'+ci).first().attr('data-wmt-row') , 'col':jQuery('.wmt_lockedSet'+ci).first().attr('data-wmt-col'), 'index':jQuery('.wmt_tile').index(jQuery('.wmt_lockedSet'+ci).first())};
	setArr['set']['connecting-tile-1'] = {'row':jQuery('.wmt_lockedSet'+ci).first().attr('data-wmt-row') , 'col':jQuery('.wmt_lockedSet'+ci).filter(':last').attr('data-wmt-col')};
	setArr['set']['connecting-tile-1']['index'] =	jQuery('.wmt_tile').index(jQuery('.wmt_lockedSet'+ci+'[data-wmt-col="'+setArr['set']['connecting-tile-1']['col']+'"][data-wmt-row="'+setArr['set']['connecting-tile-1']['row']+'"]'));
	setArr['set']['last-tile'] = {'row':jQuery('.wmt_lockedSet'+ci).filter(':last').attr('data-wmt-row') , 'col':jQuery('.wmt_lockedSet'+ci).filter(':last').attr('data-wmt-col'), 'index':jQuery('.wmt_tile').index(jQuery('.wmt_lockedSet'+ci).filter(':last'))};
	setArr['set']['connecting-tile-2'] = {'row':jQuery('.wmt_lockedSet'+ci).first().attr('data-wmt-col') , 'col':jQuery('.wmt_lockedSet'+ci).filter(':last').attr('data-wmt-row') };
	setArr['set']['connecting-tile-2']['index'] =	jQuery('.wmt_tile').index(jQuery('.wmt_lockedSet'+ci+'[data-wmt-col="'+setArr['set']['connecting-tile-2']['col']+'"][data-wmt-row="'+setArr['set']['connecting-tile-2']['row']+'"]'));

	if (!ret) t.data('wmt', setArr);
	else return setArr;
}

//responsive order
function wmt_update_responsive_pos_option () {
	var  p = jQuery('.wmt_TsetOverallSettings select[data-wmt-overall="position"]'),
			s = jQuery('.wmt_combined').index(jQuery('.wmt_custCombo')),
			h= '<select data-wmt-overall="position">';
	for (var i = 0; i<jQuery('.wmt_combined').length; i++) {
		selected = s===i ? "selected" : "";
		h += '<option value="'+i+'" '+selected+'>'+i+'</option>';
	}
	h+= "</select>";
	jQuery(h).insertAfter(p);
	p.remove();
}

jQuery(document).ready(function ($) {
	/*-- Tile Selection Section --*/
    /*--Selecting Tiles--*/
	var wmt_selection_state = false;
    $('.wmt_container').on('mousedown', '.wmt_tile', function (e) {//start selecting
		if (wmt_selection_state == true) return;
		$('.wmt_selectedTile').removeClass('wmt_endTile wmt_startTile wmt_selectedTile');//fresh slate
		wmt_selection_state = true;
		$(this).addClass('wmt_startTile wmt_selectedTile')
		e.stopPropagation();
		return false;
	}).on('mouseover', '.wmt_tile', function () {//selection process	
		if (wmt_selection_state == true) {
			$('.wmt_selectedTile ').removeClass('wmt_endTile');		
			$(this).addClass('wmt_selectedTile wmt_endTile');
			wmt_make_selection();
		}
	}).on('mouseup', '.wmt_tile', function () {//stop selecting
		wmt_selection_state = false;
		$('.wmt_selectedTile').removeClass('wmt_endTile wmt_startTile');//fresh slate
	});

   function wmt_make_selection (start, end, type) {
		if (type === undefined ) type = 'wmt_selectedTile';
		$('.wmt_tile').removeClass('wmt_selectedTile');
        var f = $('.wmt_startTile'), l = $('.wmt_endTile');
		if (start !== undefined && end !== undefined) {
			var f = start, l = end;
		}
		var  fr = parseInt(f.attr('data-wmt-row')), 
				lr = parseInt(l.attr('data-wmt-row')), 
				fc = parseInt(f.attr('data-wmt-col')), 
				lc = parseInt(l.attr('data-wmt-col'));
		
		if (fr > lr) {
			var x = lr;
			lr = fr;
			fr = x;
		}
		
		if (fc > lc) {
			var x = lc;
			lc = fc;
			fc = x;
		}		

		for (i = fr; i<=lr; i++) {
			for (o = fc; o<=lc; o++) {
				$('.wmt_tile[data-wmt-col="'+o+'"][data-wmt-row="'+i+'"]').addClass(type);
			}
		}
	}

	/*--Tool Tip--*/
	//Create
	function wmt_tileTool (ops) {
		var h = '<div class="wmt_tileTool"></div>';	//Create
		$('.wmt_container').append(h);
		wmt_tileToolOps(ops); //Feed ops
	}
	
	//Position
	function wmt_tileToolPos(arr) {
		var t = $('.wmt_tile'),
				w = parseInt(t.outerWidth(true)),
				h = parseInt(t.outerHeight(true));
		$('.wmt_tileTool').css({'left': arr[0] +'px','top': arr[1]+'px' });
	};
	
	//Feed Ops
	function wmt_tileToolOps (ops) {
		if(!$('.wmt_tileTool').length) {
			wmt_tileTool (ops);
		};
		if(!$.isArray(ops) || !ops.length) { //check if toolTip exists
			//console.log('combine tool tip does not exist, or no options were given, or options were not in array');
			return false;
		}
		
		if (ops.length === 1) $('.wmt_tileTool').addClass('wmt_tileTool_single_option');
		else $('.wmt_tileTool').removeClass('wmt_tileTool_single_option');
		
		var h='';
		for (var c=0; c<ops.length;c++) {//create html ops from argument array
			var name = ops[c].replace(/\W/g, '')//no gaps in class name
			h+= '<span class="wmt_tileToolOp wmt_tileTool'+name+'">'+ops[c]+'</span>';
		}
		$('.wmt_tileTool').html(h);
	}
	
	//Feed Data
	function wmt_tileToolData(arr) {
		if (!$('.wmt_tileTool').length) {
			return false;
		}
		$('.wmt_tileTool').attr({'data-wmt-selW': arr[0], 'data-wmt-selH': arr[1], 'data-wmt-selX': arr[2], 'data-wmt-selY': arr[3]});
	}
	
	//Show/Hide
	function wmt_tileToolDisplay(d) {//remove/add 'hide' class
		var  t = $('.wmt_tileTool'),
				c = 'wmt_hide_tileTool';
		if  (typeof wmt_canvas === "undefined") return t.addClass(c);
		d ? t.removeClass(c) : t.addClass(c);
	}

	$('.wmt_container').on('mouseenter', '.wmt_tile', function () {
		if (!$(this).hasClass('wmt_combined') && !$(this).hasClass('wmt_selectedTile')) wmt_tileToolDisplay(false);
	})

	//Initiate
	function wmt_combinePermission (ops) {
		//Check ops are array
		if (!$.isArray(ops)) return;
		
		if(ops.length === 1) $('.wmt_tileTool').addClass('wmt_tileTool_single_option');
		else $('.wmt_tileTool').removeClass('wmt_tileTool_single_option');
		
		//Create
		if (!$('.wmt_tileTool').length) wmt_tileTool(ops);
		else wmt_tileToolOps(ops);//Only change ops if already there
		
		//Prep data
		var t=$('.wmt_selectedTile').eq(0),
		c = t.attr('data-wmt-col'), //Row & col pos 
		r = t.attr('data-wmt-row'),		
		w = t.outerWidth(true), //Tile dimensions
		h = t.outerHeight(true),
		tc = $('.wmt_selectedTile[data-wmt-col="'+c+'"]').length, //Row & col length
		tr = $('.wmt_selectedTile[data-wmt-row="'+r+'"]').length, 
		rw = tr*w - (w - t.width()), //Selection width & height
		ch = tc*h - (h - t.height()),
		x = (c-1)*w + ((w - t.width())/2),
		y = (r-1)*h + ((h - t.height())/2);

		//Position
		if (isNaN(x) || isNaN(y))  return;
		wmt_tileToolPos([x,y]);

		//Ops Data
		wmt_tileToolData([rw,ch,x,y]);

		//Show
		wmt_tileToolDisplay(true);
	}
	
	//Combine Button
	$('.wmt_container').on('click', '.wmt_tileToolCREATE', function () {
		$('.wmt_currentCombo').removeClass('wmt_currentCombo');//last one is no longer the current combo	
		var  t= $(this).parent(),
				a = $('.next_combo_id').val(), //Number of already present combos
				w= t.attr('data-wmt-selw'),
				h= t.attr('data-wmt-selh'),
				l= t.attr('data-wmt-selx'),
				u= t.attr('data-wmt-sely'),
				h='<div class="wmt_combined wmt_currentCombo wmt_triggerable" data-wmt-tc=".wmt_set_title" data-wmt-combo="'+a+'" style="width:'+w+'px; height:'+h+'px; top:'+u+'px; left:'+l+'px; margin:0; padding:0"></div>';
		$('.next_combo_id').val(parseInt(a)+1);
		$('.wmt_tile.wmt_selectedTile').addClass('wmt_lockedTile wmt_lockedSet'+a); //Lock this combo's blueprint tiles to it
		$('.wmt_container').append(h);
		wmt_update_set_pos_data($('.wmt_combined').filter(':last'));
		wmt_tileToolOps(['CUSTOMIZE','MOVE/RESIZE','MOVE TILES','BREAK', 'DUPLICATE','IMPORT']); //Change the tool ops
		$('.wmt_tile.wmt_selectedTile').removeClass('wmt_selectedTile');
		var i = $('.wmt_next_set_id');//progressing index
		i.val(i.val()+1);
	})
	
	//Duplicate Button
	$('.wmt_container').on('click', '.wmt_tileToolDUPLICATE', function () {
		$('.wmt_duplicate').removeClass('wmt_duplicate');
		var  id = $('.next_combo_id').val(),
				x = $('.wmt_currentCombo').attr('data-wmt-combo'),
				c = $('.wmt_currentCombo').clone(false, false),
				d = $('.wmt_currentCombo').data('wmt');
		$('.wmt_currentCombo').removeClass('wmt_custCombo wmt_currentCombo');
		c.addClass('wmt_duplicate').attr('data-wmt-combo',id).appendTo('.wmt_container');//the duplicate
		
		var n = {'set':{'combo-index':id}};
		var o = {};
		$.extend(true,o,d,n);
		$('.wmt_duplicate').data('wmt',o);
		if ($('.wmt_duplicate').children('.wmt_slider').length) $('.wmt_duplicate').wmt_unslider();
		$('.wmt_lockedSet'+x).addClass('wmt_lockedSet'+id);
		$('.next_combo_id').val(parseInt(id)+1);
	});
	
	//Import Button
	$('body').on('click', '.wmt_tileToolIMPORT', function () {
		$('.wmt_tileToolCUSTOMIZE').click();
		$.magnificPopup.open({ 
			items: {
			  src: $('<div class="wmt_set_import_lightbox"><h2>Paste export code for current \'set\' here:</h2> <textarea></textarea><button class="wmt_set_import_lightbox_button">Submit</button></div>')
			},
			type: 'inline' // this is default type
		})
	});

	$('body').on('click', 'button.wmt_set_import_lightbox_button', function () {
		var v = $(this).siblings('textarea').val();
		$('.wmt_import_set').prev().val(v);
		$('.wmt_main_loader').addClass('wmt_loading');
		if ($('.wmt_import_set_overwrite_strength')[0].checked !== true) $('.wmt_import_set_overwrite_strength')[0].checked = true;
		if ($('.wmt_import_set_overwrite_content')[0].checked !== true) $('.wmt_import_set_overwrite_content')[0].checked = true;
		setTimeout(function () {
			wmt_unroll_set_data("for_import");
			$('.wmt_TsetApplyAll').first().click();			
			$.magnificPopup.close();
		}, 200);
	})

	//Break Button
	$('.wmt_container').on('click', '.wmt_tileToolBREAK', function () {
		var  t = $('.wmt_currentCombo'),
				a = t.attr('data-wmt-combo');
		$('.wmt_tile.wmt_lockedSet'+a).removeClass('wmt_lockedTile wmt_lockedSet'+a);
		$('.wmt_currentCombo').remove();
		wmt_update_responsive_pos_option (); //removing a set affects responsive order
		wmt_full_width_bg();
		wmt_tileToolDisplay(false);
	})

	//Customize Button
	$('.wmt_container').on('click', '.wmt_tileToolCUSTOMIZE', function () {
		if (wmt_scroll_permission) {
			$('html,body').animate({
				scrollTop: $(".wmt_TsetApplyAll").offset().top -100
			}, 200);
		} else {
			wmt_scroll_permission = true;
		}
		if (!$('.wmt_currentCombo').hasClass('wmt_custCombo')) { //don't want to re-init process and wipe current settings!
			//console.log('tooCust has been clicked');		
			$('.wmt_currentCombo').addClass('wmt_custCombo').siblings().removeClass('wmt_custCombo');
			var s = $('.wmt_combined').index($('.wmt_custCombo'));
			$('.wmt_main_loader').addClass('wmt_loading');
			setTimeout(function () {
				wmt_smart_unroll_set_data();
			}, 200);
		}
	});

	//Move/Resize Button

	$('.wmt_container').on('click', '.wmt_tileToolMOVERESIZE', function () {

		wmt_hideMoveResize();

		wmt_showMoveResize();

	});

	

	//Hide Move/Resize Div

	function wmt_hideMoveResize () {

		wmt_killMove();		

		wmt_killResize();

		$('.wmt_moveresize').remove();

		$('.wmt_reDimTile').removeClass('wmt_reDimTile');

		$('.wmt_currently_redimension').removeClass('wmt_currently_redimension');

		$('.wmt_tileTool').removeClass('wmt_hide_tileTool');//reveal tile tool

	};

	

	//Show Move/Resize Div	

	function wmt_showMoveResize () {

		$('.wmt_container').append('<div class="wmt_moveresize"><div class="wmt_keepChanges fa fa-check"></div><div class="wmt_discardChanges  fa fa-times"></div><div class="wmt_move"></div><div class="wmt_resize fa fa-expand  fa-rotate-90"></div></div></div>');

		var t = $('.wmt_currentCombo');

		$('.wmt_moveresize').css({'top':  t.css('top'), 

												'left':t.css('left'), 

												'height':t.css('height'),

												'width':t.css('width'),

											});

		$('.wmt_currently_redimension').removeClass('wmt_currently_redimension');

		t.addClass('wmt_currently_redimension');

		$('.wmt_container').on('mousedown', '.wmt_move', wmt_initMove);

		$('.wmt_container').on('mousedown', '.wmt_resize', wmt_initResize);

		wmt_dimensionFeedback();//need it! first run

		$('.wmt_tileTool').addClass('wmt_hide_tileTool');// hide tile tool

	};

	

	/*---Move Specific---*/

	//Init Move

	function wmt_initMove (e) {//binds to mouse down

		//mouse position

		var t = $('.wmt_moveresize');

		wmt_mouse.diffx = Math.ceil(e.pageX - parseInt(t.css('left')));

		wmt_mouse.diffy = Math.ceil(e.pageY - parseInt(t.css('top')));

		wmt_mouse.maxx = $('.wmt_container').width() - $('.wmt_moveresize').outerWidth();

		wmt_mouse.maxy = $('.wmt_container').height() - $('.wmt_moveresize').outerHeight();



		$('.wmt_container').on('mousemove', wmt_beginMove);

		$('.wmt_container').on('mouseup', wmt_endMove);

	};

	

	var wmt_mouse={};



	function wmt_beginMove (e) {//binds to mouse move

		var t = $('.wmt_moveresize'),

		x = e.pageX - wmt_mouse.diffx,

		y = e.pageY - wmt_mouse.diffy;

		if (y>wmt_mouse.maxy) y = wmt_mouse.maxy;

		if (y<0) y = 0;

		

		if (x>wmt_mouse.maxx) x = wmt_mouse.maxx;		

		if (x<0) x = 0;

		

		t.css({'top': y+'px', 'left':x+'px'});

		

		wmt_dimensionFeedback();				

	}



	function wmt_endMove () {//binds to mouse up

		$('.wmt_container').off('mousemove', wmt_beginMove);

		$('.wmt_container').off('mouseup', wmt_endMove);

		wmt_dimensionFeedback();

	}

	

	function wmt_killMove() {

		$('.wmt_container').off('mousedown', '.wmt_move', wmt_initMove)

										.off('mousedown', '.wmt_move', wmt_beginMove)

										.off('mousedown', '.wmt_move', wmt_endMove);

	}

	

	/*---Resize Specific---*/

	//Init Resize	

	function wmt_initResize (e) {

		e.stopPropagation();

		//mouse position

		wmt_mouse.origx = e.pageX;

		wmt_mouse.origy = e.pageY;

		//dimensions

		var t = $('.wmt_moveresize');

		wmt_mouse.origw = t.width();

		wmt_mouse.origh = t.height();

		wmt_mouse.maxw = $('.wmt_container').width() - parseInt(t.css('left'));

		wmt_mouse.maxh = $('.wmt_container').height() - parseInt(t.css('top'));

		//bindings

		$('.wmt_container').on('mousemove', wmt_beginResize)

										.on('mouseup', wmt_endResize);

	};

	

	function wmt_beginResize(e) {
		var t = $('.wmt_moveresize'),
		w = e.pageX - wmt_mouse.origx + wmt_mouse.origw,
		h = e.pageY - wmt_mouse.origy + wmt_mouse.origh;
		
		if (w<40) w= 40;
		if (w>wmt_mouse.maxw) w=wmt_mouse.maxw;
		if (h<40) h= 40;		
		if (h>wmt_mouse.maxh) h=wmt_mouse.maxh;

		t.css({'width': w+'px', 'height':h+'px'});

		wmt_dimensionFeedback();
	};
	
	function wmt_endResize () {//binds to mouse up
		$('.wmt_container').off('mousemove', wmt_beginResize)
										.off('mouseup', wmt_endResize);
	}
	
	function wmt_killResize() {
		$('.wmt_container').off('mousedown', '.wmt_resize', wmt_initResize)
										.off('mousedown', '.wmt_resize', wmt_beginResize)
										.off('mousedown', '.wmt_resize', wmt_endResize);			
	}

	//Dimension Feedback - coloring the tiles behind the transparent blue 'move/redimension' box
	function wmt_dimensionFeedback () {

		var  t = $('.wmt_tile').removeClass('wmt_reDimTile wmt_selectedTile wmt_startTile wmt_endTile'),
				tw = t.outerWidth(true),
				th = t.outerHeight(true),

				//placeholder dimensions
				m = $('.wmt_moveresize'),
				ml = parseInt(m.css('left')) ,
				mt = parseInt(m.css('top')),
				mw = m.width(),
				mh = m.height();

		if (ml<1) ml=1;
		if (mt<1) mt=1;

		var  sc = Math.ceil((ml/tw)),
				sr = Math.ceil((mt/th));

		//If over 50% of a tile is covered then include it (also if it is 'just' covered)
		if (ml%tw > tw/2 || ml%tw === 0) sc++;
		if (mt%th > th/2 || mt%th === 0) sr++;

//		console.log('sr :'+sr+' sc :'+sc);

		var  start = $('.wmt_tile[data-wmt-row="'+sr+'"][ data-wmt-col="'+sc+'"]'),

				sl = start.offset().left - $('.wmt_container').offset().left,
				st = start.offset().top - $('.wmt_container').offset().top,

				ec = ((sl+mw)%tw > tw/2) ? Math.ceil((sl+mw)/tw) : Math.floor((sl+mw)/tw) ,
				er = ((st+mh)%th > th/2) ? Math.ceil((st+mh)/th) :  Math.floor((st+mh)/th),

				end = $('.wmt_tile[data-wmt-row="'+er+'"][ data-wmt-col="'+ec+'"]');

//		if ( start.length === 0 || end.length === 0 ) console.log('there were no start / end tiles');

		wmt_make_selection (start, end, 'wmt_reDimTile');
	}
	
	//Place the tile combo at new position, with new size
	function wmt_redimension () {
		var t=$('.wmt_reDimTile').eq(0),//start with first selected blueprint
		c = t.attr('data-wmt-col'), //Row col positions of that tile and
		r = t.attr('data-wmt-row'), //...col position
		w = t.outerWidth(true), //Tile width
		h = t.outerHeight(true), //...height
		tc = $('.wmt_reDimTile[data-wmt-col="'+c+'"]').length, //num of tiles in a col
		tr = $('.wmt_reDimTile[data-wmt-row="'+r+'"]').length, //...in a row
		rw = tr*w - (w-t.width()), //Width of selection area, outside facing borders of first and last tile excluded
		ch = tc*h - (h-t.height()), //...height
		left = (c-1)*w + ((w-t.width())/2), //Distance from left, sum of widths of preceding tiles, plus left border of first selected tile
		top = (r-1)*h+ ((h-t.height())/2), //...from top, plus top border of first selected tile
		cc = $('.wmt_currently_redimension'),
		n = 'wmt_lockedSet'+cc.attr('data-wmt-combo'); //Locking the tiles for the set currently being re-dimensioned
		//apply changes to the set that is to be re-dimensioned
		cc.css({'width':rw+'px', 'height':ch+'px', 'top':top+'px', 'left':left+'px'});
//		console.log('width '+rw+'px '+' height'+ch+'px '+' top'+top+'px '+' left'+left+'px');
		//Relocate the classes onto the new tiles
		$('.wmt_tile.'+n).removeClass(n+' wmt_lockedTile wmt_startTile wmt_endTile');
		$('.wmt_reDimTile').addClass(n+' wmt_lockedTile').removeClass('wmt_reDimTile');// Set is no longer marked as being re-dimensioned

		//Make record of first and last tile in its data
		var t = $('.wmt_currently_redimension');
		var setArr;
		t.data('wmt') ? setArr= t.data('wmt') : setArr= {};
		if (!setArr['set']) setArr['set'] = {};		
		var si = $('.wmt_combined').index(t);
		wmt_update_set_pos_data(t);
		//Init set (fit, slide, lightbox)		
		wmt_init_set (t);
		wmt_hideMoveResize();
	}

	//After user moves/resizes, they need to take a call whether to keep or discard the changes
	$('.wmt_container').on('click', '.wmt_keepChanges', wmt_redimension);
	$('.wmt_container').on('click', '.wmt_discardChanges', wmt_hideMoveResize);	

	//Show Tool Tip Buttons
	$('.wmt_container').on('mouseenter', '.wmt_combined', function () {
//		console.log($(this).data('wmt'));
		wmt_tileToolOps(['CUSTOMIZE','MOVE/RESIZE','MOVE TILES','BREAK', 'DUPLICATE','IMPORT']);
		var t = $(this),
		x = parseInt(t.css('left')),
		y = parseInt(t.css('top')) + 1;
		
		$('.wmt_currentCombo').removeClass('wmt_currentCombo');
		t.addClass('wmt_currentCombo');
		wmt_tileToolPos([x,y]);
		wmt_tileToolDisplay(true);
	});

	$('.wmt_container').on('mouseenter', '.wmt_selectedTile', function () {
		wmt_tileToolDisplay(false);
		wmt_combinePermission(['CREATE']);//will also show tiletool
	})
	
	$('.wmt_container').on('mouseleave', function () {
		wmt_tileToolDisplay(false);
	})
	

/*-- Tile Customization Section --*/

	//title update
    $('body').on('change', '.wmt_content_updater', wmt_content_update_handler);
	
	//image update
	$('body').on('change', '.wmt_TsetImage input, .wmt_TsetImageHover input', wmt_update_image_feedback);
	
	function wmt_update_image_feedback () {
		var url = $(this).val();
		$(this).parent().css('background-image', 'url('+url+')');
	}

	function wmt_content_update_handler () {
		wmt_content_update ($(this));
	}

	function wmt_content_update (t) {
        var p = t.attr('data-wmt-update-parent'),
				u = t.attr('data-wmt-update-target'),
				l = t.attr('data-wmt-update-limit') || 20,
				v = t.val(),
				x = "";
//		console.log(l);
        if (l) {
            if (v.length > l) x = '...';
            v = v.substring(0, l) + x;
//			console.log(v)
        }
        t.closest(p).find(u).text(v);
//		console.log($(this).closest(p).find(u));
	}
	
	//sortable
	$('.wmt_sortable').sortable({handle: '.wmt_TsetContainerTitle'});


	//Import Set
	$('.wmt_import_set').click(function () {
		$('.wmt_main_loader').addClass('wmt_loading');
		setTimeout(function () {wmt_unroll_set_data("for_import")}, 200);

	})

	

	//Import Tile
	$('body').on('click', '.wmt_import_tile', function () {
		var p = $(this).closest('.wmt_TsetContainer'),
				tile_index = $('.wmt_TsetContainer').index(p);
		wmt_unroll_set_data("for_import", tile_index);
	})

	/*---Smart unroll set data---*/

	function wmt_smart_unroll_set_data (arr) {	
//		console.log('Object received for unroll:');
//		console.log(arr);

		if (!arr) arr = wmt_get_set_data();//fetches data from cust set
		$('.wmt_TsetContainer').not(':first-child').remove()//delete all but first tile
		wmt_clear_settings_panel();
		if (arr) { //Else its a new set, nothing to unroll
			wmt_unroll_set_overall_data(arr);//apply set overall settings			
			wmt_correct_number_of_tiles(arr);
			wmt_attach_tile_panels_data (arr);
		};
		wmt_update_responsive_pos_option();
		$('.wmt_main_loader').removeClass('wmt_loading');
	}

	/*---Unroll set data---*/
	function wmt_unroll_set_data (command, tile_index) {//give tile_index if it's for a specific tile only	
		if (command && command === "for_import") {//case of some form of import - tile or set
			//Import an Entire Set
			if ($('.wmt_import_set').prev().val() && tile_index === undefined) {
				var arr = JSON.parse($('.wmt_import_set').prev().val());
				
				if (!arr['set'] || !arr['tiles']) {//gave us wrong type of import code 
					alert('The import code could not be processed, please ensure: \n1. The code is not damaged \n2. It is for importing a \'set\', not a \'design\' or a \'tile\' \n3. You are running the latest version of iDesign.');
					$('.wmt_main_loader').removeClass('wmt_loading');
					return;
				}

				for (var i in arr['tiles']) {
					if (arr['tiles'].hasOwnProperty(i)) {
						if ((arr['tiles'][i]) === undefined || i ==="style") delete arr['tiles'][i];
					}
				}

				if (!$('.wmt_import_set_overwrite_strength')[0].checked) {//adjust number of tiles in imported set
					if (!$('.wmt_custCombo').length) return;
					arr['tiles'] = wmt_resize_object (arr['tiles'], $('.wmt_TsetContainer').length);
				}



				if (!$('.wmt_import_set_overwrite_content')[0].checked) {//adjust content in imported set
					var total = 0;
					for (var i in arr['tiles']) {
						if (arr['tiles'].hasOwnProperty(i) && arr['tiles'][i] !== undefined && i !=="style") total++;
					}

					//First we extend previous set to match new set's length, then we replace content of new set with previous set.
					var current = wmt_roll_set('read');//assumes set is already unrolled, which it must be. If they are coming from lightbox import, overwrites will be force checked
					if ($('.wmt_import_set_overwrite_strength')[0].checked) current['tiles'] = wmt_resize_object (current['tiles'], total);//else number of import set tiles is already adjusted to current set tiles

					/*Certain overall original settings need to be kept if content is not to be overwritten*/
					//Content Type
					if (current['set']['content-generation']) arr['set']['content-generation'] = current['set']['content-generation'];
					if (current['set']['content-type']) arr['set']['content-type'] = current['set']['content-type'];

					//Title
					if (current['set']['enable-title']) arr['set']['enable-title'] = current['set']['enable-title'];
					else if (arr['set']['enable-title']) delete arr['set']['enable-title'];

					if (current['set']['title'] && !arr['set']['title']) arr['set']['title'] = current['set']['title'];
					if (current['set']['title'] && arr['set']['title']['style']['content']) arr['set']['title']['style']['content'] = current['set']['title']['style']['content'];
					else if (!current['set']['title'] && arr['set']['title']) delete arr['set']['title'];

					//Filters
					if (current['set']['enable-filters']) arr['set']['enable-filters'] = current['set']['enable-filters'];
					else if (arr['set']['enable-filters']) delete arr['set']['enable-filters'];					
					if (current['set']['filters'] && !arr['set']['filters']) arr['set']['filters'] = current['set']['filters'];
					else if (!current['set']['filters'] && arr['set']['filters']) delete arr['set']['filters'];

					var bob = $.extend(true, {}, arr);//currently doesn't work without {}

					for (var key in current['tiles']) {
						if (current['tiles'].hasOwnProperty(key) && key !=="style" && current['tiles'][key] !== undefined) {
							for (var key2 in current['tiles'][key]) {
								if (current['tiles'][key].hasOwnProperty(key2)) {
									if (key2 === "link") {//needs woo treatment
										var _class = bob['tiles'][key][key2]['class'] ? bob['tiles'][key][key2]['class'] : "",
												data = bob['tiles'][key][key2]['data'] ? bob['tiles'][key][key2]['data'] : "",
												style = bob['tiles'][key][key2]['style'] ? bob['tiles'][key][key2]['style'] : "",
												style_hover = bob['tiles'][key][key2]['style-hover'] ?  bob['tiles'][key][key2]['style-hover'] : "",
												content = current['tiles'][key][key2]['content'] ?  current['tiles'][key][key2]['content'] : "",
												x = 0;

										delete bob['tiles'][key][key2]['class'];
										delete bob['tiles'][key][key2]['data'];
										delete bob['tiles'][key][key2]['style'];
										delete bob['tiles'][key][key2]['style-hover'];
										delete bob['tiles'][key][key2]['content'];
										
										delete current['tiles'][key][key2]['class'];
										delete current['tiles'][key][key2]['data'];
										delete current['tiles'][key][key2]['style'];
										delete current['tiles'][key][key2]['style-hover'];
										delete current['tiles'][key][key2]['content'];

										for (var i in current['tiles'][key][key2]) {
											if (current['tiles'][key][key2].hasOwnProperty(i)) x++;
											console.log('key was:'+i);
										};

										//console.log('total link panels in original tile: '+x);
										bob['tiles'][key][key2] = wmt_resize_object(bob['tiles'][key][key2], x);//extend the links object in pattern

										for (var key3 in bob['tiles'][key][key2]) {//replacing urls
											if (!current['tiles'][key][key2].hasOwnProperty(key3) || !bob['tiles'][key][key2][key3]['style']) continue;
											bob['tiles'][key][key2][key3]['style']['url'] = current['tiles'][key][key2][key3]['style']['url'];
										}
										
										bob['tiles'][key][key2]['class'] = _class;
										bob['tiles'][key][key2]['data'] = data;
										bob['tiles'][key][key2]['style'] = style;
										bob['tiles'][key][key2]['style-hover'] = style_hover;
										bob['tiles'][key][key2]['content'] = content;
									}

									if (bob['tiles'][key][key2]['content'] && key2 !=="link") bob['tiles'][key][key2]['content'] = ""; //clear it out in case it will be missed. Rather have it blank than wrong content.

									if (current['tiles'][key][key2]['content'] && key2 !=="link") bob['tiles'][key][key2]['content'] = current['tiles'][key][key2]['content'];
									if (key2 === "lightbox" && current['tiles'][key][key2]['content']) {
										bob['tiles'][key][key2]['content'] = current['tiles'][key][key2]['content'];
									}
								}
							}
						}
					}
					arr = $.extend(true, {}, bob);
				}
				wmt_smart_unroll_set_data(arr); //Send for unroll
			}
			
			//Import a Single Tile
			if ( ($('.wmt_TsetContainer').eq(tile_index).find('.wmt_import_tile').prev().val() || $('.wmt_TsetContainer').eq(tile_index).data('wmt')) &&  tile_index !== undefined ) { //import only to a single tile

				var  arr = {"tiles": {}},
						import_json = $('.wmt_TsetContainer').eq(tile_index).find('.wmt_import_tile').prev().val();
				if (!import_json || import_json === "") arr["tiles"][tile_index] = $('.wmt_TsetContainer').eq(tile_index).data('wmt');
				else arr["tiles"][tile_index] = JSON.parse(import_json); //grab import code from the tile panel
				if (import_json && !$('.wmt_TsetContainer').eq(tile_index).find('.wmt_import_tile').next('p').find('.wmt_import_tile_overwrite_content')[0].checked) { //do not overwrite content
					wmt_revert_inputs_to_default($('.wmt_TsetContainer').eq(tile_index), '.wmt_TsetContent', '[data-wmt-otherop="relative-width"], [data-wmt-otherop="relative-height"]');//clear the tile panel, preserving content and dimensions
					//console.log('Overwriting tile content: ');
//					console.log('Tile index is: ');
//					console.log(arr["tiles"][tile_index]);
					for (var key in arr["tiles"][tile_index]) {
						if (arr["tiles"][tile_index].hasOwnProperty(key)) {
							delete arr["tiles"][tile_index][key]['content'];
							if (key === 'overall') {
								delete arr["tiles"][tile_index][key]['style']['relative-width'];
								delete arr["tiles"][tile_index][key]['style']['relative-height'];
							}
							if (key === 'link') {
								//extend 'link' element as necessary
								var l = $('.wmt_TsetContainer').eq(tile_index).find('.wmt_single_link_settings').length,
										x = arr["tiles"][tile_index][key],
										//overall ops need to be removed before resizing object
										c = arr["tiles"][tile_index][key]['class'],
										s = arr["tiles"][tile_index][key]['style'];
								delete x['class'];
								x = wmt_resize_object(x, l);
								for (var key2 in x) {
									if (x.hasOwnProperty(key2)) {
										delete x[key2]['url'];
										delete x[key2]['text'];
									}
								}
								arr["tiles"][tile_index][key] = x;
								if (c) arr["tiles"][tile_index][key]['class'] = c;
								if (s) arr["tiles"][tile_index][key]['style'] = s;
							}
						}
					}
				} else if (import_json)  {//do nothing while loading tile
					wmt_revert_inputs_to_default($('.wmt_TsetContainer').eq(tile_index) );//clear the tile panel entirely
					//console.log('reverting inputs to default');					
				}
				wmt_unroll_tile_data (arr, tile_index);
				$('.wmt_main_loader').removeClass('wmt_loading');
				return;
			}
		}
	}

	function wmt_unroll_tile_data(arr, tile_index) {
		wmt_unroll_type_data (arr, tile_index);
		for (var tile_element_name in arr['tiles'][tile_index]) {
			if (tile_element_name !== "type" && arr['tiles'][tile_index].hasOwnProperty(tile_element_name)) {
				//Following cover all sub keys within tile elements
				wmt_unroll_style_data (arr, tile_index, tile_element_name);//style
				wmt_unroll_content_data (arr, tile_index, tile_element_name);//content

				if (tile_element_name === "description")  {
					var  x = $('.wmt_TsetContainer').eq(tile_index).find('input[data-wmt-content="description"]'),
							val = arr['tiles'][tile_index][tile_element_name]['content'];
					x.val(val);
					x.parent().find('.nicEdit-main').html(val);
				};
			};

			if (tile_element_name === "link") { //Case of LINK
				var o = arr['tiles'][tile_index]['link'],
						target = $('.wmt_TsetContainer').eq(tile_index);
				wmt_unroll_content_data (arr, tile_index, tile_element_name);//feed content to input
				target.find('.wmt_single_link_settings').not('.wmt_primary_link_settings, .wmt_woo_link_settings').remove();//woo already removed if it had to be
				for (var curr in o) {
					if (curr !== 'class' && curr !== 'style' && curr !== 'style-hover' && curr !== 'content' && o.hasOwnProperty(curr)) {//Exlcude props of overall link section, head to sub section of links
						if(!o[curr]['style']) continue;

						//if lightbox or mainlink then unload on specific panels only.
						var urls = ["wmt_lightbox", "wmt_main_link", "woo_page", "woo_cart"];
						var found_panel = false;
						for (var i = 0; i < urls.length; i++) {
							if (o[curr]['style']['url'] === urls[i]) {
								var panel = target.find('[data-wmt-otherop="url"][value="'+urls[i]+'"]').closest('.wmt_single_link_settings');
								found_panel = true;								
							}
						}
						if (!found_panel) {//New panel needs to be created
							var main = target.find('.wmt_main_link_settings');
							wmt_copy_link_panel(main, true);
							var panel = target.find('.wmt_single_link_settings').not('.wmt_primary_link_settings').first();
						}

						for (var curr2 in o[curr]) { // curr2 = style || style-hover etc
							if (o[curr].hasOwnProperty(curr2)) {
								var data = "";//default when curr2 === "style"
								if (curr2 === "style-hover") {
									data = '[data-wmt-otherop-type="hover"]';
								} else if (curr2 ==="class") {
									data = '[data-wmt-otherop-type="class"]';
								} else if (curr2 ==="data") {
									data = '[data-wmt-otherop-type="data"]';
								}
								for (var curr3 in o[curr][curr2]) {// curr3 = url, background-color etc
									panel.find('[data-wmt-otherop="'+curr3+'"]'+data).val(o[curr][curr2][curr3]);
								}
							}
						}
					}
				}
			}
		}
	}
	
	function wmt_get_set_data () {//retrieve data object for the set that is supposed to be customized
		var arr = $('.wmt_custCombo').data('wmt');
		return arr;
	}

	function wmt_unroll_set_overall_data (arr) {
		for (var key in arr['set']) { //iterate over set's overall settings
			if (arr['set'].hasOwnProperty(key)) {
				if (key=== "style") continue;
				var val = arr['set'][key],
				input = $('.wmt_TsetOverallContainer').find('[data-wmt-overall="'+key+'"]');
				wmt_unroll_basic (input, key, val);
				if (key === "title") {//title properties
					wmt_unroll_style_data_inner(arr['set'][key]['style'], 'SetTitle', 'SetTitle');
					wmt_unroll_style_data_inner(arr['set'][key]['style-hover'], 'SetTitle', 'SetTitle', 'hover');
				}
				if (key === "filters") {//title properties
					wmt_unroll_style_data_inner(arr['set'][key]['style'], 'SetFilters', 'SetFilters');
					wmt_unroll_style_data_inner(arr['set'][key]['style-hover'], 'SetFilters', 'SetFilters', 'hover');
				}
				if (key === "extended-background") {//extended bg properties
					wmt_unroll_style_data_inner(arr['set'][key]['style'], 'ExtendedBg', 'ExtendedBg');
					wmt_unroll_style_data_inner(arr['set'][key]['style-hover'], 'ExtendedBg', 'ExtendedBg', 'hover');
				}
				if (key==="slider") {//slider properties
					var a = arr['set'][key];
					for (var key2 in a) {
						if (a.hasOwnProperty(key2)) {
							var val = a[key2],
									input =  $('.wmt_slider_enabled').find('[data-wmt-otherop="'+key2+'"]');
							wmt_unroll_basic (input, key2, val);
						}
					}
				}
				if (key==="paj") {//slider properties
					var a = arr['set'][key];
					for (var key2 in a) {
						if (a.hasOwnProperty(key2)) {
							var val = a[key2],
									input =  $('.wmt_paj_enabled').find('[data-wmt-otherop="'+key2+'"]');
							wmt_unroll_basic (input, key2, val);
						}
					}
				}				
			}
			if (key==="media-query-rules") {//additional media query rules
				var object = arr['set'][key];
				wmt_component.feed($('.wmt_tile_dimensions_additional_rules .wmt_component_container'), object)
			}
		}
	}

	function wmt_unroll_basic (input, key, val, c) {
		if (val instanceof Array) { //case of multiple checkbox selection
			for (var i = 0; i<val.length; i++) {
				wmt_unroll_basic (input, key, val[i], true);
			}
		} else {
			//Reset radio and check boxes to default
			if (!c && input[0]) input[0].checked = input[0].defaultChecked;
			//Check correct radio and check boxes
			input.filter('[value="'+encodeURIComponent(val)+'"]').each(function () {
				if (this.checked) return;
				$(this).click();//Click for trigger effect
			});
			//Feed select and text input fields
			input.not('input[type="radio"], input[type="checkbox"]').val(val);	
		}
	}

	

	//Creates correct number of tile customization panels 
	function wmt_correct_number_of_tiles(arr) {
		if (!arr) return; //new empty set
		//how many tile panels needed?
		var needed = 0;
		for (var key in arr['tiles']) {
			if (arr['tiles'].hasOwnProperty(key) && key !== 'style') {
				needed++;
			}
		}
		wmt_clone_tile_panel(needed - 1);
	}

	function wmt_attach_tile_panels_data (arr) {
		for (var key in arr['tiles']) {
			if (arr['tiles'].hasOwnProperty(key) && key !== 'style' && key !== 'style-hover' && key !== 'class' && key !== 'data') {
				$('.wmt_TsetContainer').eq(key).data('wmt', arr['tiles'][key]);
				//correct title label
				var title = arr['tiles'][key]['title']['content'];
				if (!title) title = "";
				if (title.length > 20) {
					title = title.substring(0, 20) + '...';
				};
				$('.wmt_TsetContainer').eq(key).find('.wmt_TsetContainerTitle>span').text(title);
			}
		}
	}
	
	function wmt_clear_settings_panel () {
		$('.wmt_TsetContainer').each(function () {
			$(this).data('wmt','').find('.wmt_TsetContainerTitle>span').text("");
			$(this).removeClass('wmt_needs_init wmt_unroll_data_here');
			$(this).find('.wmt_single_link_settings').not('.wmt_primary_link_settings').remove();
			console.log('.nicEdit-main');
			console.log($(this).find('.nicEdit-main').html());
			$(this).find('.nicEdit-main').empty();
			$(this).find('.nicEdit-main').siblings('input').val("");
		})
		$('.wmt_TsetOverallContainer').find('.wmt_single_link_settings').not('.wmt_primary_link_settings').remove();
		wmt_component.initiate_components($('.wmt_component_container'), 1);
		wmt_revert_inputs_to_default($('.wmt_TsetOverallContainer'));
	}
	
	/*---elem data---*/
	function wmt_unroll_type_data (arr, tile_index) {
		//get to the tile panel for context	
		var a = arr['tiles'][tile_index]['type'],
		t = $('.wmt_TsetContainer').eq(tile_index);
		for (var key in a) {
			if (a.hasOwnProperty(key)) {		
				var  input = t.find('input[data-wmt-type="'+key+'"]'),
						val = a[key];
				wmt_unroll_basic (input, key, val);
			}
		}
	}
	
	/*---sub elem data---*/

	function wmt_unroll_style_data (arr, tile_index, tile_element_name) {

		var tileIndex, tileElement;

		if (arr['tiles'][tile_index][tile_element_name]['style']) wmt_unroll_style_data_inner (arr['tiles'][tile_index][tile_element_name]['style'], tile_index, tile_element_name);

		if (arr['tiles'][tile_index][tile_element_name]['style-hover']) wmt_unroll_style_data_inner (arr['tiles'][tile_index][tile_element_name]['style-hover'],  tile_index, tile_element_name, 'hover');

		if (arr['tiles'][tile_index][tile_element_name]['data']) wmt_unroll_style_data_inner (arr['tiles'][tile_index][tile_element_name]['data'],  tile_index, tile_element_name, 'data');

		if (arr['tiles'][tile_index][tile_element_name]['class']) wmt_unroll_style_data_inner (arr['tiles'][tile_index][tile_element_name]['class'],  tile_index, tile_element_name, 'class');

		if (tile_element_name === "lightbox") wmt_unroll_style_data_inner (arr['tiles'][tile_index][tile_element_name],  tile_index, tile_element_name, 'style');
	}

	function wmt_unroll_style_data_inner (arr, tileIndex, tileElement, type) {
		if (type === 'hover') {
			type = '[data-wmt-otherop-type="hover"]';
		} else if (type === 'class') {
			type = '[data-wmt-otherop-type="class"]';
		} else if (type === 'data') {
			type = '[data-wmt-otherop-type="data"]';
		} else {
			type = '';
		};

		if (tileIndex === "SetTitle" || tileIndex === "SetFilters" || tileIndex === "ExtendedBg") var set_or_tiles_settings_container = $('.wmt_TsetOverallSettings');//here's an exception for title slider and filters - refer to different parent div when looking for their options
		else var set_or_tiles_settings_container = $('.wmt_TsetContainer').eq(tileIndex);
		for (var key in arr) {
			if (arr.hasOwnProperty(key)) {
				var val = arr[key];
				var input = set_or_tiles_settings_container.find('[data-wmt-other="'+tileElement+'"]').find('[data-wmt-otherop="'+key+'"]'+type);
				wmt_unroll_basic(input, key, val);
			}
		}
	}

	function wmt_unroll_content_data (arr, tile_index, tile_element_name) {
		if (arr['tiles'][tile_index][tile_element_name]['content']) {
			var  input = $('.wmt_TsetContainer').eq(tile_index).find('[data-wmt-content="'+tile_element_name+'"]'),
					val = arr['tiles'][tile_index][tile_element_name]['content'],
					key = 'content';
			wmt_unroll_basic(input, key, val);
			if (tile_element_name === "description") {
				input =  $('.wmt_TsetContainer').eq(tile_index).find('[data-wmt-content="'+tile_element_name+'"]').prev('textarea');
				wmt_unroll_basic(input, key, val);			
			}
		}
	}

	//wmt_trigger elements reveal other elements upon being checked
    $('.wmt_trigger').each(function () {
		var c = $(this).attr('data-wmt-trigger');	
		if (this.checked) {
			$(c).addClass('wmt_dont_close');
		}
		if (!this.checked) {
			$(c).each(function () {
				if (!$(this).hasClass('wmt_dont_close')) $(this).css('display','none');
			})
		}
    });
	$('.wmt_dont_close').removeClass('wmt_dont_close');

    function wmt_trigger() {
        var  t = $(this),
				trig = t.attr('data-wmt-trigger'),
				p = t.closest('.wmt_TsetContainer').length ? t.closest('.wmt_TsetContainer') : $('body');
        if (this.checked && t.is('input:radio')) {//a radio input won't trigger change event when its relative is checked, so this ...
            var n = t.attr('name');
            t.siblings('input[type="radio"][name="'+n+'"]').each(function () {//force the unchecked siblings to slide up their associated divs
				var trig = $(this).attr('data-wmt-trigger');
				if (trig) p.find(trig).stop(true).slideUp();
            })

            t.closest('.wmt_TsetPurpose').find('input[type="radio"][name="'+n+'"]').not(t).each(function () {//force the unchecked siblings to slide up their associated divs
				var trig = $(this).attr('data-wmt-trigger');
				if (trig) t.closest('.wmt_TsetPurpose').find(trig).stop(true).slideUp();
            })
        };
        this.checked ? p.find(trig).stop(true).slideDown( 'fast' ,function () {$(this).css({'height':'auto','display':'block'})}) : p.find(trig).slideUp();
    }

    $('body').on('change', '.wmt_trigger', wmt_trigger);

	//description textarea content feed
    $('body').on('change', 'textarea.wmt_TsetDescription', function () {
        var v = $(this).val();
        $(this).next('input').val(v);
    }).on('change', 'textarea.wmt_TsetDescription+input', function () {
        var v = $(this).val();
        $(this).prev('textarea.wmt_TsetDescription').val(v);
    })

	//Enable/Disable Tile Set Title
	$('body').on('click', '.wmt_enableNext', function () {
		var nxt = $(this).parent().next();
		if ($(this)[0].checked) {
			nxt.slideDown('fast', function () {$(this).css('height', '')});		
		} else {
			nxt.slideUp('fast', function () {$(this).css('height', '')});
		}
	})
	
	//Single Tile Accordion by Settings Category
	$('body').on('click', '.wmt_TsetTitle', function () {
		var s = $(this).siblings('.wmt_TsetInner');
		$(this).closest('.wmt_TsetContainer').find('.wmt_TsetInner').not(s).slideUp();
		s.stop().slideToggle('fast', function () {
			if ($(this).height() !== 0) $(this).height('auto'); 
		});
	});

	$('body').on('click', '.wmt_TsetContainerTitle', function () {
		$(this).siblings().not('.wmt_TsetContainerControl').children('.wmt_TsetInner').slideUp();
	})

	//Clone Tile
	$('.wmt_TsetOverallContainer').on('click', '.wmt_TsetContainerCopy', function () {
		wmt_clone_tile_panel($(this));
	})

	function wmt_clone_tile_panel (t) {
		$('.wmt_TsetOverallContainer').off('click', wmt_hide_iris);//creates issues with radio click otherwise	
		var p;
		if (isNaN(t)) {//command from 'copy' button
			p = t.closest('.wmt_TsetContainer');
			p.find('select').each(function () {
				$(this).attr('data-wmt-value', $(this).val());
			})
			p.find('[data-wmt-content="description"]').val(p.find('.nicEdit-main').html());
			var radio = p.find('input[type="radio"]');
			radio.each(function () {
				if ($(this)[0].checked === true) $(this).attr('data-wmt-checked', "true");
			})
			var c = p.clone(true, false).insertAfter(p).addClass('wmt_needs_init').data('wmt', p.data('wmt'));
			c.find('.wmt_color_picker').each(function () {
				$(this).removeClass('wmt_on');
			})
			//select fields need to retain value
			c.find('select').each(function () {
				$(this).val($(this).attr('data-wmt-value'));
			})
		} else {//command from unroll
			p = $('.wmt_TsetContainer')
			var  c = p[0].outerHTML,
					s = [];
			for (var i=0 ; i < t; i++) {
				s.push(c);
			}
			s = s.join(" ");
			if (s) $(s).insertAfter(p);
			p.siblings().find('.wmt_color_picker').removeClass('wmt_on');
			$('.wmt_TsetContainer').addClass('wmt_needs_init wmt_unroll_data_here');
			wmt_init_iris ();
		}
		//radio buttons need to be renamed each time tile panels are copied
		$('.wmt_TsetContainer').each(function (index) {
			$(this).find('input[type="radio"]').each(function () {
				var _t = $(this),
					   name = _t.attr('name');
				name = name +'_' + index;
				_t.attr('name', name);
				if (isNaN(t) && (_t.prop('checked') || _t.attr('data-wmt-checked'))) _t[0].checked = true;//removes init classes from main tile without nan check
				_t.removeAttr('data-wmt-checked');
			});
			console.log('fixed radio names for one container');
		});
		$('.wmt_TsetInner').hide();
		$('.wmt_TsetOverallContainer').on('click', wmt_hide_iris);//bind hide iris event
	}

	function wmt_init_tile_panel (c) {
		if (!c.hasClass('wmt_needs_init')) return;
		c.removeClass('wmt_needs_init');	
		wmt_init_iris (c);
		//Textarea text needs to be separately fed text from the hidden input field
		wmt_nicEdit_init(c);
		var x = c.find('[data-wmt-content="description"]');
		x.prev().val(x.val()).prev().find('.nicEdit-main').html(x.val());
		
		if (c.hasClass('wmt_unroll_data_here')) {
				wmt_unroll_set_data ("for_import", c.index());				
				c.find('.wmt_TsetImage input').each(function () {//for image sections
					var t = $(this); t.parent().css('background-image', "url('"+t.val()+"')");
				});
				c.removeClass('wmt_unroll_data_here');
		}
	}

	$('body').on('click', '.wmt_TsetContainer.wmt_needs_init', function () {
		wmt_init_tile_panel ($(this));
	})

	//Delete Tile
	$('body').on('click', '.wmt_TsetContainerDelete', function () {
		var p = $(this).closest('.wmt_TsetContainer'),
			   s = p.siblings('.wmt_TsetContainer');
		if (s.length) p.remove();
	})	

	//Tabs within 'Other'
	$('body').on('click', '.wmt_TsetOtherInnerTitle', function () {
		var i = $(this).index(), p = $(this).closest('.wmt_TsetOther').find('.wmt_TsetOtherInner');
		$(this).siblings().removeClass('wmt_selected').end().addClass('wmt_selected');
		p.hide();
		p.eq(i).show();
	});

	//Settings Icon next to content inputs
	$('body').on('click', '.wmt_TsetContent .wmt_TsetMoreSettings', function () {
		var t = $(this),
			   i=t.attr('data-wmt-otherindex'),
			   o=t.closest('.wmt_TsetContent').siblings('.wmt_TsetOther');
		o.find('.wmt_TsetOtherInnerTitle').eq(i).click();			   
		o.find('.wmt_TsetTitle').click();
	})

	//Changing responsive order
	function wmt_change_resp_order () {
		var new_pos = $('select[data-wmt-overall="position"]').val();
		if (!isNaN(new_pos) && new_pos > -1 && new_pos < $('.wmt_combined').length && $('.wmt_combined').length > 1) {
			if (!$('.wmt_combined').eq(new_pos).hasClass('wmt_custCombo')) { //otherwise it's the same set
				var push_down = true; //case of pushing down the current set in dom order
				if (new_pos > $('.wmt_combined').index($('.wmt_custCombo'))) {//push down
					var lower = $('.wmt_custCombo'),//eg: 2 (lower number, not in dom order)
							higher = $('.wmt_combined').eq(new_pos);//eg: 5
				} else {//push up
					var lower = $('.wmt_combined').eq(new_pos),//eg: 5
							higher = $('.wmt_custCombo');//eg: 2
					push_down = false;
				}
				if (push_down) {//going downwards in dom order
					lower.detach().insertAfter(higher);
//					console.log('going to push it down');
				} else {//going upwards in dom order
					higher.detach().insertBefore(lower);
//					console.log('going to push it up');
				}
			}
		} else {
			alert ('There was an issue with responsive order.');
		}
	};

	$('body').on('change', 'select[data-wmt-overall="position"]', function () {
		wmt_change_resp_order();
	});

	$('body').on('click', '.wmt_disabled', function () {
		alert('This button is temporarily disabled until current process completes.');
	});

	

	/*---Gather Set data & Apply this set's settings ---*/

	$('button.wmt_TsetApplyAll').click(function () {

		if ($(this).hasClass('wmt_disabled')) return;

		$('html,body').animate({

			scrollTop: $(".wmt_custCombo").offset().top - 60

		}, 200);

		wmt_roll_set();

	});

	

	/*--Export Set--*/

	$('.wmt_export_set').click(function () {
		wmt_roll_set("for_export");
	})


	//Export Tiles
	$('body').on('click', '.wmt_export_tile', function () {
		var  p = $(this).closest('.wmt_TsetContainer'),
				tile_index = $('.wmt_TsetContainer').index(p);
		wmt_roll_set("for_export", tile_index);
	})
	
	function wmt_roll_set (command, tile_index) {

		if ($('.wmt_custCombo').length === 0) {
			alert('Please select a set to customize first!');
			return;
		};

		var setArr= {};
		setArr['set'] = {};
		setArr['set']['style'] = {};

		if (!command) setArr = wmt_update_set_pos_data( $('.wmt_custCombo') , setArr); //don't update position for export type command
		setArr['tiles'] = {};
		var count = 0;

		setArr['tiles']['style'] = {};
		//set number of tiles by default
		if ( !$('input[data-wmt-overall="cols"]').val()) {
			var  f = wmt_sa.get_figure(),
					l = $('.wmt_TsetContainer').length;
					v = f > l ? l : f;
			$('input[data-wmt-overall="cols"]').val(v);
		}

		//Overall Set settings
		$('[data-wmt-overall]').each(function () {
			var th=$(this);
			//Set val if not a checkbox/radio, ie regular text input or select but with value; or if is one, but also checked
			if (( (th.is(':checkbox') || th.is(':radio')) && th[0].checked) || ( !th.is(':checkbox') && !th.is(':radio') && th.val() !== "" && th.val() !== undefined ) ) {
				var key = th.attr('data-wmt-overall'),
					    v = th.val();
						
				if (setArr['set'][key]) {//val already exists, must be multiple selections among checkboxes
//					console.log(setArr['set'][key]);
					if (setArr['set'][key] instanceof Array) {//already an array
						setArr['set'][key].push(v);
					} else {
						setArr['set'][key] = [setArr['set'][key] , v]
					}
				} else  {
					if (th.attr('data-wmt-location')) {
						if (!setArr['set'][th.attr('data-wmt-location')]) setArr['set'][th.attr('data-wmt-location')] = {};
						setArr['set'][th.attr('data-wmt-location')][key] = v;
					};
					setArr['set'][key] = v;
				}
			}
		})

		//Set title
		if (setArr['set']['enable-title'] &&  setArr['set']['enable-title'] === 'true') {
			setArr['set']['title']={};
			setArr['set']['title']['style']={};
			setArr['set']['title']['style-hover']={};
			$('[data-wmt-setTitle]').each(function () {
				$(this).find('[data-wmt-setTitle]').each(function () {
					var key = $(this).attr('data-wmt-setTitle'),
						   th = $(this);
					//Normal and Hover styles
					if (th.attr('data-wmt-otherOp-type') === "hover") {
						var style="style-hover";
					} else {
						var style="style";
					}
					//Set val if not a checkbox/radio, ie regular text input or select but with value; or if is one, but also checked
					if (( (th.is(':checkbox') || th.is(':radio')) && th[0].checked) || ( !th.is(':checkbox') && !th.is(':radio') && th.val() !== "" && th.val() !== undefined ))  {
						var v = th.val();
						setArr['set']['title'][style][key] = v;
					}
				})
			});
		}
		//Set slider
		if (setArr['set']['type'] &&  setArr['set']['type'] === 'slider') {
			setArr['set']['slider']={};
			$('.wmt_slider_enabled').find('[data-wmt-otherop]').each(function () {
				var th = $(this),
					   key = th.attr('data-wmt-otherop');
				//We will absorb the value if its a checkbox / radio and is checked. Or if its not one of those input types, then it must be a text/select input, in which case if t has some value then we will absorb that
				if (( (th.is(':checkbox') || th.is(':radio')) && th[0].checked) || ( !th.is(':checkbox') && !th.is(':radio') && th.val() !== "" && th.val() !== undefined ) ) {
					var v = th.val();
					setArr['set']['slider'][key] = v;
				}
			})
		}
		//Set paj
		if (setArr['set']['enable-paj'] &&  setArr['set']['enable-paj'] === 'true') {
			setArr['set']['paj']={};
			$('.wmt_paj_enabled').find('[data-wmt-otherop]').each(function () {
				var th = $(this),
					   key = th.attr('data-wmt-otherop');
				if (( (th.is(':checkbox') || th.is(':radio')) && th[0].checked) || ( !th.is(':checkbox') && !th.is(':radio') && th.val() !== "" && th.val() !== undefined ) ) {
					var v = th.val();
					setArr['set']['paj'][key] = v;
				}
			})
		}
		//Set filters
		if (setArr['set']['enable-filters'] &&  setArr['set']['enable-filters'] === 'true') {
			setArr['set']['filters'] = wmt_roll_overall_types ($('.wmt_filters_enabled'), true);
		}
		//Set Extended Background
		if (setArr['set']['background-full-width']) {
			setArr['set']['extended-background'] = wmt_roll_overall_types ($('.wmt_bg_full_width_ops'), true);
		}
		//Additional media queries
		if (setArr['set']['additional-dimension-rules'] &&  setArr['set']['additional-dimension-rules'] === 'true') {
			setArr['set']['media-query-rules'] =  wmt_component.collect($('.wmt_tile_dimensions_additional_rules .wmt_component_container'));
		}
		
		//ROLLING TILE PANELS HERE
		$('.wmt_TsetContainer').each(function () {
			setArr['tiles'][count]={};
			var arr = setArr['tiles'][count];
				   ths = $(this);
			count++;
			
			//skip process if data wasn't unloaded
			if (ths.hasClass('wmt_unroll_data_here')) {
				setArr['tiles'][count - 1] = ths.data('wmt');
				return;
			}
			
			//Type
			arr['type'] = {};
			arr['type']['purpose'] = ths.find('[data-wmt-type="purpose"]:checked').val();
			arr['type']['option'] = ths.find('[data-wmt-type="option"]:checked').val();

			//Content
			ths.find('[data-wmt-content]').each(function () {
				var key = $(this).attr('data-wmt-content'),
						val = $(this).val();
				if (key === "description") val = $(this).parent().find('.nicEdit-main').html();
				arr[key] = {};
				arr[key]['content'] = val;
			})
			
			//Other
			ths.find('[data-wmt-other]').each(function () {
				//Prepare sub-arrays for each category
				var t = $(this),
					   key = t.attr('data-wmt-other');
				if (arr[key]===undefined) arr[key] = {};

				//Title, Tagline, Descr. and Overall
				if (key === "title" || key === "tagline" || key === "description" || key === "overall" || key === "icon" || key === "image" || key === "image-hover" || key === "link") {

					if (!arr[key]['style']) arr[key]['style']={};
					if (!arr[key]['style-hover']) arr[key]['style-hover']={};					
					if (!arr[key]['class']) arr[key]['class']={};
					if (!arr[key]['data']) arr[key]['data']={};
					var selector;
					if (key !== "link") selector = $(this).find('[data-wmt-otherop]'); //normal case
					else selector = $(this).children().not('.wmt_links_settings').find('[data-wmt-otherop]'); //case of link - overall ops should be placed inside p tags else they won't be found.
					selector.each(function () {
						var key2 = $(this).attr('data-wmt-otherop'),
							   th = $(this),
							   style="style";
						//Normal and Hover styles
						if ($(this).attr('data-wmt-otherop-type') === "hover") {
							var style="style-hover";
						} else if ($(this).attr('data-wmt-otherop-type') === "class") {
							var style="class";
						} else if ($(this).attr('data-wmt-otherop-type') === "data") {
							var style="data";
						}

						//Set val if not a checkbox/radio, ie regular text input or select but with value; or if is one, but also checked
						if (( (th.is(':checkbox') || th.is(':radio')) && th[0].checked) || ( !th.is(':checkbox') && !th.is(':radio') && th.val() !== "" && th.val() !== undefined ) ) {
							var k = $(this).val();
							arr[key][style][key2] = k;
						}
					})
				}

				//Links
				if (key === "link") {
					var i = 0;
					t.find('.wmt_single_link_settings').each(function () {
						arr[key][i] = {}; // new object for each 
						var o = arr[key][i];						
						o['style']={};
						o['style-hover']={};
						o['class']={};
						$(this).find('[data-wmt-otherop]').each(function () {
							var key2 = $(this).attr('data-wmt-otherop'),
								   th = $(this),
								   style= "style";
							//Normal and Hover styles
							if ($(this).attr('data-wmt-otherop-type') === "hover") {
								var style="style-hover";
							} else if ($(this).attr('data-wmt-otherop-type') === "class") {
								var style="class";
							}	else if ($(this).attr('data-wmt-otherop-type') === "data") {
								var style="data";
							}
							//Set val if not a checkbox/radio, ie regular text input or select but with value; or if is one, but also checked
							if (( (th.is(':checkbox') || th.is(':radio')) && th[0].checked) || ( !th.is(':checkbox') && !th.is(':radio') && th.val() !== "" && th.val() !== undefined ) ) {
								var k = $(this).val();
								o[style][key2] = k;
							}
						})
						i++;
					})
				}
				
				//Image
				if (key === "image" || key === "lightbox" ) {
					var a = arr[key];
					t.find('input').each(function () {
						var i = $(this).attr('data-wmt-otherop'),
							   th = $(this);
						//Set val if not a checkbox/radio, ie regular text input but with value; or if is one but also checked
						if (( (th.is(':checkbox') || th.is(':radio')) && th[0].checked) || ( !th.is(':checkbox') && !th.is(':radio') && th.val() !== "" && th.val() !== undefined ) ) {
							var k = $(this).val();
							a[i] = k;
						}
					})
				}
			})
			
		})

		if (!command) {
			$('.wmt_custCombo').data('wmt', setArr);
			wmt_rollGrid();
			//Preparing the ajax request for compiling set html		
			function success(r) {
//				console.log('return was:');
//				console.log(r);
				var t = $('.wmt_combined').eq(parseInt(r['set-index']));
				wmt_init_set(t,r);
			}
			function fail() {alert('There was an error!');}
			function complete() {alert('request completed');}
			wmt_ajax(setArr, 'wmt_ajax_get_set', success, fail, complete);

		} else if (command==="for_export") { //case of EXPORT
			if (tile_index === undefined) { //Set
				$('.wmt_export_set').prev().val(JSON.stringify(setArr));
			} else { //Tile
				$('.wmt_TsetContainer').eq(tile_index).find('.wmt_export_tile').prev().val(JSON.stringify(setArr['tiles'][tile_index]));
			}
		} else if (command==="read") {
			console.log('This is what was read:')
			console.log(setArr);
			return setArr;
		}
	};	
	
	function wmt_roll_overall_types (i, x) { //i = selector of type container div, x = segregation based on style

		var s={};

		if (x) {

			s['style']={};

			s['style-hover']={};

		}

		i.find('[data-wmt-otherop]').each(function () {

			var key = $(this).attr('data-wmt-otherop'),

				   th = $(this);

			//Normal and Hover styles

			if (x) {

				if (th.attr('data-wmt-otherop-type') === "hover") {

					var style="style-hover";

				} else {

					var style="style";

				}

			}

			//Set val if not a checkbox/radio, ie regular text input or select but with value; or if is one, but also checked

			if (( (th.is(':checkbox') || th.is(':radio')) && th[0].checked) || ( !th.is(':checkbox') && !th.is(':radio') && th.val() !== "" && th.val() !== undefined ) ) {

				var v = th.val();

				if (x) s[style][key] = v;

				else s[key] = v;

			}

		});

		return s;

	}

	

	//Ajax for retrieving set markup 

	function wmt_ajax (arr, command, success, fail) {

	   $.ajax({
			type : "post",
			dataType : "json",
			beforeSend: function () {
				$('.wmt_main_loader').addClass('wmt_loading');
				console.log('About to send this via ajax:');
				console.log(arr);
			},
			url : wmt_myAjax.ajaxurl,
			data : {action: command, nonce : wmt_myAjax.nonce, wmt_arr : JSON.stringify(arr)},
			success: function (response) {
				console.log('response was: ');
				console.log(response);
				if (response && response.result ==="success" ) {
					if (success) success(response);
				} else {
					if (fail) fail();
				};
			},
			complete: function () {
				$('.wmt_main_loader').removeClass('wmt_loading');
			}
		});
	}

	//Roll grid
	function wmt_rollGrid () {
		wmt_grid ={};//emptying it out
		wmt_grid.sets = {};
		if ($('.wmt_combined').length === 0 ) return; //Create some sets first
		var count = 0;
		$('.wmt_combined').each(function () {
			var t = $(this);
			wmt_grid.sets[count] = t.data('wmt');
			if (!wmt_grid.sets[count]) wmt_grid.sets[count] = {'set':{'top':'', 'left':'', 'width':'', 'height':''} };
			wmt_grid.sets[count]['set']['top'] = t.css('top');
			wmt_grid.sets[count]['set']['left'] = t.css('left');
			wmt_grid.sets[count]['set']['width'] = t.css('width');
			wmt_grid.sets[count]['set']['height'] = t.css('height');
			wmt_grid.sets[count]['set']['combo-index'] = t.attr('data-wmt-combo');
			if (wmt_grid.sets[count]['set']['title']) {
				wmt_grid.sets[count]['set']['title']['style']['max-height'] = t.find('li.wmt_set_title').css('height');
			}
			count++;
		});

		wmt_grid['width'] = $('.wmt_container').css('width');
		wmt_grid['height'] = $('.wmt_container').css('height');
		wmt_grid['flex'] = $('.wmt_grid_respFlex').val();
		wmt_grid['align'] = $('.wmt_grid_alignment').val();
		wmt_grid['display-above'] = $('.wmt_grid_displayAbove').val();
		wmt_grid['display-below'] =  $('.wmt_grid_displayBelow').val();
		wmt_grid['no-resp'] = $('.wmt_grid_noResp').filter(':checked').val();
		wmt_grid['bg-enabled'] = $('.wmt_grid_bg_enabled').filter(':checked').val() || false;
		wmt_grid['bg-image'] = $('.wmt_grid_bg_image').val();
		wmt_grid['bg-color'] = jQuery('.wmt_grid_bg_color').val();
		wmt_grid['bg-attachment'] = jQuery('.wmt_grid_bg_attachment').val();
		wmt_grid['bg-position'] = jQuery('.wmt_grid_bg_position').val();
		wmt_grid['bg-repeat'] = jQuery('.wmt_grid_bg_repeat').val();
	}

	//Save grid
	$('button.wmt_save').click(function () {
		if (!$('.wmt_combined').length) return;
		wmt_rollGrid();//Collect all values object before saving via ajax
		wmt_grid.bpMem = wmt_bp_collect();//Blue print data such as classes of wmt_tiles
		wmt_grid.rows = parseInt($('.wmt_container').attr('data-wmt-rows'));
		wmt_grid.cols = parseInt($('.wmt_container').attr('data-wmt-cols'));
		wmt_grid.tile_gap = parseInt($('.wmt_tile').css('border-right-width'));
		wmt_grid.tile_size = parseInt($('.wmt_tile').width());
		wmt_grid.sc_index = $('.wmt_save').prev().val();
		wmt_grid.next_combo_id = $('.next_combo_id').val();		

		function success(r) {
			var indexed_sc = $('.wmt_blueprint_container').clone().find('.wmt_blueprint_resize_container, .wmt_tile, .wmt_tileTool, .wmt_blueprint_resizer_index').remove().end().contents().each(function() {
																			if (this.nodeType == 8  || (this.nodeType == 3 && !/\S/.test(this.nodeValue))) {
																				$(this).remove();
																			} 
																		}).end().html();
			indexed_sc = indexed_sc.replace(/\n/g,"").replace(/\t/g, '');
			$.magnificPopup.open({
				items: {
					src: $('<div class="wmt_set_import_lightbox" style="height: 320px; width: 550px;"><h2>YOUR DESIGN HAS BEEN SAVED!</h2> <strong style="margin-right: 5px; display: inline-block;">Here is the shortcode for your design:</strong> [idesign id="' + r.currSet +'"]<br><strong style="margin-right: 5px; display: inline-block;">Or you can use this indexible code instead:</strong><textarea class="wmt_shortcode" style="height: 180px; margin-top:10px;">[idesign id="' + r.currSet +'"]'+indexed_sc+'[/idesign]</textarea>')
				},
				type: 'inline' // this is default type
			})
		}

		function fail() {
			alert('There was an error!');
		}

		function complete() {
		//console.log('request was completed');
		}

		wmt_ajax(wmt_grid, 'wmt_ajax_save_grid', success, fail, complete);		

	})

	

	//Copy grid

	$('button.wmt_copy').click(function () {
		//First copy the grid from requested position via ajax, then using ajax once more, generate html content for the sets
		var wmt_sc_index = $('.wmt_copy').prev().val();
		if (wmt_sc_index === "") wmt_sc_index = 1;
		function success(r) {
//			console.log('return from the copy button was:');
//			console.log(r);
			if (r.iGrid.bpMem) wmt_bpMem = r.iGrid.bpMem;
			if (!r.iGrid.tile_size) r.iGrid.tile_size = 50;
			if (!r.iGrid.tile_gap) r.iGrid.tile_gap = 2;
			if (!r.iGrid.next_combo_id) r.iGrid.next_combo_id = 5000;
			if (!r.iGrid.align) r.iGrid.align = 'center';
			wmt_reproduce(r.iGrid.cols, r.iGrid.rows, r.iGrid.tile_size, r.iGrid.tile_gap, r.iGrid.next_combo_id, r.iGrid.align, r.iGrid['display-above'], r.iGrid['display-below'],  r.iGrid['no-resp'], r.iGrid['bg-enabled'], r.iGrid['bg-image'], r.iGrid['bg-color'], r.iGrid['bg-attachment'], r.iGrid['bg-position'], r.iGrid['bg-repeat']);
			wmt_recreateGrid (r.iGrid);
		}
		function fail() {
			alert('There was an error!');		
		}
		function complete() {
		}
		wmt_ajax(wmt_sc_index, 'wmt_ajax_copy_grid', success, fail, complete);
	})

	

	//Apply New Blueprint Settings

	$('button.wmt_selDims').click(function () {

		var  c = $('input.wmt_selDimsc').val(),

				r = $('input.wmt_selDimsr').val(),

				g = $('.wmt_bpTileGap').val(),

				s = $('.wmt_bpTileSize').val() - (  (g*2) > s ? g*2 : 0  ),

				n = $('.next_combo_id').val(),

				a	=	$('.wmt_grid_alignment').val() || 'center',

				da= $('.wmt_grid_displayAbove').val(),

				db = $('.wmt_grid_displayBelow').val(),

				res = $('.wmt_grid_noResp').filter(':checked').val() || false,

				bge = $('.wmt_grid_bg_enabled').filter(':checked').val() || false,

				bgi = $('.wmt_grid_bg_image').val(),

				bgc = jQuery('.wmt_grid_bg_color').val(),//color

				bga = jQuery('.wmt_grid_bg_attachment').val(),//attachment

				bgp = jQuery('.wmt_grid_bg_position').val();//position

				bgr = jQuery('.wmt_grid_bg_repeat').val();//repeat



//		console.log('c: '+c+' r: '+r+' s: '+s+ ' g: '+g);

		if (!isNaN(c) && !isNaN(r) && !isNaN(s) && !isNaN(g) && c>0 && r>0 && s>=20 && g>=0) {

			wmt_bp_collect();//collect tile data from blueprint			

			wmt_rollGrid();

			wmt_grid.bpMem = wmt_bp_collect();//collects info on each tile, and one 'min' field, records vals in wmt_bpMem

			wmt_grid.rows = c;

			wmt_grid.cols = r;

			wmt_grid.tile_size = s;

			wmt_grid.tile_gap = g;

			wmt_grid.align = a;

			wmt_grid.next_combo_id = n;

			wmt_reproduce(c,r,s,g,n,a,da,db,res,bge,bgi,bgc,bga,bgp,bgr);//reproduce blueprint

			wmt_recreateGrid(wmt_grid, true); //sets

		} else  {

			console.log("Note: Values did not qualify");

		}

	})

	
	//auto select contents of text area
	$('.wmt_export_set_textarea, .wmt_export_output, .wmt_shortcode').click(function () {
		$(this).select();
	})
	
	$(document).on('click', 'textarea.wmt_shortcode, .wmt_export_tile_textarea', function () {
		$(this).select();
	})
	
	//Export grid
	$('.wmt_export').click(function () {
		wmt_rollGrid();

		wmt_grid.bpMem = wmt_bp_collect();//collects info on each tile, and one 'min' field, records vals in wmt_bpMem

		wmt_grid.rows = parseInt($('.wmt_container').attr('data-wmt-rows'));

		wmt_grid.cols = parseInt($('.wmt_container').attr('data-wmt-cols'));

		wmt_grid.next_combo_id = $('.next_combo_id').val();

		if(!wmt_grid.tile_size) wmt_grid.tile_size = $('.wmt_tile').width();

		if(!wmt_grid.tile_gap) wmt_grid.tile_gap =  ($('.wmt_tile').outerWidth(true) - $('.wmt_tile').width())/2;

		var current_grid = JSON.stringify(wmt_grid);

		$('.wmt_export_output').val(current_grid);

	})

	

	//Import grid

	$('.wmt_import').click(function () {

		var iGrid =$('.wmt_import_input').val();

		if (iGrid === "") return;

		iGrid = JSON && JSON.parse(iGrid) || $.parseJSON(iGrid);

		wmt_bpMem = iGrid.bpMem;
		
		console.log("Tile size: "+iGrid.tile_size);
		
		if (!iGrid.tile_size) iGrid.tile_size = $('.wmt_tile').width();

		if (!iGrid.tile_gap) iGrid.tile_gap = ($('.wmt_tile').outerWidth(true) - $('.wmt_tile').width())/2;

		if (!iGrid.next_combo_id) iGrid.next_combo_id = 5000;

		if (!iGrid.align) iGrid.align = 'center';

		

		wmt_reproduce(iGrid.cols, iGrid.rows, iGrid.tile_size, iGrid.tile_gap, iGrid.next_combo_id, iGrid.align, iGrid['display-above'], iGrid['display-below'], iGrid['no-resp'], iGrid['bg-enabled'], iGrid['bg-image'], iGrid['bg-color'], iGrid['bg-attachment'], iGrid['bg-positoin'], iGrid['bg-repeat']); //produce blue print

		wmt_recreateGrid(iGrid); //sets

	})



	//Recreating a grid's sets

	function wmt_recreateGrid (iGrid, condition) {

		if (!condition) $('.wmt_combined').remove(); //removes all prev sets from bp

		var  flex = iGrid['flex'] === undefined ? 0 : iGrid['flex'],

				above = iGrid['display-above']===undefined? "":iGrid['display-above'],

				below = iGrid['display-below']===undefined? "":iGrid['display-below'],

				resp = iGrid['no-resp'] === undefined ? "" : iGrid['no-resp'],

				bgi = iGrid['bg-image']===undefined? "":iGrid['bg-image'],

				bgt = iGrid['bg-type']===undefined? "center":iGrid['bg-type'];



		$('input.wmt_grid_respFlex').val(flex);

		$('input.wmt_grid_noResp[value="'+resp+'"]').not(':checked').click();

		$('input.wmt_grid_displayAbove').val(above);

		$('input.wmt_grid_displayBelow').val(below);

		

		var iGrid_sets = iGrid['sets'],

				w = $('.wmt_tile').width(),

				ow = $('.wmt_tile').outerWidth(true),

				bw = (ow-w)/2; //single border's width

		for (var index in iGrid_sets) { //set widths were stored in units of 'tiles/cells', not px. Now they'll be calc based on curr cell size & space

			var	col = iGrid_sets[index]['set']['first-tile']['col'],

					row = iGrid_sets[index]['set']['first-tile']['row'],

					first_tile = $('.wmt_tile[data-wmt-col="'+col+'"][data-wmt-row="'+row+'"]'),



					col = iGrid_sets[index]['set']['last-tile']['col'],

					row = iGrid_sets[index]['set']['last-tile']['row'],

					last_tile = $('.wmt_tile[data-wmt-col="'+col+'"][data-wmt-row="'+row+'"]'),



					width = ((parseInt( iGrid_sets[index]['set']['last-tile']['col']) - parseInt(iGrid_sets[index]['set']['first-tile']['col']) +1)*ow) - (bw*2),

					height = ((parseInt( iGrid_sets[index]['set']['last-tile']['row']) - parseInt(iGrid_sets[index]['set']['first-tile']['row']) +1)*ow) - (bw*2),



					top = (( parseInt(iGrid_sets[index]['set']['first-tile']['row']) - 1) * ow) + bw,

					left = (( parseInt(iGrid_sets[index]['set']['first-tile']['col']) - 1) * ow) + bw;



			iGrid_sets[index]['set']['set-index'] = index;//tells success function locate div to place html

			

			if (condition) {

				var t = $('.wmt_combined').eq(index).attr('data-wmt-combo', iGrid_sets[index]['set']['combo-index']).css({'top': top, 'left': left, 'height':height, 'width': width});

				wmt_init_set(t);

			} else {

				var combo = '<div class="wmt_combined wmt_triggerable" data-wmt-tc=".wmt_set_title" data-wmt-combo="'+iGrid_sets[index]['set']['combo-index']+'" style="width:'+width+'px ; height:'+height+'px ; top:'+top+'px ; left:'+left+'px ;"> </div>';

				$('.wmt_container').append(combo);//create set outer body			

				$('.wmt_combined').filter(':last').data('wmt', iGrid_sets[index]);			

				//Go ajax

				function success (r) {

					var t = $('.wmt_combined').eq(parseInt(r['set-index']));

					wmt_init_set(t,r);

				}

				function fail() {alert('There was an error!')};

				function complete() {alert('request completed')};

				wmt_ajax(iGrid_sets[index], 'wmt_ajax_get_set', success, fail, complete);

			}

		}

	}



	//Links Panel

	$('.wmt_TsetOverallContainer').on('click', '.wmt_copy_link', wmt_copy_link_panel_trigger) //COPY

	.on('click', '.wmt_delete_link', function () { //DELETE

		if ($(this).parents('.wmt_single_link_settings').hasClass('wmt_main_link_settings') ||  $(this).parents('.wmt_single_link_settings').hasClass('wmt_lightbox_link_settings') ) return;

		$(this).parents('.wmt_single_link_settings').remove();

	});



	function wmt_copy_link_panel_trigger () {

		var t = $(this).closest('.wmt_single_link_settings');

		wmt_copy_link_panel (t);

	}

	

	//Copy Link

	function wmt_copy_link_panel (t) {

		var c = t.clone();

		if (c.hasClass('wmt_main_link_settings') || c.hasClass('wmt_lightbox_link_settings') || c.hasClass('wmt_woo_link_settings') ) {// we have copy of main link settings panel

			c.removeClass('wmt_primary_link_settings wmt_main_link_settings wmt_lightbox_link_settings wmt_woo_link_settings');

			c.find('[data-wmt-otherop="url"]').attr({'type':'visible', 'value':"http://"}).prev('p').remove();

		}

		t.closest('.wmt_single_link_settings').after(c);

		wmt_init_iris(c);

	}



	//Media uploader

	function wmt_media (inp) {

		// Create the media frame.

		file_frame = wp.media.frames.file_frame = wp.media({

		  title: $( this ).data( 'uploader_title' ),

		  button: {

			text: $(this).data( 'uploader_button_text' ),

		  },

		  multiple: false 

		});

	 

		//Storing image link for future use

		file_frame.on( 'select', function() {
			attachment = file_frame.state().get('selection').first().toJSON();
			$(inp).val(attachment.url).parent().css('background-image', 'url('+attachment.url+')');

			//Feed lightbox
			if ($(inp).attr('data-wmt-content')==="image") {
				var u = attachment.url;
				$(inp).closest('.wmt_TsetContainer').find('input[data-wmt-otherop="content"]').val(u).parent().css('background-image', 'url("'+u+'")');
			}

		});
		file_frame.open();
	};	

	//Enabling media uploader for tile imgs
	$('body').on('click', '.wmt_TsetImageAdd', function () {
		var t = $(this);
		wmt_media (t.next('input'));
	});

	//Remove uploaded image
	$('body').on('click', '.wmt_TsetImageRemove', function () {
		var t = $(this);
		t.parent().css('background-image','').end().prev('input').val('');
	})

	/*--Iris Color Picker--*/
	function wmt_init_iris(s) {
//		if (s) s = $(s).find('.wmt_color_picker').not('.wmt_on');
		if (s) s = $(s).find('.wmt_color_picker');
//		else s = $('.wmt_TsetOverallContainer .wmt_sortable .wmt_color_picker').not('.wmt_on');
		else s = $('.wmt_TsetOverallContainer .wmt_sortable .wmt_color_picker');
		s.each(function () {
//			$(this).addClass('wmt_on').iris({palettes: true});
			$(this).addClass('wmt_on').iris({palettes: true});
		})
	};

	wmt_init_iris ($('body'));

	$('.wmt_color_panel_inside').on('click', wmt_hide_iris);

	function wmt_hide_iris(e) {
        if (!$(e.target).is(".colour-picker, .iris-picker, .iris-picker-inner, .iris-palette-container, .wmt_dot")) {
            $('.wmt_color_picker.wmt_on').iris('hide');//only hide initialized
			$('.iris-picker').hide();
        }
	}

    $(document).on('click', '.wmt_color_picker', function (event) {
        $('.wmt_color_picker').iris('hide');
        $(this).iris('show');
        return false;
    });

	$('.wmt_selDims').click();//conjure first grid and on with it...		

	//Color presets
	$('.wmt_TsetOverallContainer').on('change', 'select[data-wmt-otherop="tile_color_preset"]' , function () {
		var v = $(this).val();
		if (!wmt_preset_colors[v]) return;
		var overall_parent = $(this).parents('.wmt_TsetContainer');
		for(var section in wmt_preset_colors[v]) {// section = "title" / "ligthbox" / etc..
			if(wmt_preset_colors[v].hasOwnProperty(section)) {		
				var current_parent = overall_parent.find('[data-wmt-other="'+section+'"]');
				for(var sub_section in wmt_preset_colors[v][section]) { // sub_section = "style" / "style-hover"
					if(wmt_preset_colors[v][section].hasOwnProperty(sub_section)) {
						var type= sub_section !== "style-hover" ? "" : '[data-wmt-otherop-type="hover"]';
						var not= sub_section !== "style-hover" ? '[data-wmt-otherop-type="hover"]' : "";					
						for(var sub_section_element in wmt_preset_colors[v][section][sub_section]) { // sub_section_element = "background-color" / "color" / "box-shadow-color"
							if(wmt_preset_colors[v][section][sub_section].hasOwnProperty(sub_section_element)) {
								current_parent.find('[data-wmt-otherop="'+sub_section_element+'"]'+type).not(not).val(wmt_preset_colors[v][section][sub_section][sub_section_element]);
							}
						}
					}
				}
			}
		}
	});

	wmt_nicEdit_init ();//first one

	//load from url
	if(window.location.hash) {
		var hash = window.location.hash.substring(1); //Puts hash in variable, and removes the # character
		if (!isNaN(hash)) {
			$('.wmt_copy').prev('input').val(hash);
			$('.wmt_copy').click();
		}
	}

	//Woo comm links
	$('[name=wmt_contType]').on('change', function () {
		if($('input[name=wmt_contType][type=radio]:checked').val() === 'woocomm') {
			var t = wmt_which_woo_links ();
			wmt_prep_woo_link_panels (t);
		} else {
			wmt_kill_woo_link_panels ();
		}
	})

	$('[data-wmt-overall="content-generation"]').click(function () {
		if ($(this).val() === "woocomm")
		wmt_kill_woo_link_panels ();
	})

	$('select[data-wmt-overall="link-type"]').on('change', function () {
		wmt_prep_woo_link_panels ();
	})

	function wmt_which_woo_links () {
		var t = 'page';
		if ($('.wmt_custCombo').length && $('.wmt_custCombo').data('wmt') && $('.wmt_custCombo').data('wmt')['set']['link-type']) 
		t = $('.wmt_custCombo').data('wmt')['set']['link-type'];
		return t;
	}
	
	function wmt_prep_woo_link_panels (t) {
		if (!t) t = $('[data-wmt-overall="link-type"] option:selected').val();
		wmt_kill_woo_link_panels ();
		var arr = ['cart','page'];//iterate over these if both
		if (t !== 'both') arr.unshift(t);//iterate over just this first item
		var x = t === 'both'? 2 : 1;
		for (var i=0; i<x;i++) {
			link = 'woo_'+arr[i]; // woo_cart / woo_page
			if ($('input[value="'+link+'"][data-wmt-otherop="url"]').length) continue;
			$('.wmt_TsetContainer').each(function () {
				var f = $(this).find('.wmt_main_link_settings');
				wmt_copy_link_panel(f);
				f.next().show().addClass('wmt_woo_link_settings').find('[data-wmt-otherop="url"]').val(link).attr('type','hidden').before('<p style="font-weight:bold;">Woo '+arr[i]+'</p>');
				var icon = link === 'woo_cart' ? 'fa-shopping-cart' : 'fa-link';
				f.next().find('input[data-wmt-otherop="icon"]').val(icon).end().find('input[data-wmt-otherop="text"]').val('');
				f.hide();
			})
		}
	}

	function wmt_kill_woo_link_panels () {
		$('.wmt_woo_link_settings').each(function () {
			$(this).siblings('.wmt_single_link_settings').show()
			.end().remove();
		});
	};

	/*--- Resources Page ---*/
	//Import All
	var wmt_file;
	$(':file').change(function () {
		if (this.files[0]) {
			wmt_file = this.files[0];
			var file = this.files[0],
					name = file.name,
					size = file.size,
					type = file.type;
			//console.log('type: '+type+' size: '+size+'name: '+name);
		}
	})

	$('.wmt_upload_import input:button').click(function(){
		var wmt_formData = new FormData();
		wmt_formData.append('wmt_upload', wmt_file);
		wmt_formData.append('nonce', wmt_myAjax.nonce);
		if ($('.wmt_modify_db_trigger').is(':checked')) {
			wmt_formData.append('replace_this', $('.wmt_modify_db input.wmt_replace_this').val());
			wmt_formData.append('replace_with', $('.wmt_modify_db input.wmt_replace_with').val());
		}

		$.ajax({
			url : wmt_myAjax.ajaxurl+'?action=wmt_ajax_import_total',
			type: "post",
			dataType : "json",
			xhr: function() {  // Custom XMLHttpRequest
				var myXhr = $.ajaxSettings.xhr();
				if(myXhr.upload){ // Check if upload property exists
					myXhr.upload.addEventListener('progress',progressHandlingFunction, false); // For handling the progress of the upload
				}
				return myXhr;
			},

			beforeSend: beforeSendHandler,
			success: successHandler,
			data: wmt_formData,
			cache: false,
			contentType: false,
			processData: false
		});
	});

	function progressHandlingFunction(e){
		if(e.lengthComputable){
			$('.wmt_upload_import progress').attr({value:e.loaded,max:e.total});
		}
	}

	function successHandler (response) {
		console.log(response);
		$('.wmt_main_loader').removeClass('wmt_loading');
		if (response['result'] && response['result']  === 'success') 
		alert('Data was successfully imported!');
	}

	function beforeSendHandler () {
		$('.wmt_main_loader').addClass('wmt_loading');
	}

	//Export All	
	$('.wmt_export_all').click(function () {
		var success = function (r) {
			window.location = wmt_url+'idesign/database/idesign_database.zip';
		}
		wmt_ajax(false, 'wmt_ajax_export_total', success);
	});

	//Google fonts
    $('body').on('click', '.wph_rep_edit', function () {
        var i = $(this).closest('.wph_rep').data('wph_rep');
        wph.cust.area = $(this).closest('.wph_rep_area').siblings('.wph_cust_area');
        wph.cust.load(i);//loads to editor
    })
    .on('click', '.wph_rep_delete', function () {
        var i = $(this).closest('.wph_rep').remove();
		var o = wph.rep.save();
		function success (r) {
			console.log('google fonts saved');
			console.log(r);
		};
		wmt_ajax(o, 'wmt_ajax_gfonts',success);
    })
    .on('click', '.wph_cust_area button', function () {
        wph.cust.area = $(this).closest('.wph_cust_area')
        wph.rep.area = wph.cust.area.siblings('.wph_rep_area');
        wph.rep.insert();
        wph.rep.callback = function (o) {
			function success (r) {
			};
			wmt_ajax(o, 'wmt_ajax_gfonts',success);
		};
        wph.rep.save();		
    })

	if (wph.rep.items) { //array of items to be represented
		$.each(wph.rep.items, function (k, v) {
			wph.rep.area = $('.wph_rep_area');	
			wph.rep.insert(v);
		});
	}
	
	$('.wph_rep').each(function () {
		var t = $(this),
				o = t.data('wph_rep');
		t.css('font-family', o['name']);
	})

	$('body').on('click', '.wmt_export_tile_to_siblings', function () {
		var v = $(this).siblings('.wmt_export_tile').click().prev().val();
		$('.wmt_main_loader').addClass('wmt_loading');
		setTimeout(function () {
			$('.wmt_TsetApplyAll').addClass('wmt_disabled');//#
			$('.wmt_import_tile').each(function () {
				wmt_init_tile_panel ($(this).closest('.wmt_TsetContainer'));
				$(this).prev().val(v);
				$(this).click();
			});
			$('.wmt_main_loader').removeClass('wmt_loading');
			$('.wmt_TsetApplyAll').removeClass('wmt_disabled');
		}, 250);
	})

	//Delete database
	$('.delete-database-popup').magnificPopup({
		modal:true
	})
	$('.wmt_delete_op').click(function () {
		$.magnificPopup.instance.close();
	})

	$('.wmt_delete_yes').click(function () {
		var success = function (r) {
			alert('All Welcome Tiles Data has been wiped clear!');
		}
		wmt_ajax(true, 'wmt_ajax_delete_all', success);
	})

	//resize blueprint with key
	wmt.blueprint.resize.init();

	//blur the buttons so they don't reclick with space bar
    $('#wpbody-content button').click(function () {
        $(this).blur();
    })	

	//nicedit
	$('body').on('click', '.nicEdit-main', function (e) {
		$(this).focus();
		e.stopPropagation();
	})

	$('body').on('click', function (e) {
		$('.nicEdit-main').blur();
	})
	
	//Edit Tile Geometry
	$('.wmt_container').on('click', '.wmt_tileToolMOVETILES', function () {
		wmt_tile_geometry_edit.on($('.wmt_currentCombo'));
	})

	$('.wmt_disabled').click(function () {
		alert('This button has been temporarily disabled');
		return false;
	})

	//Pesky backspace
	if ($('.wmt_TsetApplyAll').length) {
		function wmt_confirm_exit () {
			return " ";
		};
		window.onbeforeunload = wmt_confirm_exit;
	}
	
	//Component System	
		//Event Handlers
	$('body').on('click', '.wmt_copy_component' , function () {
		wmt_component.copy($(this));
	}).on('click', '.wmt_remove_component', function (){
		wmt_component.remove($(this));
	});

		//Object
	var wmt_component = {
		copy: function (button) {
			var  component = button.closest('.wmt_component'),
					clone = component.clone(true, true);
			clone.insertAfter(component);
		},
		remove: function (button) {
			var component = button.closest('.wmt_component');
			if (component.siblings('.wmt_component').length) component.remove();
		},
		collect: function (component_container) {
			var 	components = component_container.find('.wmt_component'),
					array = [];
			for (var i=0; i < components.length; i++) {
				var 	object = {},
						component = components.eq(i);
				component.find('[data-wmt-component-key]').each(function () {
					object[$(this).attr('data-wmt-component-key')] = $(this).val();
				})
				array[i] = object;
			}
			return array;			
		},
		feed: function (component_container, array) {
			var length = array.length;
			wmt_component.initiate_components(component_container, length);
			if (!array.length)  return false;
			var components = component_container.find('.wmt_component');
			for (var i = 0; i<length; i++) {
				var  object = array[i],
						component = components.eq(i);
				$.each( object, function( key, value ) {
					component.find('[data-wmt-component-key="'+key+'"]').val(value);
				});
			}
		},
		initiate_components: function (component_container, required) {
			var  last = component_container.children('.wmt_component').last(),
					clone = last.siblings().remove().end().clone(true, true);
			for (var i = 1; i < required; i++) {
				var component = clone.clone(true, true).insertAfter(last);
			}
		}
	}
	
})



/*--utility fns--*/

function wmt_resize_object (obj, req) {//resizes the object, increasing its keys in original pattern or reducing them
	var total = 0;
	for (var i in obj) {
		if (obj.hasOwnProperty(i)) total++;
	}

	var feed_key = 0;		
	if (total < req) {
		for (var key = 0; key < req; key++) {
			if (!obj.hasOwnProperty(key)) {
				obj[key] = obj[feed_key];
				feed_key++;
				if (feed_key === total) feed_key = 0;
			}
		}
	} else if (total > req) {
		for (var i in obj) {
			if (obj.hasOwnProperty(i)) {
				if (feed_key >= req) delete obj[i];
				feed_key++;
			};
		}
	}

	return obj;
}

function wmt_revert_inputs_to_default (t , x, x2) { //t = container of inputs , x = exceptions (direct child only), x2= exception selector strings combined
	t = t.children().not(x);
    //text/select
    t.find('input, select').not('[type="checkbox"],[type="radio"]').each(function () {
		if (x2 && jQuery(this).filter(x2).length) return;
        jQuery(this).val(this.defaultValue);
    })
	//textarea
	t.find('textarea').val('');
    //checkbox & radio
    t.find('input[type="checkbox"],input[type="radio"]').each(function () {
		if (x2 && jQuery(this).filter(x2).length) return;
        if (this.defaultChecked) this.checked = true;
        else this.checked = false;
    })
	//nic editor
	t.find('.nicEdit-main').empty();
	//close triggerable sections
	t.find('.wmt_trigger').each(function () {
		var a = jQuery(this).attr('data-wmt-trigger');
		var x = t.find(a);
		if (!x.hasClass('wmt_op_thumb_outer_cover')) x.hide();
	})
	//image selector
	t.find('.wmt_TsetImageAdd').each(function () {
		jQuery(this).parent().css('background-image','none').find('input').val('');
	})
	//select a type
	t.find('[data-wmt-type="purpose"]:first, .wmt_button_types [data-wmt-type="option"]:first').click();
}

var wmt_sa = { //space assessor -  how many tiles should be fit in the cust area?
    o: function () {
        return jQuery('.wmt_custCombo');
    },
    w: function () {
        return this.o().width();
    },
    min: 200,
    over_min : function () {
        return this.w() > this.min; 
    },
    get_figure : function () {
        var _ = this;
        if (_.over_min()) {
            return Math.floor(_.w()/_.min);
        } else {
            return 1;
        }
    }
};


/*--wph helper obj--*/
if (!wph) var wph = 
(function ($) {
    return {
        rep: {
            prepare: function (i) {
                if (i['name'] === undefined) return false;
                var e = '<div class="wph_rep_edit wph_rep_ops fa fa-copy"></div>',
                    d = '<div class="wph_rep_delete wph_rep_ops fa fa-times"></div>',
                    h = '<div class="wph_rep"><span>' + i['name'] + '</span>' + e + d + '</div>';
                return h;
            },
            insert: function (i) { //i is an object of info to represent
                if (!i) i = wph.collect(wph.cust.area);
                var h = this.prepare(i);
                if (h) this.area.append(h).children().filter(':last').data('wph_rep', i);
            },
            area: $('.wph_rep_area'),
            save: function (a) {
                if (!a) a = this.area;
                var o = [];
                a.find('.wph_rep').each(function () {
                    var d = $(this).data('wph_rep');
					o.push(d);
                })
                this.callback(o);
				return o;
            },
            callback: function (o) {                
            }
        }, //closed reps
        cust: {
            clear: function (t) {
                //text
                t.find('input').not('[type="checkbox"],[type="select"],[type="radio"]').each(function () {
                    jQuery(this).val(this.defaultValue);
                })
                //textarea
                t.find('textarea').val('');
                //checkbox & radio
                t.find('input[type="checkbox"],input[type="radio"]').each(function () {
                    if (this.defaultChecked) this.checked = true;
                    else this.checked = false;
                })
            },
            load: function (i, a) {
                if (a) this.area = a; //assign cust area parent div
                this.clear(this.area);
                this.area.find('[data-wph-key]').each(function () {
                    var v = i[jQuery(this).attr('data-wph-key')];
                    if (!v) return; //no value to assign
                    wph.unroll(jQuery(this), v);
                });
            },
            area: jQuery('.wph_cust_area')
        },
        unroll: function (i, v) { //i = input selector
//            i.removeAttr('checked'); //Reset radio and checkboxes
            if (v instanceof Array) { //check button with multi selections
                for (var x = 0; x < v.length; x++) {                    
                    i.filter('[value="' + v[x] + '"]').click();
                }
            } else {
                i.filter('[value="' + v + '"]').each(function () {
					$(this)[0].checked = true;//Check correct radio and checkboxes
				})
                i.not(':radio,:checkbox').val(v); //Feed select and text input fields
            }
        },

        roll: function (i, k) { //k= key to rep that val in obj
            i = $(i);
            var chk = ':checkbox,:radio';
            if (((i.is(chk)) && i[0].checked) || (!i.is(chk) && i.val() !== "" && i.val() !== undefined)) {
                var v = i.val();
                var o = {};
                o[k] = v;
                if (v !== undefined) return o;
            }
        },

        collect: function (a) {

            var o = {};

            $(a).find('[data-wph-key]').each(function () {

                var k = $(this).attr('data-wph-key');

                var r = wph.roll(this, k);

                if (r) {

                    if ($(this).is(':checkbox')) { //want array for multi selection

                        if (!o[k]) o[k] = [];

                        o[k].push(r[k]);

                    } else {

                        $.extend(o, r);

                    }

                }

            });

            return o;

        }

    }; 

})(jQuery);



var wmt_extend = {};

wmt_extend.blueprint = 

(function ($) {

	return {

		resize: {

			init: function () {

				$(this.key.selector).on('mousedown', this.mousedown).on('mouseup', this.mouseup);

				$('.wmt_blueprint_resize_op').on('mousedown', this.ops.hide);

			},

			mousedown : function () {				

				$(document).on('mousemove', wmt.blueprint.resize.mousemove);

				var  c = wmt.blueprint.resize,

						p = $(c.container.selector).offset(),

						t = $('.wmt_tile');

				c.container.left = p.left;

				c.container.top = p.top;

				c.key.width = $(c.key.selector).outerWidth();

				c.key.height = $(c.key.selector).outerHeight();

				c.tile.width = t.outerWidth(true);

				c.tile.height = t.outerHeight(true);

				$(c.container.selector).addClass('wmt_front');

			},

			mouseup: function () {

				var  c = wmt.blueprint.resize;

				$(document).off('mousemove', wmt.blueprint.resize.mousemove);

				wmt.blueprint.resize.ops.reveal();

				$('.wmt_blueprint_resize_op_confirm').mousedown(function () {

					c.ops.confirm();

				});

				$('.wmt_blueprint_resize_op_cancel').mousedown(function () {

					c.ops.cancel();

				});

			},

			mousemove: function (e) {

				var  x = e.pageX,

						y = e.pageY;

				wmt.blueprint.resize.position_key(x,y);

			},

			position_key: function (x,y) {

				var  c = wmt.blueprint.resize,

						k = c.key,

						key = $(k.selector),

						left = x - c.container.left,

						top = y - c.container.top;

				key.closest('.wmt_blueprint_resize_controller').css({'top': top- (.5*c.key.height)+'px', 'left': left- (.5*c.key.width)+'px'});

				c.resize_container();

			},

			legit: function (x,y) {

				var c = $(wmt.blueprint.resize.container.selector),

						t = c.offset().top,

						l = c.offset().left;

			},

			resize_container: function () {

				var  c = wmt.blueprint.resize,

						k = $(c.key.selector),

						width = parseInt(k.closest('.wmt_blueprint_resize_controller').css('left')),

						height = parseInt(k.closest('.wmt_blueprint_resize_controller').css('top'));

				$(c.container.selector).css({'width': width+'px', 'height':height+'px'});

			},

			conform : function () {

				var  c = wmt.blueprint.resize,

						m = $('.wmt_container'),

						w = m.width(),

						h = m.height(),

						k = c.key,

						cont = $(c.container.selector);

				cont.width(m.width()).height(m.height());

				$(k.selector).closest('.wmt_blueprint_resize_controller').css({'left': w+'px', 'top':h+'px'});
				
				wmt.blueprint.init_stick();

			},
			ops: {
				reveal:function () {
					var c = wmt.blueprint.resize;
							k = $(c.key.selector);
					k.closest('.wmt_blueprint_resize_controller').removeClass('wmt_limited');
				},
				hide: function () {
					var c = wmt.blueprint.resize;
							k = $(c.key.selector);
					k.closest('.wmt_blueprint_resize_controller').addClass('wmt_limited');
				},
				confirm:function () {
					var c = wmt.blueprint.resize,
							t = c.tile,
							t_w = t.width,
							t_h = t.height,
							cont = $(c.container.selector),
							c_w = cont.width(),
							c_h = cont.height(),
							cols = Math.ceil(c_w/t_w),
							rows = Math.ceil(c_h/t_h);
					$('.wmt_selDimsc').val(cols);
					$('.wmt_selDimsr').val(rows);
					$('.wmt_selDims').click();
					wmt.blueprint.resize.conform();
					$(c.container.selector).removeClass('wmt_front');
					$('.wmt_moveresize').remove();
					$('.wmt_reDimTile').removeClass('wmt_reDimTile');
				},
				cancel : function () {
					wmt.blueprint.resize.conform();
					var c = wmt.blueprint.resize;					
					$(c.container.selector).removeClass('wmt_front');
				}
			},

			key : {

				selector: '.wmt_blueprint_resize_container .wmt_resize',

				width: 30,

				height:30

			},

			container: {

				selector: '.wmt_blueprint_resize_container',

				left: 0,

				top:0

			},

			tile: {

				width: 50,

				height: 50

			}
		},

        init_stick : function () {
            var stick =  $('.wmt_blueprint_resizer_index');
            var cell_size =  [$('.wmt_tile').outerWidth(), $('.wmt_tile').outerHeight()],
					gaps = (cell_size[0] - 14)/2,
					total = 2 * (stick.height() / cell_size[0]),
					class_ ="",
					html = "";
					console.log("cell size: "+cell_size[0]);
            for (i=0; i<=total; i++) {
                class_ = (i%2 > 0) ? "wmt_remove_row fa fa-minus" : "wmt_add_row fa fa-plus";
                html += '<div class="'+class_+'" style="margin-bottom:'+gaps+'px;"></div>';
            }
            stick.html(html);
            
            $('body').on('mouseenter', '.wmt_add_row, .wmt_remove_row', function () {
                $('.wmt_tile').removeClass('wmt_remove_this_row wmt_add_row_below_this wmt_add_row_above_this');
				$('body').off('click', '.wmt_add_row').off('click', '.wmt_remove_row');
			
				/*Binding click handlers*/
				$('body').on('click', '.wmt_add_row', function () {
					var v = parseInt($('.wmt_selDimsr').val());
					$('.wmt_selDimsr').val(v+1);
					$('.wmt_selDims').click();
					wmt_impact($('.wmt_add_row_below_this:first').attr('data-wmt-row') * cell_size[0], cell_size[0], '+');
				}).on('click', '.wmt_remove_row', function () {
					wmt_impact($('.wmt_remove_this_row:first').attr('data-wmt-row') * cell_size[0], cell_size[0], '-');
					var v = parseInt($('.wmt_selDimsr').val());
					$('.wmt_selDimsr').val(v-1);
					$('.wmt_selDims').click();
				})
			
                if ($(this).hasClass('wmt_remove_row')) {
                    var target = $('.wmt_remove_row').index(this) +1;
                    $('[data-wmt-row="'+target+'"].wmt_tile').addClass('wmt_remove_this_row');
                } else {
                    var target = $('.wmt_add_row').index(this);
                    $('[data-wmt-row="'+target+'"].wmt_tile').addClass('wmt_add_row_below_this');                    
                    $('[data-wmt-row="'+(target+1)+'"].wmt_tile').addClass('wmt_add_row_above_this');
                };
            }).on('mouseleave', '.wmt_blueprint_resizer_index', function () {
                $('.wmt_tile').removeClass('wmt_remove_this_row wmt_add_row_below_this wmt_add_row_above_this');				
				$('body').off('click', '.wmt_add_row').off('click', '.wmt_remove_row');
			});
        }
	}

})(jQuery);

if (typeof wmt === 'undefined') var wmt = {};
jQuery.extend(wmt, wmt_extend);

var wmt_tool_tip_disabled = false;

//Tile Geometry

var wmt_tile_geometry_edit = {
	on : function (s) {
		if (s.hasClass('wmt_currentCombo') && s.hasClass('wmt_tile_geometry_edit_on')) return; //already editing it
		if (s.children('.wmt_slider').length) {//not on sliders
			alert('There is no tile editing on sliders');
			return;
		};
		if (s.siblings().hasClass('wmt_tile_geometry_edit_on')) {
			alert('Please close previous tile editor first by accpeting or reject changes.')
			return;
		};
		if (s.data('wmt')['set']['content-generation']==="automatic") {
			alert("Option not available for sets with automatically generated content. Instead, please use the tile settings panel to manage tile position and sizing.");
			return;
		}
		if (!s.find('.wmt_tileWrap').length) return;//no tiles or not yet loaded
		wmt_tool_tip_disabled = true;
//		s.removeClass('wmt_custCombo');
		jQuery('.wmt_TsetApplyAll').addClass('wmt_disabled');
		var _ = this;
		_.set = s.children('ul.wmt_tileSet');
		_.tiles = s.find('li.wmt_tileWrap');
		_.clone = _.set.clone(true, true);
		_.current_tile="";
		s.addClass('wmt_tile_geometry_edit_on').css('overflow','visible').children('ul.wmt_tileSet').append(_.html.tooltip).find('li.wmt_tileWrap').each(function () {
			jQuery(this).append(_.html.key);
		});
		s.addClass('wmt_force_overflow_auto').append(_.html.final_command);
		_.data = jQuery.extend(true, {}, jQuery('.wmt_tile_geometry_edit_on').data('wmt'));
		//current tile
		_.tiles.on('mouseenter', wmt_tile_geometry_edit.mark_current_tile);
		//tooltip
		_.tooltip.object  = s.find('.wmt_tile_geometry_tooltip');//jQuery tooltip object
		_.tiles.on('mouseenter', _.tooltip.position);//position
		_.tooltip.object.find('.fa-arrows-alt').on('mousedown', _.tooltip.moving.start)//move
																	.on('mouseup', _.tooltip.moving.stop);
		//width
		_.tooltip.object.find('.wmt_tg_width .wmt_tg_add').on('click', _.width.increase);
		_.tooltip.object.find('.wmt_tg_width .wmt_tg_subtract').on('click', _.width.decrease);
		//height
		_.tooltip.object.find('.wmt_tg_height .wmt_tg_add').on('click', _.height.increase);
		_.tooltip.object.find('.wmt_tg_height .wmt_tg_subtract').on('click', _.height.decrease);
		//accept/reject tabs
		_.tooltip.object.find('.wmt_tg_accept').on('click', _.accept);
		_.tooltip.object.find('.wmt_tg_reject').on('click', _.reject);
	},
	mark_current_tile: function () {
		wmt_tile_geometry_edit.current_tile = jQuery(this);
	},
	set : "",
	tiles: "",
	clone: "",
	data:{},
	current_tile: "",
	tooltip: {
		position: function () {
			var  _ =  wmt_tile_geometry_edit,
					t = jQuery(this),
					top = parseInt(t.css('top'))-100,
					left = parseInt(t.css('left'))+20,
					width = parseInt(t.outerWidth()),//not with margin
					height = parseInt(t.outerHeight()),//not with margin
					top = top+(height/2),
					left = left+(width/2);
			_.tooltip.object.css({'top': top, 'left':left, 'display':'inline-block'});
		},			
		object: "",
		moving: {
			hovered_position: "",
			start: function () {
				var _ = wmt_tile_geometry_edit;
				_.tooltip.moving.hovered_position = _.current_tile.index();
				_.set.on('mousemove', _.tooltip.moving.move);
				//constant offsets
				_.tooltip.moving.constant.top = _.set.offset().top;
				_.tooltip.moving.constant.left = _.set.offset().left;
				//set dimensions
				_.tooltip.moving.constant.set_width = _.set.outerWidth();
				_.tooltip.moving.constant.set_height = _.set.outerHeight();
				//refresh tile cache
				_.tiles = _.set.children('.wmt_tileWrap');
				//co-ordinates
				var gap = parseInt(_.set.attr('data-wmt-tile-gap'))/2;//offset to cover tile margins
				_.tooltip.moving.constant.coordinates = [];
				_.tiles.each(function (i) {
					var  t = jQuery(this),
							top = parseInt(t.css('top')),
							left = parseInt(t.css('left')),
							width = t.outerWidth(),
							height = t.outerHeight();
					_.tooltip.moving.constant.coordinates.push([[top - gap, left - gap], [top+height, left+width], i]);
				})
//				console.log('coordinates array');
//				console.log(_.tooltip.moving.constant.coordinates);
				//stop marking new current tiles
				_.tiles.off('mouseenter', _.mark_current_tile);
				
				console.log('_.tooltip.moving.constant');
				console.log(_.tooltip.moving.constant);
			},
			move: function (e) {
				var  _ = wmt_tile_geometry_edit,
						left = e.pageX - _.tooltip.moving.constant.left + 20,
						top = e.pageY - _.tooltip.moving.constant.top - 100;
				//Top limit
				if (top < -85) top = -85;
				if (top > (_.tooltip.moving.constant.set_height -120)) top = _.tooltip.moving.constant.set_height -120;
				//Left limit
				if (left < 35) left = 35;
				if (left > _.tooltip.moving.constant.set_width) left = _.tooltip.moving.constant.set_width;
				_.tooltip.object.css({'left':left+'px', 'top':top+'px'});//move tile tool
		
				left = e.pageX - _.tooltip.moving.constant.left,
				top = e.pageY - _.tooltip.moving.constant.top;

				//Locate currently hovered tile
				var  arr = _.tooltip.moving.constant.coordinates,
						c = arr.length;
				for (var i=0; i<c; i++ ) {
					if (arr[i][0][0]<=top && arr[i][0][1]<=left && arr[i][1][0]>=top && arr[i][1][1]>=left) _.tooltip.moving.hovered_position = arr[i][2];
				}
				if (_.tooltip.moving.hovered_position === false) _.tooltip.moving.hovered_position = c-1; //blank area left after packaging
				if (!_.current_tile) _.current_tile = _.tiles.eq(_.tooltip.moving.hovered_position);
//				console.log('hovered position');
//				console.log(_.tooltip.moving.hovered_position);
			},
			stop: function (e) {//applies the 'move' changes
				var  _ = wmt_tile_geometry_edit,
						new_pos = (_.tooltip.moving.hovered_position <0 || _.tooltip.moving.hovered_position > (_.tiles.length-1)) ? _.tiles.length - 1 : _.tooltip.moving.hovered_position,
						prev_pos = _.current_tile.index();
				_.tiles.on('mouseenter', _.mark_current_tile);
				console.log('new_pos: ' + new_pos);
				if (new_pos !== prev_pos) {
					tile = _.current_tile.detach();
					if (new_pos < prev_pos) tile.insertBefore(_.tiles.eq(_.tooltip.moving.hovered_position));
					else tile.insertAfter(_.tiles.eq(_.tooltip.moving.hovered_position));
					_.refit();
					//reflect changes in data
					var  cache_1= _.data['tiles'][new_pos],
							cache_2={},
							new_pos_copy = new_pos,
							prev_pos_copy= _.data['tiles'][prev_pos];

					if (new_pos > prev_pos) {
						while (new_pos > prev_pos) {//pulling tile down the dom
							cache_2 = _.data['tiles'][new_pos-1];
							_.data['tiles'][new_pos-1] = cache_1;
							cache_1 = cache_2;
							--new_pos;
						}
					} else {
						while (new_pos < prev_pos) {//pushing tile up the dom
							cache_2 = _.data['tiles'][new_pos+1];
							_.data['tiles'][new_pos+1] = cache_1;
							cache_1 = cache_2;
							++new_pos;
						}
					}
					_.data['tiles'][new_pos_copy] = prev_pos_copy;

				}
				_.tiles = jQuery('.wmt_tile_geometry_edit_on').find('li.wmt_tileWrap');					
				_.set.off('mousemove', _.tooltip.moving.move);
			},
			constant: {
				top: 0,
				left: 0,
				width: 0,
				height: 0
			}
		}
	},
	html: {
			key: '<div class="wmt_tile_geometry_edit_cover"><div class="wmt_tile_geometry_edit_key fa fa-cog"></div></div>',

			tooltip:'<div class="wmt_tile_geometry_tooltip"><div class="wmt_tg_width"><span class="wmt_tg_label">Width:</span> <span class="wmt_tg_add">+</span><span class="wmt_tg_subtract">-</span> </div><div class="wmt_tg_height"><span class="wmt_tg_label">Height:</span><span class="wmt_tg_add">+</span><span class="wmt_tg_subtract">-</span></div><div class="wmt_tg_move"><span class="fa fa-arrows-alt"></span><span class="wmt_tg_label">Drag and Move</span></div><div class="wmt_tg_confirm"><span class="wmt_tg_label">Accept:</span> <span class="wmt_tg_accept fa fa-check"></span><span class="wmt_tg_reject fa fa-times"></span> </div></div>'

	},

	accept: function () {

		//implement changes on data

		var  _ = wmt_tile_geometry_edit,

				s = _.set.parent();

		s.data('wmt', _.data);

		s.removeClass('wmt_force_overflow_auto').find('li.wmt_tileWrap').off('mouseenter', _.mark_current_tile).off('mouseenter', _.tooltip.position).find('.wmt_tile_geometry_edit_cover').remove();

		_.set.off('mousemove', _.tooltip.moving.move);

		s.find('.wmt_tile_geometry_tooltip').remove();

		wmt_tool_tip_disabled = false;

		jQuery('.wmt_TsetApplyAll').removeClass('wmt_disabled');

		if (s.hasClass('wmt_custCombo')) {

			wmt_scroll_permission = false;

			s.removeClass('wmt_custCombo');

			jQuery('.wmt_tileToolCUSTOMIZE').click();

		}



		s.removeClass('wmt_tile_geometry_edit_on');

	},

	reject: function () {

		//return tiles to previous state

		var  _ = wmt_tile_geometry_edit,

				s = _.set.parent();

		_.set.html(_.clone);

		s.removeClass('wmt_force_overflow_auto').find('.wmt_tile_geometry_tooltip').remove();

		_.set.off('mousemove', _.tooltip.moving.move);

		wmt_tool_tip_disabled = false;

		jQuery('.wmt_TsetApplyAll').removeClass('wmt_disabled');

		s.removeClass('wmt_tile_geometry_edit_on');

	},

	width: {

		increase: function () {

			var  _ = wmt_tile_geometry_edit,

					index = _.current_tile.index();

			if (!_.data['tiles'][index]['overall']['style']['relative-width']) _.data['tiles'][index]['overall']['style']['relative-width'] = 1;

			if (parseInt(_.data['tiles'][index]['overall']['style']['relative-width']) > 6) return;

			_.data['tiles'][index]['overall']['style']['relative-width'] = parseInt(_.data['tiles'][index]['overall']['style']['relative-width']) + 1;

			_.current_tile.attr('data-wmt-relative-width', _.data['tiles'][index]['overall']['style']['relative-width']);

			_.refit();

		},

		decrease: function () {

			var  _ = wmt_tile_geometry_edit,

					index = _.current_tile.index();

			if (!_.data['tiles'][index]['overall']['style']['relative-width']) _.data['tiles'][index]['overall']['style']['relative-width'] = 1;

			if (parseInt(_.data['tiles'][index]['overall']['style']['relative-width']) === 1) return;

			_.data['tiles'][index]['overall']['style']['relative-width'] = parseInt(_.data['tiles'][index]['overall']['style']['relative-width']) - 1;

			_.current_tile.attr('data-wmt-relative-width', _.data['tiles'][index]['overall']['style']['relative-width']);

			_.refit();

		}

	},

	height: {

		increase: function () {

			var  _ = wmt_tile_geometry_edit,

					index = _.current_tile.index();

			if (!_.data['tiles'][index]['overall']['style']['relative-height']) _.data['tiles'][index]['overall']['style']['relative-height'] = 1;

			if (parseInt(_.data['tiles'][index]['overall']['style']['relative-height']) > 6) return;

			_.data['tiles'][index]['overall']['style']['relative-height'] = parseInt(_.data['tiles'][index]['overall']['style']['relative-height']) + 1;

			_.current_tile.attr('data-wmt-relative-height', _.data['tiles'][index]['overall']['style']['relative-height']);

			_.refit();

		},

		decrease: function () {

			var  _ = wmt_tile_geometry_edit,

					index = _.current_tile.index();

			if (!_.data['tiles'][index]['overall']['style']['relative-height']) _.data['tiles'][index]['overall']['style']['relative-height'] = 1;

			if (parseInt(_.data['tiles'][index]['overall']['style']['relative-height']) === 1) return;

			_.data['tiles'][index]['overall']['style']['relative-height'] = parseInt(_.data['tiles'][index]['overall']['style']['relative-height']) - 1;

			_.current_tile.attr('data-wmt-relative-height', _.data['tiles'][index]['overall']['style']['relative-height']);

			_.refit();
		}
	},

	refit : function () {
		var _ = wmt_tile_geometry_edit;
		wmt_responsive_packaging(wmt_tile_geometry_edit.set, "admin");
		wmt_tile_geometry_edit.set.find('.wmt_tileImage').children().each(function () {
			wmt_center_image (this);
		});
		wmt_tile_geometry_edit.tiles = wmt_tile_geometry_edit.set.find('li.wmt_tileWrap');//refresh cache
	}
}


var wmt_impact = //Impact
(function($){
	return function (origin, dis, dir) {//displacement, direction
		if (!origin) origin = -1;
		$('.wmt_combined').each(function () {
			var t = $(this);
			if (parseInt(t.css('top')) > origin) {
				t.css('top', dir+'='+dis+'px');
				//shift extended background
				if (t.children('.wmt_tileSet').length && t.children('.wmt_tileSet').hasClass('wmt_full_width_bg')) {
					var combo = t.attr('data-wmt-combo'); 
					t.siblings('.wmt_full_width_bg[data-wmt-associated-combo="'+combo+'"]').css('top', dir+'='+dis+'px');
				}
				//shift its locked tiles
				var  combo = t.attr('data-wmt-combo'),
						cells = $('.wmt_tile.wmt_lockedSet'+combo),
						first_col = cells.first().attr('data-wmt-col'),
						last_col = cells.last().attr('data-wmt-col'),
						first_row = cells.first().attr('data-wmt-row'),
						last_row = cells.last().attr('data-wmt-row');
				
				if (dir === "+") {
					cells.slice(0, (last_col-first_col)+1).each(function () {
						$(this).removeClass('wmt_lockedSet'+combo+' wmt_lockedTile');
					});
					cells.slice(first_col-last_col-1).each(function () {
						$('.wmt_tile[data-wmt-col="'+$(this).attr('data-wmt-col')+'"][data-wmt-row="'+(parseInt($(this).attr('data-wmt-row')) + 1)+'"]').addClass('wmt_lockedSet'+combo+' wmt_lockedTile');
					});
				} else {
					cells.slice(0, (last_col-first_col)+1).each(function () {
						$('.wmt_tile[data-wmt-col="'+$(this).attr('data-wmt-col')+'"][data-wmt-row="'+(parseInt($(this).attr('data-wmt-row')) - 1)+'"]').addClass('wmt_lockedSet'+combo+' wmt_lockedTile');
					});
					cells.slice(first_col-last_col-1).each(function () {
						$(this).removeClass('wmt_lockedSet'+combo+' wmt_lockedTile');
					});
				}
				wmt_update_set_pos_data (t);
			}
		})
	}

})(jQuery);
