var wmt_chrome = navigator.userAgent.toLowerCase().indexOf('chrome') > -1,
		wmt_safari = /Safari/.test(navigator.userAgent) && /Apple Computer/.test(navigator.vendor),
		wmt_webkit = (wmt_chrome || wmt_safari) ? true : false,
		wmt_iPad = navigator.userAgent.match(/iPad/i) != null,
		wmt_firefox = navigator.userAgent.toLowerCase().indexOf('firefox') > -1;

/*---Center Images---*/
function wmt_center_image (th) {
	var  i=jQuery(th),
			fitting = i.closest('.wmt_tileImages').attr('data-wmt-image-fitting'),
			c=i.parent('.wmt_tileImage'),
			spl='wmt_imgTreat',
			icon = i.hasClass('fa'),//true/false
			p = parseInt(i.css('padding-left'));
	
	if(i.is('canvas')) i.addClass(spl);//brings to natural dimensions
	if(i.hasClass('fa')) i.css({'width': '' , 'height': '', 'font-size':'200px'}).parent().css({'text-align':'center', 'line-height':'1em'});//font awesome
	var  cw = c.width(),
			ch = c.height(),
			iw = i.attr('data-wmt-width') || i[0].naturalWidth|| i.width(),
			ih = i.attr('data-wmt-height') || i[0].naturalHeight || i.height(),
			cr= (cw/ch).toFixed(8),
			ir= (iw/ih).toFixed(8);
//				console.log('ir: '+ir+' cw: '+cw + ' ch:'+ch+' iw: '+iw+' ih: '+ih+ ' p:'+p);
	if (cr>ir) {//horizontal capping - image proportionately taller, vertical overflow permitted?
		if(i.is('canvas') || icon) i.removeClass(spl).addClass('wmt_icon_prop_wider');
		if (icon) {//respect padding
			p = parseInt(i.css('padding-top'));
			if (!p) p =0;
			i.css({'font-size': ch-(2*p) + 'px'});
			return;
		}
		var ih = (cw / ir).toFixed(3);
		if (fitting === "contain") i.css({'height':'100%', 'width':'auto', 'margin-top':0});
		else i.css({'max-width':'100%', 'max-height':'none', 'height':ih+'px', 'width':'100%', 'margin-left':0, 'margin-top':parseInt((parseInt(ch)-parseInt(ih))/2) });
	} else if (ir>cr) {//vertical capping - image proportionately wider, horizontal overflow permitted?
		if(i.is('canvas') || icon) i.removeClass(spl).addClass('wmt_icon_prop_taller');
		if (icon) {//icon should be contained within instead of peeping out
			p = parseInt(i.css('padding-left'));
			if (!p) p =0;
			i.css({'font-size': (cw-(2*p))/(i.width() /i.height()) +'px'});
			return;
		}
		var iw = ch * ir;
		if (fitting === "contain") {
			i.css({'height':'auto', 'width':'100%'});
			i.css('margin-top',((i.parent().height() - i.height())/2) + 'px');
		}
		else i.css({'max-width':'none', 'max-height':'100%', 'height':'100%', 'width':iw+'px', 'margin-top':0, 'margin-left':parseInt((parseInt(cw)-parseInt(iw))/2) });
	} else {
		if(i.is('canvas') || icon) i.removeClass(spl).addClass('wmt_icon_prop_equal');
		if (icon) {//icon should be contained within instead of peeping out
			p = parseInt(i.css('padding-left'));
			if (!p) p =0;
			i.css({'font-size': (cw-(2*p))/(i.width() /i.height()) +'px'});
			return;
		}
		var iw = ch * ir;
		i.css({'max-width':'none', 'max-height':'100%', 'height':'100%', 'width':iw+'px', 'margin':0});
	};
	
	//Apply fx
	setTimeout(function () {
		if (wmt_mobile || wmt_safari || wmt_chrome || wmt_iPad) {
			return;
		} else {
			if (i.is('canvas') || !i[0].naturalHeight) return;
			if (i[0].naturalHeight < i.attr('data-wmt-height') || !i.height()) {
				i.load(function () {
					wmt_image_fx (i);
				});
			} else {
				wmt_image_fx (i);
			}
		}	
	}, 1);
}

function wmt_image_fx (i) {
	if (!wmt_mobile && !i.hasClass('fa') && !wmt_chrome && !i.closest('.wmt_container_front_end').hasClass('wmt_tiles_squeezed')) {
		var pop = i.parent();
		if (pop.hasClass('wmt_tileImageHover') && pop.siblings('.wmt_tileImageMain').hasClass('wmt_blur_image')) {//Blur
			i.pixastic("blurfast", {amount:0.2});
		};
		if (pop.hasClass('wmt_grayscale_image')) {//Grayscale
			i.pixastic('desaturate');
		};
	}
	i.parent().removeClass('wmt_ImageChanging');//paj related
}

/*---Fit Text---*/
var wmt_fit_text = {
	fit: function (s, type) {//s could be an element or tile
		if (s.hasClass('wmt_image_a') || s.hasClass('wmt_focus_d')) return;
		var  _ = this,
				$ = jQuery,
				done = false;
		s.addClass('wmt_force_overflow_visible');
		_.elems = s.hasClass('wmt_tileWrap')? s.find('.wmt_title, .wmt_tagline, .wmt_description').filter(':visible') : s;
		if (_.elems.length == 0) {
			s.removeClass('wmt_force_overflow_visible');
			return;
		}
		_.elems.each(function () {
			if (!$(this).attr('data-wmt-style-original')) $(this).attr('data-wmt-style-original', JSON.stringify({'font-size' : $(this).css('font-size'), 'line-height' : $(this).css('line-height')})); //original styles must be retained
			if ($(this).attr('data-wmt-style-'+type)) {
				$(this).css(JSON.parse($(this).attr('data-wmt-style-'+type)));
				done = true;
				return;
			} else {
				var s = $(this).attr('data-wmt-style-original') ? JSON.parse($(this).attr('data-wmt-style-original')) : false;
				if (!s) s = {'font-size': $(this).css('font-size'), 'line-height': $(this).css('line-height')};
				$(this).attr('data-wmt-style-original', JSON.stringify(s));
				$(this).css(s);
			}
		})
		if (!done && !_.check(s)) {
			var attempt = 0;			
			while (!_.check(s) && attempt < 20) {
				_.shrink(_.elems);
				attempt++;
			};
		}
		s.removeClass('wmt_force_overflow_visible');
	},
	check: function (s) {
        var  sh = s[0].scrollHeight,
				ch = s[0].clientHeight;
        if (sh > ch) return false;
		else return true;
	},
	elems : {},//elements that should be affected during shrinking
	shrink: function (s) {
		s.each(function () {
			var font_size = parseInt(jQuery(this).css('font-size')) -.5,//weirdness to appease chrome
					lineHeight = parseInt(jQuery(this).css('line-height'));
//			console.log('font_size');
//			console.log(font_size);
			font_size = (font_size > 10 ? font_size -.5: font_size);
			lineHeight = (lineHeight > 10 && (lineHeight > (1.2 *font_size))) ? (lineHeight - .5) : (1.2 *font_size);
			jQuery(this).css({'font-size':font_size+'px', 'line-height':lineHeight+'px'});
		})
	}
};

/*---Fit Set---*/
//This is the 'pre-justification' phase of resizing tiles. Widths and heights are determined here.
function wmt_fitSet (ul, cond) {
	
	ul = jQuery(ul);
	var tiles_per_row = false;
	if (ul.attr('data-wmt-media-query-rules')) {
		var 	doc_width = parseInt(document.body.scrollWidth),
				rules = JSON.parse(ul.attr('data-wmt-media-query-rules')),//array
				tile_height = false;
				
		jQuery.each(rules, function (index, value) {//value is an object
			if ((value['page-width'] < doc_width && value['apply-rule-when'] === "above") || (value['page-width'] >= doc_width && value['apply-rule-when'] === "below")) {
				if (value['tile-height']) tile_height = value['tile-height'];
				if (value['tiles-per-row']) tiles_per_row = value['tiles-per-row'];
			}
		})
	}

	var  ul = cond? jQuery(ul) : jQuery(ul).height(''), //refers to ul.wmt_tileSet
			tx = ul.siblings('.wmt_set_title_tile'),//title
			txh = tx.outerHeight(true),
			nx = ul.siblings('.wmt_arrow'),//slider nav arrows
			nxh = nx.outerHeight(true),
			fx = ul.siblings('.wmt_set_filters'),//filter
			fxh = fx.outerHeight(true),
			sh = ul.parent().height() - txh - fxh - nxh;//set height

	ul.height(sh);

	if (ul.attr('data-wmt-media-query-rules') && typeof wmt_canvas === "undefined") ul.parent().height('auto');
	
	if (tiles_per_row && typeof wmt_canvas === "undefined") cond = false;
	wmt_responsive_packaging (ul, cond, tiles_per_row, tile_height);
	
	//tile elements special dimensions
	ul.find('.wmt_tileWrap').each(function () {
		wmt_tile_elem_size_primer(jQuery(this));	
	});
	
	//center images
	ul.find('.wmt_tileImage>*').each(function () {
		wmt_center_image (this);
		jQuery(this).load(function () {
			wmt_center_image (this);
		})
	});
}

/*---LightBox---*/
function wmt_magnific_call (x) {
	//Give lightbox divs to their tiles via ids
	var wmt_lightbox_id = 0;
	var sel = x? x.find('.wmt_lightbox') : jQuery('.wmt_lightbox');
	sel.each(function () {
		var t = jQuery(this),
		id = 'wmt_lightbox_id_'+wmt_lightbox_id;
		t.attr('id', id);
		t.closest('.wmt_tileWrap').attr('data-mfp-src','#'+id);
//			t.append('<span style="color:white;">'+wmt_lightbox_id+'</span>');
		wmt_lightbox_id++;
	});
	//Magnific
	jQuery('.wmt_lightbox_gallery').removeClass('wmt_lightbox_gallery');
	jQuery('.wmt_lightbox').closest('.wmt_tileSet').addClass('wmt_lightbox_gallery');

	jQuery('.wmt_lightbox_gallery').each(function () {
		jQuery(this).magnificPopup({
//				delegate: '.wmt_tileWrap',
			delegate: 'a[href="wmt_lightbox"]',
			gallery:{enabled:true},
			preloader: true,
			tClose: 'Close (Esc)',
			tLoading: 'Loading...',
			callbacks: {
				change: function () { //changes inside document's lightbox element. Needs to be wiped clean
					var  s = jQuery(this.currItem.el), //source
							t = jQuery(this.content),//target
							close='<div class="mfp-close wmt_lightbox_close fa fa-times"></div>', img = "", title= "", tagline="",description="",text="",entire="";
					if (s.find('.wmt_lightbox[data-wmt-lightbox-video]').length === 0) {//proceed if its not a video lightbox
						t.attr('data-wmt-lightbox-image') !== undefined ? img = '<img class="wmt_lightbox_image" src="'+t.attr('data-wmt-lightbox-image')+'" >' : img = "";
						//prepare text
						var d = t.attr('data-wmt-lightbox-display');
						if (d) {
							(d.indexOf('title') !== -1 && s.find('.wmt_title').length > 0) ? text+= '<h2 class="wmt_lightbox_title">'+s.find('.wmt_title').text()+'</h2>' : title = '';
							(d.indexOf('tagline') !== -1 && s.find('.wmt_tagline').length > 0) ? text+= '<h3 class="wmt_lightbox_tagline">'+s.find('.wmt_tagline').text()+'</h2>' : tagline = '';
							(d.indexOf('description') !== -1 && s.find('.wmt_description').length > 0) ? text+= '<p class="wmt_lightbox_description">'+s.find('.wmt_description').text()+'</p>' : description = '';
							(d.indexOf('links') !== -1 && s.find('.wmt_link').length > 0) ? text+= '<div class="wmt_lightbox_links">'+s.find('.wmt_link').html()+'</div>' : description = '';
						}
						if (text !== "") text = '<div class="wmt_lightbox_text_key fa fa-ellipsis-h"></div><div class="wmt_lightbox_text">'+text+'</div>';
						entire = close+img+text;
						t.html(entire).find('[data-wmt-link="wmt_lightbox"]').remove();
						//if (!t.find('img').length) -> code for icon
						t.find('img').load(function () {
							var th = jQuery(this);
							th.closest('.wmt_lightbox_img_loading').removeClass('wmt_lightbox_img_loading');
						});
					}
				},
				elementParse: function(item) {
					item.el = item.el.parents('.wmt_tileWrap'); //changes the this.currItem.el in 'change' callback fn
					if (item.el.find('.wmt_lightbox[data-wmt-lightbox-video]').length) {
						item.type = "iframe";
						item.src = item.el.find('.wmt_lightbox').attr('data-wmt-lightbox-video') || "http://www.youtube.com/watch?v=7HKoqNJtMTQ";
					}else {
						item.src = item.el.find('.wmt_lightbox');//items.src had already been parsed before, so we must define a new one
					};
//					console.log('Parsing content. Item object that is being parsed:', item);
				},
				open : function () {
					if (!jQuery('.mfp-bg').length) alert('there is no lightbox backfround right now!');
					var  s = jQuery(this.currItem.el), //source
							t = jQuery(this.content);//target
					//styling the background
					jQuery('.mfp-bg').css({'opacity':t.attr('data-wmt-lightbox-bg-op'), 'background-color':t.attr('data-wmt-lightbox-bg-color') ? t.attr('data-wmt-lightbox-bg-color'): black, 'background-image':'url(\''+t.attr('data-wmt-lightbox-bg-image')+'\')' });								
				}
			},
			gallery: {
				enabled:true
			},
			iframe: {
			  markup: '<div class="mfp-iframe-scaler">'+
						'<div class="mfp-close"></div>'+
						'<iframe class="mfp-iframe" frameborder="0" allowfullscreen></iframe>'+
					  '</div>', // HTML markup of popup, `mfp-close` will be replaced by the close button

				  patterns: {
					 dailymotion: {
					   
						index: 'dailymotion.com',
						
						id: function(url) {        
							var m = url.match(/^.+dailymotion.com\/(video|hub)\/([^_]+)[^#]*(#video=([^_&]+))?/);
							if (m !== null) {
								if(m[4] !== undefined) {
								  
									return m[4];
								}
								return m[2];
							}
							return null;
						},
						
						src: 'http://www.dailymotion.com/embed/video/%id%'
						
					  }
				  },

			  srcAction: 'iframe_src', // Templating object key. First part defines CSS selector, second attribute. "iframe_src" means: find "iframe" and set attribute "src".
			}
		});
	});		
	
};

//These functions turn code from html from php into an actual tuned up set
function wmt_init_set (t, r) {
	t.removeClass('wmt_post_init').addClass('wmt_during_init');	
	//Feed the ajax returned HTML to current combo
	if (r) t.html(r['set-html']);
	var  ul = t.find('.wmt_tileSet');
	//Resize-set outer container		
	var  w = t.attr('data-wmt-width') ? parseInt(t.attr('data-wmt-width')) : t.css('width'),//front-end or admin
			h = t.attr('data-wmt-height') ? parseInt(t.attr('data-wmt-height')) : t.css('height'),
			s = ul.attr('data-wmt-style') ? JSON.parse(ul.attr('data-wmt-style')) : '',
			o = {//neutralizes set's overall settings
				'padding-top' : 0,
				'padding-bottom' : 0,
				'padding-left' : 0,
				'padding-right' : 0,
				'background-image' : "none",
				'background-color' : "transparent",
				'overflow':'visible',
				'z-index':'auto',
				'border-color':'transparent',
				'border-top-width' : 0,
				'border-right-width' : 0,
				'border-left-width' : 0,
				'border-bottom-width' : 0,
				'border-top-left-radius' : 0,
				'border-top-right-radius' : 0,
				'border-bottom-left-radius' : 0,
				'border-bottom-right-radius' : 0,
				'border-style' : 'solid'
			},
			c = (ul.attr('data-wmt-appear') && !wmt_mobile) ? 'wmt_appear' : '',
			cls = (ul.attr('data-wmt-custom-class')) ? ul.attr('data-wmt-custom-class') : '',//#prev classes
			d = (ul.attr('data-wmt-appear') && !wmt_mobile) ? ul.attr('data-wmt-appear') : '';
	
	jQuery.extend(o,s);
	if (r) t.css(o).addClass(c).attr('data-wmt-appear', d);

	//Slider
	if (ul.hasClass('wmt_slider')) {
		t.wmt_unslider();
		t.css('overflow', 'hidden');
	//Refit tiles
	} else {
		var condition = (typeof wmt_canvas === "undefined") ?  "flex" : "admin";
		ul.each(function () {
			if (wmt_mobile) jQuery(this).addClass('wmt_set_squeezed wmt_tiles_squeezed wmt_set_squeezed_beyond_flex');
			else wmt_fitSet (this, condition);//refit set with rigid height
		})
	}
	
	//Inner tile tuning
	ul.find('.wmt_tileWrap').each(function () {
		var th = jQuery(this);
		//Fix dimensions for elements
		wmt_tile_elem_size_primer(th);
	})
	
	//Lightbox
	wmt_magnific_call();
	
	//Center images
	ul.find('.wmt_tileImage').children().each(function () {
		wmt_center_image(this);
	})
	
	//Pagination
	if (typeof wmt_canvas !== "undefined") wmt_pajInit();
	else wmt_pajInit(t);
	
	//Appear animation
	jQuery('.wmt_appear').appear();
	jQuery('body').on('appear', '.wmt_appear', function () {
		var  t = jQuery(this),
				c = t.attr('data-wmt-appear');
		if (!wmt_mobile) t.addClass(c+ ' wmt_animation_over').removeClass('wmt_appear');
	});
	if (r) jQuery.force_appear();//check if ready to appear if on admin

	//Full width background
	if (typeof wmt_admin !== 'undefined') wmt_full_width_bg();
	t.addClass('wmt_post_init').removeClass('wmt_during_init');
}

//Full width bg
function wmt_full_width_bg () {
	var $ = jQuery;
	$('div.wmt_full_width_bg').remove();
	$('ul.wmt_full_width_bg').each(function () {
		var  ul = $(this),
				set = $(this).parent(),
				combo = set.attr('data-wmt-combo'),
				bg_img = ul.attr('data-wmt-bg-image'),
				bg_color = ul.attr('data-wmt-bg-color'),
				extend_up = ul.attr('data-wmt-background-extension-upwards') && !wmt_mobile ? parseInt(ul.attr('data-wmt-background-extension-upwards')) : 0,
				extend_down = ul.attr('data-wmt-background-extension-downwards') && !wmt_mobile? parseInt(ul.attr('data-wmt-background-extension-downwards')) : 0,
				container = set.parent(),
				beyond_flex = container.hasClass('wmt_grid_squeezed_beyond_flex') ? true : false,
				height = 0,
				top = set.offset().top - container.offset().top,
				use_top = top,
				bottom = top + set.outerHeight(),
				use_bottom = bottom;
		//supposed to be responsible for others
		if ($(this).attr('data-wmt-background-cover-siblings')) {
			var  receivers = [],
					original_top = top,
					use_top = top = beyond_flex ? top : top - extend_up,
					original_bottom = bottom,
					use_bottom = bottom = beyond_flex ? bottom : bottom + extend_down,
					extend_up_more = false,
					extend_down_more = false;
					
			//Admin
			if (typeof wmt_admin !== 'undefined') {
				var  _data = set.data('wmt');
				//create list of siblings to be covered
				set.parent().children('.wmt_combined').each(function (index) {
					var  _ = $(this),
							_top = parseInt(_.css('top')),
							_bottom = _top + _.outerHeight(true);
					if (_bottom > top && _top < bottom) {
						receivers.push(index);
						if (_top < top) use_top = _top, extend_up_more = true;
						if (_bottom > bottom) use_bottom = _bottom, extend_down_more = true;
					}
				})
				//modify data object
				_data['set']['data']['background-cover-siblings'] = (receivers.length ? receivers.join() : "");
				set.data('wmt', _data);
			//Front End
			} else {
				//via offsets check the limits that need to be covered based on the siblings already known
				receivers = $(this).attr('data-wmt-background-cover-siblings').split(",");
				for (var i = 0, length = receivers.length, index=0; i < length; i++) {
					index = receivers[i];
					container.children('.wmt_combined').eq(index).each(function (index) {
						var  _ = $(this),
								_top = _.offset().top - container.offset().top,
								_bottom = _top + (wmt_mobile ? _.outerHeight() : _.outerHeight(true));//on mobile, margin will be cancelled
						if (_top < use_top) use_top = _top, extend_up_more = true;
						if (_bottom > use_bottom) use_bottom = _bottom, extend_down_more = true;
					});
				};
			}
			
			if (extend_up_more) {
				use_top = use_top - extend_up;
//				console.log('extend up more');
			}
			if (extend_down_more) {
				use_bottom = use_bottom + extend_down;
//				console.log('extend down more');
			}
		} else {
			if (!beyond_flex && !wmt_mobile) {
				use_bottom = use_bottom + extend_down;
				use_top = use_top - extend_up;
			}
		}
		height = use_bottom-use_top;		
		var  style = ul.attr('data-wmt-extended-bg-style-normal') ? JSON.parse(ul.attr('data-wmt-extended-bg-style-normal')) : "";
		//use collected style data to construct background
		var bg = '<div class="wmt_full_width_bg" style="top:'+use_top+'px; left:-'+(set.parent().offset().left)+'px; width:'+(document.body.scrollWidth)+'px; height:'+height+'px; background-image:'+bg_img+'; background-color:'+bg_color+';" data-wmt-associated-combo="'+combo+'"></div>';
		bg.replace(/"/g, '\\"');
		bg = $(bg);
		//append background to the design container
		set.parent().prepend(bg);
		bg.css(style);
		//compensate for borders
		if (typeof style === "object") {
			var  vert_borders = parseInt(style['border-top-width'] ? style['border-top-width'] : 0) + parseInt(style['border-bottom-width'] ? style['border-bottom-width'] : 0),
					horiz_borders = parseInt(style['border-left-width'] ? style['border-left-width'] : 0) + parseInt(style['border-right-width'] ? style['border-right-width'] : 0);
			bg.css({'height':'-='+vert_borders+'px', 'width':'-='+horiz_borders+'px'});
		}
	})
}

function wmt_force_full_width_set (set) {
	var $ = jQuery;
	set.css({'left': '-'+set.parent().offset().left+'px', 'width': document.body.scrollWidth});
}

//sizing
function wmt_tile_elem_size_primer(t) {
	if (wmt_mobile) return;

	//Roundify
	if (t.hasClass('wmt_roundify') && !t.parent().hasClass('wmt_set_squeezed_beyond_flex')) {
		var  w = t.outerWidth(),
				h = t.outerHeight();
		if (w>h) {
			var diff = w - h;
			t.outerWidth(h).css('left','+='+(diff/2));
		} else if (h>w){
			var diff = h - w;
			t.outerHeight(w).css('top','+='+(diff/2));
		}
	}
	
	//Image
	var img = true;
	if (!t.find('.wmt_tileImage').length) {
		t.addClass('wmt_no_image').find('.wmt_tileImages').remove();
		img = false;
	}
	
	//Special Needs
	if (!t.find('.wmt_description:visible').length) t.addClass('wmt_no_description');
	if (!t.find('.wmt_title:visible').length) t.addClass('wmt_no_title');
	if (!t.find('.wmt_tagline:visible').length) t.addClass('wmt_no_tagline');

	if (t.find('.wmt_description')) {
		var para = t.find('.wmt_description p');
		if (para.length === 1) 
		para.css('margin', 0);
	}
	
	if (t.hasClass('wmt_no_description') && t.hasClass('wmt_focus_c')) {
		t.removeClass('wmt_animate');
	}

	if (t.hasClass('wmt_focus_b')) {
		t.find('.wmt_description').height('auto');
	}
	
	if (t.hasClass('wmt_focus_a')) {
		var h = t.innerHeight() - t.find('.wmt_cover').outerHeight();
		t.find('.wmt_hide_vert').children().outerHeight(h);
	}

	if(t.hasClass('wmt_button') && !img && !t.hasClass('wmt_button_d')) {
		t.find('.wmt_textGroup').addClass('wmt_center_v').css('bottom','auto');
	}
	
	if ((t.hasClass('wmt_button_a') || t.hasClass('wmt_button_e')) && img && t.find('.wmt_textGroup').length) {
		var style = t.find(".wmt_tileImages").attr('data-wmt-style-normal');
		if (style) style = JSON.parse(style);
		if (style.height) t.find(".wmt_tileImages").removeClass('wmt_adjust_chump').addClass('wmt_adjust_boss')
								.siblings('.wmt_textGroup').removeClass('wmt_adjust_boss').addClass('wmt_adjust_chump');
	}

	if (t.hasClass('wmt_button_d') && (t.find('.wmt_title, .wmt_tagline').length) && !wmt_mobile) {
		t.find('.wmt_main_content, .wmt_title, .wmt_tagline, .wmt_link').width('');
		var h = t.find('.wmt_title').outerHeight(true) + t.find('.wmt_tagline').outerHeight(true) + t.find('.wmt_link').outerHeight(true);
		t.find('.wmt_tileImages').css({'height': h+'px' , 'width': h+'px' });
		var  w = t.width(),
				hw = Math.max(t.find('.wmt_title').outerWidth(true), t.find('.wmt_tagline').outerWidth(true), t.find('.wmt_link').outerWidth(true)),
				hw = hw+(hw/50),//font adjustment
				tw = hw + (img ? h : 0);
		t.find('.wmt_main_content').css({'width': tw+'px'});
//		t.find('.wmt_title, .wmt_tagline, .wmt_link').css({'width': hw+'px'});
	}
	
	if (t.hasClass('wmt_notice')) {
		if (t.hasClass('wmt_no_description')) {
			t.find('.wmt_tileImages, .wmt_textUpper, .wmt_textGroup').addClass('wmt_center_v');
		}
		if (img) {
			var w = t.find('.wmt_tileImages').outerWidth(true),
					tw = t.width(),
					dw = tw - w-2;
			t.find('.wmt_title, .wmt_textUpper, .wmt_textGroup').outerWidth(dw);
		} else {
			t.find('.wmt_title, .wmt_textUpper, .wmt_textGroup').outerWidth('100%');
		}
	}

	if (t.hasClass('wmt_feature_b') || t.hasClass('wmt_quote_c')) {
		var w = t.find('.wmt_tileImages').outerWidth(true),
				tw = t.width(),
				dw = tw - w;
		t.find('.wmt_textGroup, .wmt_textUpper').width(dw-3);
	}
	
	//containers that adjust their height to siblings
	t.find('.wmt_adjust_chump').each(function () {
		var  th = jQuery(this),
				sh = 0;
		th.siblings('.wmt_adjust_boss').each(function () {
			if (jQuery(this).css('display') === "none") return;
			sh+= jQuery(this).outerHeight(true);
		});
		var ph = th.parent().height(),
				r = ph-sh;
		th.outerHeight(r);
		if (!t.hasClass('wmt_button')) {
			th.css('top', sh+'px');			
		}
	})

	if (t.find('.wmt_center_h').length) {
		var	c =  t.find('.wmt_center_h'),
				w = c.outerWidth(true),
				pw = c.parent().width();
		if (pw>w) c.css({'padding-left': (((pw-w)/2)/pw)*100 + '%'});
	}
	
	//disable switch animation
	if (t.hasClass('.wmt_up_switch') && (!t.find('.wmt_show_second').length || !t.find('.wmt_show_first').length)) {
		t.removeClass('.wmt_up_switch');
	}
	
	if (t.hasClass('wmt_image_b') && !t.find('.wmt_center_v').children('.wmt_title, .wmt_tagline, .wmt_description, .wmt_link').length) {
		t.find('.wmt_cover').css('display','none');
	}
	
	//equal width link spans
	var max = 0;
	t.find('.wmt_link').find('span').each(function () {			
		jQuery(this).css('width','auto');
		var w = jQuery(this).width();
		max = (w > max) ? w : max;
	});
	t.find('.wmt_link').find('span').each(function () {
		jQuery(this).css('min-width',max+'px');
	})

	//center items
	t.find('.wmt_center_v').each(function () {
		if (wmt_mobile) return;
		var  _t = jQuery(this);
		if (_t.hasClass('wmt_no_center_v')) return;
		var	h = _t.outerHeight(),
				ph = _t.parent().height();
		if (ph > h) {
			var m = (ph - h)/2;
			_t.css('margin-top',m+'px');
		} else {
			_t.css('margin-top', 0);
		}
	})

	//after process cleanup
	if (t.hasClass('wmt_focus_b')) {
		t.find('.wmt_description').height('100%');
	}
};

jQuery(document).ready(function ($) {

	/*Special Cases*/
	//Adjust viewing size
	$('.wmt_controller .wmt_tileWrap').click(function (e){
		e.preventDefault();
		var a = $(this).index();    
		if (a=== 0) {
			wmt_mobile = false;
			$('#page').css('max-width', '100%');
			$('body').removeClass('wmt_tiles_squeezed');						
			wmt_resize_grids ();
		} else if (a=== 1) {
			wmt_mobile = false;		
			$('#page').css('max-width', '640px');
			$('body').removeClass('wmt_tiles_squeezed');
			wmt_resize_grids ();			
		} else {
			wmt_mobile = true;		
			$('#page').css('max-width', '300px');
			$('body').addClass('wmt_tiles_squeezed');
			wmt_resize_grids ();
		};
	})
		
	/*Exportable*/
	$('.wmt_set_export').magnificPopup({
		type:'inline',
	});
	
	$('body').on('click', '.wmt_set_export_lightbox_content textarea', function () {
		$(this).select();
	})

	/*--Animations--*/
	//Reveal vert
	if (!wmt_mobile) {
		$('.wmt_container').on('mouseenter', '.wmt_focus_a', function () {
			$(this).find('.wmt_hide_vert').each(function () {
				var c = $(this).children();
				if (c.length && c.css('display') !== "none") $(this).height(c[0].clientHeight);
			});
		}).on('mouseleave', 'li.wmt_tileWrap', function () {
			$(this).find('.wmt_hide_vert').each(function () {
				$(this).stop().css({'height':'0'});
			});
		});
	}

	/*--Init--*/
	//Special link case: Entire tile acts as anchor
	$('body').on('click', '.wmt_link_tile', function () {
		$(this).find('.wmt_link a').first().click();
	})
	
	$('body').on('click', '.wmt_link_tile a', function (e) {
		var li = $(this).closest('li.wmt_tileWrap');
		if (li.closest('.wmt_tablet_view').length && !li.hasClass('wmt_clicked_once')) {
			$('li.wmt_tileWrap.wmt_clicked_once').removeClass('wmt_clicked_once');
			li.addClass('wmt_clicked_once');
			return false;
		}
		var _t = $(this),
				u = _t.attr('href'),
				tg = _t.attr('target');
		if (u && u!=="wmt_lightbox") {
			if (tg && tg  === "_blank") wmt_openNewWindow(u)
			else  window.location = u;
		}
		e.stopPropagation();
	})

	function wmt_openNewWindow(url ) {
	  var win=window.open(url, '_blank');
	  win.focus();
	}
	
	var  wmt_screen = screen.width;
	function wmt_choose_to_display (th) {
				var th = $(th),
						a = th.attr('data-wmt-display-above'),
						b = th.attr('data-wmt-display-below');
		if ((a && parseInt(a) > wmt_screen) || (b && parseInt(b) < wmt_screen)) $(this).remove();
	}
	
	//Main init loop
	$('.wmt_container_front_end').each(function () {
		var th = $(this);
		
		wmt_choose_to_display(th);
		
		th.find('.wmt_combined').each(function () {
			var t = $(this);
			if (!wmt_mobile) {//not mobile
				wmt_init_set(t);
			} else {//mobile
				if (t.children('ul').hasClass('wmt_slider')) t.wmt_unslider(); //slider
				t.find('.wmt_tileImage').children().each(function () {
					wmt_center_image(this);
				});
				wmt_pajInit(t);
				wmt_magnific_call(t);//lightbox
			}
		});

		if (!wmt_mobile) th.addClass('wmt_container_init').parent().removeClass('wmt_loading');
		
	})	
	$.force_appear();

	//iterate through the classes, if any matches one from this array, then return it
	function wmt_get_selector(elm) {
		var list = ['wmt_title','wmt_link', 'wmt_tileWrap', 'wmt_tagline','wmt_tileImages', 'wmt_description'];
		for (var i = 0; i < list.length; i++) {
			if (elm.hasClass(list[i])) return '.'+list[i];
		}
		return elm.prop("tagName").toLowerCase(); //probably 'a' tag if nothing else
	}

	//Lightbox
	$('body').on('mouseenter', 'wmt_lightbox', function () {
		var  e = $(this).find('.wmt_lightbox_text'),
				h = e.outerHeight();
		
		$(this).find('.wmt_lightbox_text').slideUp();
	})
	
	//Filters
	$('body').on('click','.wmt_filter', wmt_trigger_filter);
	
	function wmt_trigger_filter (t) {
//		console.log('wmt variable is: ');
		var  t = $(this),
				tg = 'wmt_triggerable',
				ts = 'wmt_filter_out',
				ul = wmt_front.reach_ul(t),
				ti = ul.find('li.wmt_tileWrap'),
				fl = t.attr('data-wmt-filter');
		if (!t.hasClass(tg)) return; //already on
		t.removeClass(tg).siblings().addClass(tg).trigger('mouseleave');//permanent hover, relieve siblings
		var f = fl === 'all'? '[data-wmt-filter]' : '[data-wmt-filter="'+fl+'"]';
		$(ti).filter(f).removeClass(ts).end().not(f).addClass(ts);
		if (ul.hasClass('wmt_slider')) {//re-initiate slider
			ul.parent().wmt_unslider();
			ul.siblings('.wmt_dots').children('.wmt_dot').eq(0).click();
		}
	}

	//Tile elements
	if (!wmt_mobile) $('.wmt_container').on('mouseenter', '.wmt_triggerable', wmt_mouseenter).on('mouseleave', '.wmt_triggerable', wmt_mouseleave);
	else $('.wmt_container').on('touchstart', '.wmt_triggerable', wmt_mouseenter).on('touchend', '.wmt_triggerable', wmt_mouseleave);

	function wmt_mouseenter() {
		wmt_hover (this, true);
	}

	function wmt_mouseleave() {
		wmt_hover (this, false);    
	}

	function wmt_hover (elem, type) {
		var t = $(elem);
		wmt_doStyle(t, type); //apply hover styles
		var c = t.attr('data-wmt-tc'); //list of children to trigger
		if (c) {
			c = c.split(",");
			if (typeof c === 'string') { //single child to trigger
				wmt_doStyle(t.find(c), type);
			} else { //multiple children
				for (var i = 0; i < c.length; i++) {
					wmt_doStyle(t.find(c[i]), type);
				}
			}
		}
	}	

	function wmt_doStyle (elem, type) {
		var t = elem;
		var s = "";
		type == true ? s = t.attr('data-wmt-style-hover') : s = t.attr('data-wmt-style-normal');
		if (s) {
			var style = JSON.parse(s);
			delete style['font-size'];
			delete style['line-height'];
			t.css(style);
		}
	}
	
	/*--Resize--*/
	function wmt_resize_grids () {
		$('.wmt_container_front_end').each(function () {

			//MOBILE
			if (wmt_mobile) {
				$(this).height('');
				$(this).find('.wmt_combined').each(function () {
					$(this).removeClass('wmt_tiles_normal').addClass('wmt_tiles_squeezed');
					//Mobile styles
					$(this).find('[data-wmt-style-mobile]').each(function () {
						var mobile_style = $(this).attr('data-wmt-style-mobile') ? JSON.parse($(this).attr('data-wmt-style-mobile')) : '{}';
						$(this).css(mobile_style);
					});
					$(this).css({'width':'','height':''}).addClass('wmt_tiles_squeezed wmt_set_squeezed_beyond_flex').find('.wmt_tileSet').height('');
					//SLIDER
					if ($(this).find('.wmt_slider').length) {
						$(this).wmt_unslider();
					//NON SLIDER
					} else {
						$(this).find('.wmt_tileWrap').css({'width': '96%', 'height':''});
						$(this).find('.wmt_tileImage>*').each(function () {
							wmt_center_image (this);
						});
					}
				})
				return;
			}

			//NON-MOBILE
			$(this).find('[data-wmt-style-original]').each(function () {//original styles
				var orig = $(this).attr('data-wmt-style-original');
				if (orig) $(this).css(JSON.parse(orig));
			})
			
			//GRID BEYOND FLEX
			var  wmt_curr_width = $(this).width(),
					wmt_flex_limit =  parseInt($(this).attr('data-wmt-width')) * (1 - parseInt($(this).attr('data-wmt-flex'))/100 ),
					wmt_original_size = wmt_curr_width === parseInt($(this).attr('data-wmt-width')) ? true : false;
			if (wmt_curr_width < wmt_flex_limit) {
				$(this).addClass('wmt_grid_squeezed_beyond_flex').removeClass('wmt_grid_within_flex').height('');
				$(this).find('.wmt_combined').each(function () {
					//give set user assigned width for beyond flex
					var  w = parseInt($(this).attr('data-wmt-set-width-beyond-flex')),
							ml = parseInt($(this).css('margin-left')),
							mr = parseInt($(this).css('margin-right')),
							pw = $(this).closest('.wmt_align_container').width();
					$(this).width((pw*w/100) - ml - mr);
					$(this).attr('data-wmt-ml', ml);
					if ($(this).children('.wmt_slider').length) $(this).css('height', $(this).attr('data-wmt-height')).find('.wmt_tileSet').height('');
					else $(this).css('height', '').find('.wmt_tileSet').height('');
					//Restore to normal for testing
					var ul = $(this).find('.wmt_tileSet'),
							h = ul.attr('data-wmt-tile-height'),
							w = ul.attr('data-wmt-tile-width');
					if (ul.attr('data-wmt-tile-width-beyond-flex') === "full-width") w = '100%';
					ul.find('li.wmt_tileWrap').height(h).width(w);
					//clean slate
					$(this).removeClass('wmt_set_squeezed wmt_tiles_squeezed wmt_set_squeezed_beyond_flex');
					var wmt_has_additional_sizing_rules = $(this).children('ul.wmt_tileSet').attr('data-wmt-media-query-rules')? true: false,
							wmt_set_within_flex = $(this).outerWidth() > (parseInt($(this).attr('data-wmt-width')) * (1 - parseInt($(this).attr('data-wmt-flex'))/100 )) ? true: false;
					//SET WITHIN FLEX
					if (wmt_set_within_flex || wmt_has_additional_sizing_rules) {
						$(this).css('height', $(this).attr('data-wmt-height'));
						if (wmt_has_additional_sizing_rules) $(this).children('li.wmt_set_title').css('max-height', 'none');//set title max-height unrestricted
						if (ul.hasClass('wmt_slider')) {
							$(this).wmt_unslider();
						} else {
							ul.height($(this).height() - $(this).children('.wmt_set_title').outerHeight(true));
							if (ul.children('.wmt_tileWrap').length > 1) wmt_fitSet(ul);
							else {//Single Tile in Set
								$(this).addClass('wmt_single_tile');
								$(this).find('.wmt_tileWrap').each(function () {
									if (($(this).hasClass('wmt_notice') || $(this).hasClass('wmt_feature')) && !$(this).find('.wmt_tileImage').length) $(this).height('');
									wmt_tile_elem_size_primer(jQuery(this));
								});
								//center images
								$(this).find('.wmt_tileImage>*').each(function () {
									wmt_center_image (this);
								});
							}
							$(this).height('auto');
						};
					//SET BEYOND FLEX
					} else {
						$(this).css('min-height','none');
						$(this).attr('data-wmt-flex-requirement', (parseInt($(this).attr('data-wmt-width')) * (1 - parseInt($(this).attr('data-wmt-flex'))/100 )));
						$(this).attr('data-wmt-flex-current', $(this).outerWidth());
						$(this).addClass('wmt_set_squeezed_beyond_flex').removeClass('wmt_tiles_squeezed wmt_single_column');
						$(this).find('ul.wmt_tileSet').height('');
						if($(this).children('ul.wmt_tileSet').hasClass('wmt_slider')) {//SLIDER
							$(this).wmt_unslider();
						} else {//NON-SLIDER
							if (!wmt_mobile && $(this).children('ul.wmt_tileSet').attr('data-wmt-media-query-rules')==false) {//NON MOBILE
								var 	sw = $(this).find('.wmt_tileSet').width(),
										tw = $(this).find('.wmt_tileSet').attr('data-wmt-tile-width'),
										d = sw-tw;
								
								//SQUEEZE TILES
								if(d<0) {
									$(this).addClass('wmt_tiles_squeezed').removeClass('.wmt_tiles_normal');//this class only for pc
									$(this).find('.wmt_tileImage').children().each(function () {
										wmt_center_image (this);
									});
								//EXPAND TILES
								} else {
									$(this).removeClass('wmt_tiles_squeezed').addClass('wmt_tiles_normal');
									var  t = Math.floor(sw/tw); //total tiles per row
									if ($(this).hasClass('wmt_responsive_spread')) {
										//arbitrary responsive margin is 5px;
										var m = t*5*2, //margin
												tw = (sw - m)/t; //tile width
									}
									//Equalize tile heights
									var li = $(this).find('li.wmt_tileWrap');
									if (t>1 && li.length > 1) {
										wmt_fitSet(ul, false);//second parameter, possible conditions = "flex"/"admin"/false 
									} else {
										$(this).addClass('wmt_single_column');
										var gap = ul.attr('data-wmt-tile-gap');
										li.each(function () {
											if (($(this).hasClass('wmt_notice') || $(this).hasClass('wmt_feature')) && !$(this).find('.wmt_tileImage').length) $(this).height('');
											wmt_tile_elem_size_primer(jQuery(this));
											$(this).not(':last-child').css('margin-bottom', gap+'px');
										});
									}
									//center images
									$(this).find('.wmt_tileImage').children().each(function () {
										wmt_center_image (this);
									});									
								}
							} else {//MOBILE
								$(this).addClass('wmt_tiles_squeezed wmt_set_squeezed_beyond_flex').parent().addClass('wmt_tiles_squeezed');
								$(this).find('.wmt_tileWrap').css('width', '');
									//center images
								$(this).find('.wmt_tileImage').children().each(function () {
									wmt_center_image (this);
								});
							}
						}
					}
				})
			//GRID WITHIN FLEX
			} else { //just bring everything to normal
				
				//clean slate
				$(this).removeClass('wmt_grid_squeezed_beyond_flex').addClass('wmt_grid_within_flex').children().removeClass('wmt_set_squeezed_beyond_flex wmt_set_squeezed wmt_tiles_squeezed').addClass('wmt_tiles_normal');
				
				//give percentage widths
				var cw= parseInt($(this).attr('data-wmt-width'));
				var ch= parseInt($(this).attr('data-wmt-height'));
				$(this).width(cw).height(ch);
				
				$(this).find('.wmt_combined').each(function () {//needed so impact can be compounded
					$(this).css('top', $(this).attr('data-wmt-top'));
				})
				
				$(this).find('.wmt_combined').each(function () {
					var w = parseInt($(this).attr('data-wmt-width'));
					var pw = (w/cw)*100;
					var h = parseInt($(this).attr('data-wmt-height'));
					var ph = (h/ch)*100;
					$(this).css({'width': pw+'%','height': ph+'%'});
					
					//Text Fit Title
					$(this).find('[data-wmt-style-original]').css(JSON.parse($(this).attr('data-wmt-style-original') ? $(this).attr('data-wmt-style-original') : '{}'));					
					if (!wmt_original_size) {
						var set_title = $(this).children('li.wmt_set_title');
						if (set_title.length) wmt_fit_text.fit (set_title, 'flex');
					}
					
					//Force full width where applicable
					if ($(this).hasClass('wmt_force_set_full_width')) wmt_force_full_width_set ($(this));
					
					//Fit the set
					if (!$(this).children('.wmt_slider').length) wmt_fitSet($(this).children('ul.wmt_tileSet'), true);
					else $(this).wmt_unslider();
					var wmt_has_additional_sizing_rules = $(this).children('ul.wmt_tileSet').attr('data-wmt-media-query-rules')? true: false;
					if (wmt_has_additional_sizing_rules) wmt_impact_front.init($(this));
					if (!wmt_original_size) {
						//Fit other texts
						$(this).find('li.wmt_tileWrap').each(function () {
							wmt_fit_text.fit ($(this), 'flex');
						})
					}
				})
			}
		})
		wmt_full_width_bg();
	};

	if (typeof wmt_admin === 'undefined') wmt_resize_grids();
	
	var wmt_slider_dir;	
	$('body').on('touchstart', '.wmt_slider li', function (event) {
		wmt_slider_dir = event.originalEvent.changedTouches[0].clientX;
	}).on('touchend', '.wmt_slider li', function (event) {
		var x = $(this).closest('.wmt_slider').siblings('.wmt_dots').find('.wmt_dot_active'),
				y = event.originalEvent.changedTouches[0].clientX - wmt_slider_dir;
		if (y === 0) return;
		(y < 1) ? x.next().click() : x.prev().click();
	})

	//responsive
	var wmt_resizing = false;
	
	if (!wmt_mobile) {
		if( jQuery.support.opacity == true	) {
			$(window).resize(function(){
	//			console.log('resizing function');		
				if(wmt_resizing !== false) {
					clearTimeout(wmt_resizing);
					wmt_resizing = false;
				};
				wmt_resizing = setTimeout(wmt_resize_grids, 50);
			});
		} else {
			var wmt_resizing = function(){
			  $(window).one("resize",function(){ //unbinds itself every time it fires
					wmt_resize_grids();
					setTimeout(wmt_resizing, 50); //rebinds itself after 50ms
			  });
			}
			wmt_resizing();
		}
	}
})

//Utility
if (!wmt_front) var wmt_front = 
(function ($) {
	return {
		reach_ul : function (t) {
			return $(t).closest('.wmt_combined').find('.wmt_tileSet');	
		},
		fit_tiles: function (ul, o, f) {
			var  c = ul.find('li.wmt_tileWrap').filter(':visible'); //exclude filtered out tiles
					ct = c.length,//Total tiles in set
					i = 0,//index
					row = parseInt(ul.attr('data-wmt-cols')), //tiles in a row
					col = Math.ceil(ct/row); //tiles in tallest col
			c.each(function () {
				//Justification
				var jt = $(this);
				jt.removeClass('wmt_top wmt_bottom wmt_left wmt_right');
				if (i<row) jt.addClass('wmt_top');//Top Row
				if ((i+1)>(row*(col-1))) jt.addClass('wmt_bottom');//Bottom Row
				if (i%row===0) jt.addClass('wmt_left');//Left Col
				if ((i+1)%row===0) jt.addClass('wmt_right');//Right Col
				i++;
			});		
		},
	};
})(jQuery);

/*ToolTip*/
jQuery(function ($) {
	var wmt_tooltip = {
		init: function (e) {
			var _ = this;
			$('body')
				.append('<div class="wph_tooltip"></div>')
				.on('mouseenter', '[data-wmt-tooltip], li.wmt_tileWrap', function () {
				if (typeof wmt_tool_tip_disabled === "boolean" && wmt_tool_tip_disabled == true || wmt_mobile) return;
				if ($(this).hasClass('wmt_filter_out')) return;
				_.currElement = $(this);
				if(!_.feed()) return;
				_.pos();
				_.show();
			})
				.on('mouseleave', '[data-wmt-tooltip], li.wmt_tileWrap', function () {
				_.hide();
			});
		},
		pos: function () {
			var  o = this.currElement.offset(),
					ow = this.currElement.outerWidth(true),
					w = (ow > 200) ? 1.2 * ow : 200,
					sw = document.body.scrollWidth,
					cw = document.body.clientWidth,
					dir = this.currElement.attr('data-wmt-tooltip-direction') ? this.currElement.attr('data-wmt-tooltip-direction') : "top";
					if (this.currElement.attr('data-wmt-tooltip-width')) w = this.currElement.attr('data-wmt-tooltip-width');
			var  h = $('.wph_tooltip').css({ //flash it to get height
															'opacity':'0',
															'display': 'inline-block',
															'max-width':w+'px',
															'width':'auto',
															}).height() + (parseInt($('.wph_tooltip').css('padding-top'))*2),//innerHeight() fails
				    w = $('.wph_tooltip').width() + (parseInt($('.wph_tooltip').css('padding-left'))*2),
					left = o.left+(ow/2) - (w/2),
					top = (o.top - 10 - h),
					right = 0,
					failed = [];

			for (var i = 0; i < 1; i++ ) {
				if (dir === "left") {
					left = o.left - w - 15;
					right = cw - left - w;
					top = o.top;
					if (left < 0 && failed.length !== 3) {
						failed.push('left');
						dir = $.inArray("right", failed) ? "top" : "right";
						i--;
						continue;
					}
				} else if (dir === "right") {
					left = o.left + ow + 15;
					right = cw - left - w;
					top = o.top;
					if ((left+w) > sw  && failed.length !== 3) {
						failed.push('right');
						dir = $.inArray("left", failed) ? "top" : "left";
						i--;
						continue;
					}
				} else if (dir === "bottom") {
					left = o.left+(ow/2) - (w/2),
					right = cw - left - w;
					top = o.top+ this.currElement.outerHeight(true) +15;
					if (((left+ow) > sw || left < 0 || (top+w) > document.body.scrollHeight) && failed.length !== 3) {
						failed.push('right');
						dir = $.inArray("top", failed) ? "left" : "top";
						i--;
						continue;
					}
				} else {//top
					left = o.left+(ow/2) - (w/2),
					top = (o.top - 15 - h);
					right = cw - left - w;
					if ((top < 0 || (left+w) > sw || left <0 ) && failed.length !== 3) {
						failed.push('right');
						dir = $.inArray("bottom", failed) ? "left" : "bottom";
						i--;
						continue;
					}
				}
			}
			
			$('.wph_tooltip').css({
				'opacity':'1',
				'left': 'auto',
				'right':right,
				'top' :  top,
			}).removeClass('wmt_tooltip_top wmt_tooltip_bottom wmt_tooltip_left wmt_tooltip_right').addClass('wmt_tooltip_'+dir);
		},
		feed: function () {
			if (!this.currElement.is('li.wmt_tileWrap')) { //part of admin
				var text = this.currElement.attr('data-wmt-tooltip');
				$('.wph_tooltip').html(text+"<div class='wmt_tooltip_arrow '></div>").css({'background-color':'#777'});
			} else { //part of a tile
				var  include = "",
						elems = this.currElement.find('.wmt_tooltip_include'),
						bg="";
						
				if (this.currElement.attr('data-wmt-style-hover') && this.currElement.attr('data-wmt-style-hover').indexOf("background-color") > -1) {
					var obj = JSON.parse(this.currElement.attr('data-wmt-style-hover'));
					bg = obj['background-color'];
				} else {
					bg = this.currElement.css('background-color');				
				}
				
				if (!elems.length || wmt_mobile)	return false;
				elems.each(function () {
					include+=$(this)[0].outerHTML;
				})
				$('.wph_tooltip').css({'background-color':bg}).html("<div class='wmt_tooltip_arrow ' style='background-color:"+bg+"; border-color:"+bg+"'></div>"+include);
			}
			return true;
		},
		hide: function () {
			$('.wph_tooltip').css({
				'opacity': 0,
				'display': 'none'
			});
		},
		show: function () {
			$('.wph_tooltip').css({
				'opacity': 1,
				'display': 'block'
			});
		},
		currElement: ""
	};

wmt_tooltip.init();			

})

function wmt_responsive_packaging (ul, condition, col_, th_) {//condition = "flex"/"admin"/false
    //First understanding dimension parameters
    var 	tile = ul.find('.wmt_tileWrap').css('position', 'absolute'),
			w = ul.width(),
			h = ul.height(),
			margin = parseInt(ul.attr('data-wmt-tile-gap')),
			tw = parseInt(ul.attr('data-wmt-tile-width')),
			col = col_ ? col_ : (condition) ? ul.attr('data-wmt-cols') : Math.floor(w/(tw+margin)),
			tw = (w-((col-1)*margin))/col,
			th = (th_  && th_ !== "" && th_ !==false) ? th_ : (condition && condition ==="admin") ? (h-(((Math.ceil(tile.length / col))-1)*margin)) / Math.ceil(tile.length / col) : ul.attr('data-wmt-tile-height'),
			totalArray = new Array(col),
			current_tile = [],
			current_space = [],
			fillArr = [],
			gapArr= [],
			lowest = [0,0],//will record the lowest tile
			gapCheck = false,
			g = 0, //Gap count
			ct, //tile
			cc = 0, //current col
			cr = 0, //current row
			cw = 0, //current tile v blocks
			ch = 0 //current tile h blocks
			cache_cc = 0,
			cache_cr = 0;
	//tw and th here are treated only as slot width and slot height
	tile.width(tw).height(th);//starting with standard dimensions
	ul.find('.wmt_gapFiller').removeClass('wmt_gapFiller');

	function wmt_fitSuccess (vert) {
		if (gapCheck == true) {//gap was filled
			gapArr.splice(g,1);
			ct.addClass('wmt_gapFiller');
			g=0;
			if (vert) {
				for (var q=0;q<gapArr.length;q++) {
					if ( (gapArr[q] instanceof Array) && gapArr[q][0] === (cc-1) && gapArr[q][1] === (cr+1))
					gapArr.splice(q,1);
//					console.log('vertical gap filler at cc: '+ (cc-1) + ' cr: ' + (cr+1));
				}
			}
		} else {
			gapCheck = true;		
			cache_cc = cc;
			cache_cr = cr;							
		}			
	};
	
	function wmt_fitFailure () {
		if (gapCheck == true) {
			g++;
		} else {// if gap mode is not on 
			gapArr[gapArr.length] = [cc, cr];
			cc++;
		}
		i--; // regardless, we are to return to tile in next iteration
	};
	
	//Mapping to array
	for (var i=0; i<tile.length; i++) {

		//pick up next tile
		ct = tile.eq(i);

		//Cancel gap mode 
		if (g >= gapArr.length) { // Case where array is either empty or been run through
			g = 0;
			gapCheck = false;
			cc = cache_cc;
			cr = cache_cr;
		}

		if (gapCheck === false) {
			//Fresh Space Mode
			if ((cc+1) > col) { //time for next row
				cc = 0;
				cr++;
			};

			if (totalArray[cc] instanceof Array) {
				if (!(totalArray[cc][cr] instanceof Array)) {
					totalArray[cc][cr] = [];
				}
			} else {
				totalArray[cc] = [];
				totalArray[cc][cr] = [];
			}
			if (totalArray[cc+1] instanceof Array) {
				if (!(totalArray[cc+1][cr] instanceof Array)) {
				}
			} else {
				totalArray[cc+1] = [];
				totalArray[cc+1][cr] = [];
			}
		} else { // Get vals from current gap
			cc = gapArr[g][0];
			cr = gapArr[g][1];
		}
		
		if (  gapCheck == false && totalArray[cc][cr][0] === true) {//skip if current space already occupied
			cc++; //Skip column
			cache_cc = cc; // updating cached values since these will be picked up again.
			cache_cr = cr;
			i--; // Return this tile in next round
		} else { //empty space
			var tcol = (ct.attr('data-wmt-relative-width')) ? parseInt(ct.attr('data-wmt-relative-width')) : 1,
					tcol = (tcol > col) ? col : tcol
					trow = (ct.attr('data-wmt-relative-height')) ? parseInt(ct.attr('data-wmt-relative-height')) : 1,
					fail = false;
			if (tcol>col) tcol=col;
			if ((cc+tcol)>col) fail = true;//not enough cols
			for (var c=0;c<tcol;c++) { //iterate over cols
				for (var r=0;r<trow;r++) {//iterate over rows of cols, check if tile already exists in this space
					if ((totalArray[cc + c] instanceof Array) && (totalArray[cc+c][cr+r] instanceof Array) && totalArray[cc+c][cr+r][0]==true) fail = true;
				}
			}
			if (fail==true) { // FAIL
				wmt_fitFailure ();
			} else { // SUCCESS
				for (var c=0;c<tcol;c++) { //iterate over cols
					for (var r=0;r<trow;r++) {//iterate over rows of cols
						if (!(totalArray[cc+c] instanceof Array)) totalArray[cc+c]=[];
						totalArray[cc+c][cr+r] = [true, 'pos', i];
					}
				};
				var  top = cr*(parseInt(th)+parseInt(margin)),
						height = (th*trow)+(margin*(trow-1));
				ct.css({
								'top' : top +'px' ,
								'left':  (cc*(tw+(parseInt(margin))))+'px', 
								'width' : ((tw*tcol)+(margin*(tcol-1)))+'px', 
								'height' : height +'px',
							});
				if ( (top + height)  > (lowest[0] + lowest[1]) ) {
					lowest[0] = top;
					lowest[1] = height;
				}
				cc=cc+tcol;
				wmt_fitSuccess ();
			}
		}
	}

	//Final Adjustments
	if (!condition) {//adjust ul if set is out of flex bounds
		ul.height(parseInt(lowest[0]) +parseInt(lowest[1]));
	} else if (condition ==="admin"){//adjust height of tile slots if ul is inflexible
		var  l = parseInt(lowest[0]) +parseInt(lowest[1]),
				r = (l === 0) ? 1: ul.height() / l,
				rows = totalArray[0].length,
				ul_height = ul.height(),
				margin_siphon = (rows-1)*margin,
				h = ( ul_height - margin_siphon) /rows, //height of single tile slot
				data = ul.parent().data('wmt');
		ul.attr('data-wmt-tile-height', h);
		data['set']['tile-height'] = h;
		data['set']['tile-width'] = tw;
		ul.parent().data('wmt', data);
		wmt_fitSet(ul, "flex");
	}
}

var wmt_impact_front = (function ($) {
	return {
		init: function (set) {
			var result = this.details(set);
			if (result == false) {
				return;
			}
			$.each(result['targets'], function (index, value) {
				value.css('top', result['type']+'='+result['amount']+'px');
			})
			set.parent().css('height', result['type']+'='+result['amount']+'px');
		},
		details: function (set) {//calculates who to affect, what kind of effect and how much effect. 
			//compare heights to see if we need impact at all
			var 	original_height = parseInt(set.attr('data-wmt-height')),
					current_height = set.outerHeight(),
					diff = current_height - original_height,
					type = (diff > 0) ? "+" : "-";
			if (!diff) return false;
			var affected = this.designate_targets(set);
			return {"type":type, "amount":diff, "targets":affected};//expanded
		},
		designate_targets: function (set) {
			var 	top = parseInt(set.css("top")),
					affected = [];
			set.siblings('.wmt_combined').each(function () {
				if (parseInt($(this).css('top')) > top) affected.push($(this));
				if ($(this).children('ul.wmt_full_width_bg').length) affected.push($(this).siblings('wmt_full_width_bg[data-wmt-associated-combo="'+$(this).attr('data-wmt-combo')+'"]'));
			})
			return affected;
		}
	}
})(jQuery)
