var wmt_paj_index = 0, wmt_pajInit;

jQuery(document).ready(function ($) {

	wmt_pajInit = function (t) {
		if (t && !t.children('[data-wmt-paj-c]').length) return;
		
		if (!t) {
			$('.wmt_paj_cont').removeClass('wmt_paj_cont');//clean slate , dump paj containers, likely in init 
			if (!$('[data-wmt-paj-c]').length) return;
			t = $('[data-wmt-paj-c]').parent();
		}

		t.each(function () {
			$(this).addClass('wmt_paj_cont');
			$(this).attr("data-wmt-paj-i", wmt_paj_index);
			wmt_paj_index++;
			var o = {
				id: $(this).attr("data-wmt-paj-i"),
				offset : $(this).find('ul').attr("data-wmt-paj-o") ? $(this).find('ul').attr("data-wmt-paj-o") : 0,
				request : 0,
				tiles : {},
				total : parseInt($(this).find('.wmt_paj_container').attr("data-wmt-total-entries"))
			};
			var x = o.offset;
			var s = $(this);
			s.find('li.tileWrap').each(function () {
				$(this).find('[data-wmt-paj-t]').each(function () {
					var i = $(this).attr('data-wmt-paj-t');
					if(!o.tiles[x]) o.tiles[x] = {};
					if(!o.tiles[x][i]) o.tiles[x][i] = {};
					o.tiles[x][i]['content'] = $(this).text();
				})
				x++;
			})
			$(this).data('wmt-paj',o);
			wmt_disable_paj (s);
		})
		t.off('click', '[data-wmt-paj-d]', wmt_pajPrep);//don't want double calls	
		t.on('click', '[data-wmt-paj-d]', wmt_pajPrep);
	}

	function wmt_disable_paj (s) {
		var o = s.data('wmt-paj');
		o.offset === 0 ? s.find('.wmt_paj_n').addClass('wmt_disable_paj') : s.find('.wmt_paj_n').removeClass('wmt_disable_paj');
		(parseInt(o.offset) + s.find('li.wmt_tileWrap').length) >= o.total ? s.find('.wmt_paj_p').addClass('wmt_disable_paj').siblings('.wmt_paj_n').removeClass('wmt_disable_paj') : s.find('.wmt_paj_p').removeClass('wmt_disable_paj');
	}

	//Prepares pagination ajax req data
    function wmt_pajPrep() {
		if ($(this).hasClass('wmt_disable_paj')) return;
		var p = $(this).closest('.wmt_paj_cont'),
				d = p.data('wmt-paj'),
				s = $(this).parent('.wmt_paj_container').siblings('ul.wmt_tileSet');
		d.request++;
		p.data('wmt-paj', d);
		var o = ($(this).attr('data-wmt-paj-d') === "prev") ? parseInt(d.offset) + s.find('li').length :  parseInt(d.offset) - s.find('li').length;
		if (o < 0) o = 0;
		var data = {"set":
			{
			"post-category":s.attr("data-wmt-paj-c"),
			"woocomm-category":s.attr("data-wmt-paj-w"),
			"post-type":s.attr("data-wmt-paj-pt"),
			"parent-page":s.attr("data-wmt-paj-pp"),
			"offset":o,
			"excerpt":s.attr("data-wmt-paj-x"),
			"entries":s.find('li').length,
			"set-index":p.attr("data-wmt-paj-i"),
			"content-type":s.attr("data-wmt-paj-ct"),
			"request":d.request,
			"content-generation":"automatic",
			}
		}
		
		if (s.find('.wmt_tagline_time').length) data["set"]['include-date'] = true;
		if (s.find('.wmt_tagline_author').length) data["set"]['include-author'] = true;
		if (s.find('.wmt_tagline_comments').length) data["set"]['include-comments'] = true;

		wmt_pajAjax(data);
		s.find('.wmt_tileImage').addClass('wmt_ImageChanging');
	}

	//Pagination ajax
	function wmt_pajAjax(data) {
	   $.ajax({
			type : "post",
			dataType : "json",
			url : wmt_myAjax.ajaxurl,
			beforeSend: function () {console.log(this.data)},
			data : {action: 'wmt_ajax_get_set', wmt_arr : JSON.stringify(data), nonce: wmt_myAjax.nonce},
			success: function (r) {
				wmt_PajDataFeed(r);
				wmt_PajVisFeed(r);
			},
		});
	}

	//Feed the paj ajax req returned data to its paj object
	function wmt_PajDataFeed (r) {//para: ajax retrieved data
		var  p = $('[data-wmt-paj-i="'+r["set-index"]+'"]'),//target set
				d = p.data('wmt-paj'),
				x = r["set-html"]["set"]["offset"],
				t = r["set-html"]["tiles"];

		for(var i in t) {
			if (t.hasOwnProperty(i)) {
				d["tiles"][x]=t[i];
			}
			x++;
		}
	}

	//Feed latest paj data to set
	function wmt_PajVisFeed (r) {
		var  p = $('[data-wmt-paj-i="'+r["set-index"]+'"]'), //target set
				d = p.data('wmt-paj'),
				c = p.find('li.wmt_tileWrap');

		if (parseInt(r['set-html']['set']['request']) === parseInt(d["request"])) { //latest request?
			var undelivered = c.length;
			if (r['set-html']['tiles']) {
				for (var i in r['set-html']['tiles']) {
					if (r['set-html']['tiles'].hasOwnProperty(i)) {
						undelivered--;
					}
				}
			}

			d.offset=r['set-html']['set']['offset'] - undelivered;
			p.data('wmt-paj', d);
			wmt_disable_paj (p);//disable the button if limit reached
			var  x = r["set-html"]["set"]["offset"],
					t = r["set-html"]["tiles"],
					ul = p.find('ul.wmt_tileSet');

			if (t) {
				for(var i in t) {
					if (t.hasOwnProperty(i)) {
						var tile = t[i];
						for (var elem in tile) {
							if (tile.hasOwnProperty(elem)) {
								if (elem==="image") {
									ul.find('li').eq(i).find('.wmt_tileImages .wmt_tileImage').each(function () {
										$(this).html('<img src= "'+tile[elem]['content']+'" data-wmt-width="'+tile[elem]['width']+'" data-wmt-height="'+tile[elem]['height']+'"  />');
									});
									ul.find('li').eq(i).find('.wmt_tileImages .wmt_tileImage').each(function () {
										var img = $(this).find('img');
										if (!img.width() || !img.height() || wmt_firefox) {
											img.load(function () {//firefox won't skip event even if img is already loaded
												wmt_center_image ($(this));
												$(this).parent().removeClass('wmt_ImageChanging').siblings().removeClass('wmt_ImageChanging');
											});
										} else {
											wmt_center_image (img);
											img.parent().removeClass('wmt_ImageChanging').siblings().removeClass('wmt_ImageChanging');
										}
									});
									ul.find('li').eq(i).find('[data-wmt-lightbox-image]').attr('data-wmt-lightbox-image', tile[elem]["content"]);
								} else if (elem==="link") {
									ul.find('li').eq(i).find('.wmt_link a').each(function () {
										if ($(this).attr('href') === "wmt_lightbox") return;
										if ($(this).attr('href').indexOf('add-to-cart') > -1) $(this).attr('href', tile[elem]["cart"]);
										else $(this).attr('href', tile[elem]["content"]);
									});
								} else {
									ul.find('li').eq(i).find('.wmt_'+elem).html(tile[elem]["content"]);
								}
							}
						}
					}
					x++;
				}
			} else {//there were no more posts, no data sent back
				p.find('.wmt_ImageChanging').removeClass('wmt_ImageChanging');
			}
			//hide unupdated tiles
			var h = c.length - undelivered;
			if (h>0) c.removeClass('wmt_paj_hide').slice(h).addClass('wmt_paj_hide');
		}
	}
})