<?php

function wmt_generate_set_markup ($arr) {

	global $wmt_mk;
	$mk = $wmt_mk;
	$h="";

	//Prepare the Title's markup
	if (isset($arr['set']['title'])) {
		(isset($arr['set']['title']['style']['mode']) && $arr['set']['title']['style']['mode'] === "overlay") ? $title_class = "wmt_set_title_overlay" : $title_class = "wmt_set_title_tile";
		$content = $arr['set']['title']['style']['content'];
		unset($arr['set']['title']['style']['content']);
		unset($arr['set']['title']['style']['mode']);

		if (isset($arr['set']['title']['style'])) $arr['set']['title']['style-normal'] = $arr['set']['title']['style'];
		wmt_parse_for_style ($arr['set']['title']);

		//The completed title markup
		$h.='<li class="wmt_set_title '.$title_class.'" style="'.(isset($arr['set']['title']['style']) ? $arr['set']['title']['style'] : "" ).'" data-wmt-style-hover ="'.(isset($arr['set']['title']['style-hover']) ?  $arr['set']['title']['style-hover'] : "" ).'" data-wmt-style-normal ="'.(isset($arr['set']['title']['style-normal']) ? $arr['set']['title']['style-normal'] : "").'" data-wmt-style-mobile ="'.(isset($arr['set']['title']['style-mobile']) ? $arr['set']['title']['style-mobile'] : "").'"  data-wmt-style-flex ="'.(isset($arr['set']['title']['style-flex'])? $arr['set']['title']['style-flex']: "").'">'.$content.'</li>';
	};

	//Prepare the Filters' markup
	if (isset($arr['set']['filters']) && isset($arr['tiles'])) {
		$sf = $arr['set']['filters'];
		//Get filters
		$f = array();
		$all = false;
		if (isset($sf['style']['all'])) {
			$all =$sf['style']['all'];
			$f[] = $sf['style']['all'];
		};

		foreach ($arr['tiles'] as $tile) {
			if (isset($tile['filter']) && isset($tile['filter']['content']))
			$f[] = $tile['filter']['content'];
		}

		$f = array_unique($f);
		
		//Create style strings
		$sf['style-normal'] = isset($sf['style']) ? $sf['style'] : '';
		$sf_align = isset($sf['style']['text-align']) ? $sf['style']['text-align'] : "center";
		wmt_parse_for_style($sf);

		//The completed fitler markup
		$h.='<div class="wmt_set_filters" style="text-align:'.$sf_align.';">';
		foreach ($f as $val) {
			$data = $val === $all ? 'all' : $val;
			$h.='<div class="wmt_filter wmt_triggerable" data-wmt-filter="'.$data.'" style="'.$sf['style'].'" data-wmt-style-hover ="'.$sf['style-hover'].'" data-wmt-style-normal ="'.$sf['style-normal'].'">'.$val.'</div>';
		}
		$h.='</div>';
	}	

	//Prepare ul container for tiles within the set
	$t = count($arr['tiles']);
	isset($arr['set']['cols'])? $cols = $arr['set']['cols'] : $cols = 2;
	isset($arr['set']['cols-m'])? $cols_m = $arr['set']['cols-m'] : $cols_m = 1;
	isset($arr['set']['set-gap'])? $set_gap = $arr['set']['set-gap'] : $set_gap = 5;
	isset($arr['set']['tile-gap'])? $tile_gap = $arr['set']['tile-gap'] : $tile_gap = 5;
	isset($arr['set']['type'])? $type = $arr['set']['type'] : $type = 'normal';//normal or slider
	isset($arr['set']['background-color'])? $bg_c = $arr['set']['background-color'] : $bg_c = 'transparent';//normal or slider
	//padding
	$p_t = isset($arr['set']['padding-top']) ? wmt_treat_dimension($arr['set']['padding-top'])  : '0';
	$p_r = isset($arr['set']['padding-right']) ? wmt_treat_dimension($arr['set']['padding-right'])  : '0';
	$p_b = isset($arr['set']['padding-bottom']) ? wmt_treat_dimension($arr['set']['padding-bottom']) : '0';
	$p_l = isset($arr['set']['padding-left']) ? wmt_treat_dimension($arr['set']['padding-left']) : '0';
	$padding = $p_t.' '.$p_r.' '.$p_b.' '.$p_l;

	//slider
	$slider = isset($arr['set']['slider']['slider-cols']) ? ' data-wmt-sl-c ="'.$arr['set']['slider']['slider-cols'].'" ' : ' data-wmt-sl-c ="1" ';
	$slider_seconds = isset($arr['set']['slider']['slider-seconds'])?  $arr['set']['slider']['slider-seconds']: "4";
	$slider .= ' data-wmt-sl-sec="'.$slider_seconds.'" ';
	if(isset($arr['set']['slider']['slider-nav-dots'])) {
		$slider .= ' data-wmt-sl-nd-dead="'.(isset($arr['set']['slider']['nav-dots-color-disabled']) ? $arr['set']['slider']['nav-dots-color-disabled'] : "").'" data-wmt-sl-nd-live="'.(isset($arr['set']['slider']['nav-dots-color-enabled']) ? $arr['set']['slider']['nav-dots-color-enabled'] : "").'" data-wmt-sl-nd-place="'.$arr['set']['slider']['nav-dots-placement'].'" ';
	}

	if(isset($arr['set']['slider']['slider-nav-arrows'])) {
		if (!isset($arr['set']['slider']['nav-arrows-prev'])) $arr['set']['slider']['nav-arrows-prev'] = "fa-caret-left";
		if (!isset($arr['set']['slider']['nav-arrows-next'])) $arr['set']['slider']['nav-arrows-next'] = "fa-caret-right";
		$slider .= ' data-wmt-sl-na-place="'.$arr['set']['slider']['nav-arrows-placement'].'" data-wmt-sl-na-color="'.$arr['set']['slider']['nav-arrows-color'].'"  data-wmt-sl-na-bg-color="'.$arr['set']['slider']['nav-arrows-bg-color'].'" data-wmt-sl-na-prev="'.$arr['set']['slider']['nav-arrows-prev'].'" data-wmt-sl-na-next="'.$arr['set']['slider']['nav-arrows-next'].'" ';
	}

	isset($arr['set']['tile-width'])? $tile_width = $arr['set']['tile-width'] : $tile_width = '';
	isset($arr['set']['tile-height'])? $tile_height = $arr['set']['tile-height'] : $tile_height = '';
	
	//pagination
	isset($arr['set']['paj'])? $paj = 'data-wmt-paj-c="'.(isset($arr['set']['post-category'])?$arr['set']['post-category'] : "" ).'" data-wmt-paj-w="'.(isset($arr['set']['woocomm-category'])?$arr['set']['woocomm-category'] : "" ).'" data-wmt-paj-pt="'.(isset($arr['set']['post-type'])? is_array($arr['set']['post-type'])? implode(',', $arr['set']['post-type']): $arr['set']['post-type'] : "" ).'" data-wmt-paj-pp="'.(isset($arr['set']['parent-page'])? is_array($arr['set']['parent-page'])? implode(',', $arr['set']['parent-page']): $arr['set']['parent-page'] : "" ).'" data-wmt-paj-o="'.(isset($arr['set']['offset'])? $arr['set']['offset'] : "").'"  data-wmt-paj-ct="'.$arr['set']['content-type'].'" data-wmt-paj-x="'.$arr['set']['excerpt'].'"' : $paj = '';

	if ($paj !== "") {
		if (empty($arr['set']['paj']['nav-arrows-next'])) $arr['set']['paj']['nav-arrows-next'] = 'fa-caret-up';
		if (empty($arr['set']['paj']['nav-arrows-prev'])) $arr['set']['paj']['nav-arrows-prev'] = 'fa-caret-down';
		if (empty($arr['set']['paj']['paj-nav-size'])) $arr['set']['paj']['paj-nav-size'] = 'small';
		if (empty($arr['set']['paj']['paj-item-color'])) $arr['set']['paj']['paj-item-color'] = '#ededed';
		if (empty($arr['set']['paj']['paj-item-bg-color'])) $arr['set']['paj']['paj-item-bg-color'] = '#999';
		if (empty($arr['set']['paj']['paj-show-index'])) $arr['set']['paj']['paj-show-index'] = 'false';
		$paj_style = '"color: '.$arr['set']['paj']['paj-item-color'].'; background-color: '.$arr['set']['paj']['paj-item-bg-color'].';"';
	}

	//appear
	$appear = isset($arr['set']['appear_animation']) ? $arr['set']['appear_animation'] : '';
	$arr['set']['style-normal'] = isset($arr['set']['style']) ? $arr['set']['style'] : '';
	wmt_parse_for_style($arr['set']);

	//stretch bg full width
	$full_width_bg = isset($arr['set']['background-full-width']) ? $arr['set']['background-full-width']: "";
	if (!empty($arr['set']['extended-background'])) {
		$arr['set']['extended-background']['style-normal'] = isset($arr['set']['extended-background']['style']) ? $arr['set']['extended-background']['style'] : '';
		wmt_parse_for_style($arr['set']['extended-background']);
		$extended_bg_style_normal = isset($arr['set']['extended-background']['style-normal']) ? $arr['set']['extended-background']['style-normal'] : "";
		$extended_bg_style_hover = isset($arr['set']['extended-background']['style-hover']) ? $arr['set']['extended-background']['style-hover'] : "";
	} else {
		$extended_bg_style_normal = "";
		$extended_bg_style_hover = "";
	}

	//tile width beyond flex
	$tile_width_beyond_flex = isset($arr['set']['tile-width-beyond-flex'])  ? $arr['set']['tile-width-beyond-flex'] : "auto";	

	//custom class
	$cust_class = (!empty($arr['set']['overall']['custom_class'])) ? $arr['set']['overall']['custom_class'] : "";

	//data
	$data = "";

	if (isset($arr['set']['data'])) {
		foreach ($arr['set']['data'] as $key=>$val) {
			$data .= 'data-wmt-'.$key.'="'.$val.'" ';
		};
	};
	
	//additional dimension rules for tiles
	$mediaQueryRules = (empty($arr['set']['media-query-rules']) || empty($arr['set']['additional-dimension-rules'])) ? "" : str_replace('"', "&quot;", json_encode($arr['set']['media-query-rules']));
	
	$h.='<ul class="wmt_tileSet wmt_'.$type.' '.$full_width_bg.'" '.$paj.' '.$slider.' '.$data.' data-wmt-cols="'.$cols.'" data-wmt-cols-m="'.$cols_m.'"  data-wmt-set-gap="'.$set_gap.'" data-wmt-tile-gap="'.$tile_gap.'" data-wmt-tile-width="'.$tile_width.'" data-wmt-tile-height="'.$tile_height.'" data-wmt-extended-bg-style-normal="'.$extended_bg_style_normal.'" data-wmt-extended-bg-style-hover="'.$extended_bg_style_hover.'" data-wmt-bg-color="'.$bg_c.'" data-wmt-padding="'.$padding.'" data-wmt-style="'.$arr['set']['style-normal'].'" data-wmt-appear="'.$appear.'" data-wmt-tile-width-beyond-flex="'.$tile_width_beyond_flex.'" data-wmt-custom-class="'.$cust_class.'" data-wmt-media-query-rules="'.$mediaQueryRules.'">';

	//Iterate over tiles within this set
	for ($c=0;$c<$t;$c++) {
		if (!isset($arr['tiles'][$c]) || !$arr['tiles'][$c] || $arr['tiles'][$c]==="undefined" ) continue;
		$tile = $arr['tiles'][$c];
		$purpose = empty($tile['type']['purpose']) ? "button":$tile['type']['purpose'];
		$option = empty($tile['type']['option']) ? "0_button" : $tile['type']['option'];
		if (!isset($option)) $option = 1;

		if (strlen($option) > 1) $option = substr($option, 0, 1);//extract out option

		global $wmt_other_browser;
		global $wmt_mobile;

		if ($purpose === "image" && $option === "2" && ($wmt_other_browser || $wmt_mobile )) $option = "3";//avoid flip in IE
		$layout = $mk[$purpose][$option];

		/*Modifying the layout*/
		//Images parent div should get the data attribs from children
		if (isset($tile['image']) && isset($tile['image']['data'])) {
			$layout['data']['images'] = $tile['image']['data'];
		}
		//notice image vert centering
		if ($purpose === "notice") {
			if (isset($tile['image'] , $tile['image']['style'], $tile['image']['style-arr']['margin-top'])) $layout['classes']['images'][] = "wmt_no_center_v";
		}

		$sequence = $layout['sequence'];
		$classes = implode(" ", $layout["classes"]["container"]);
		$class_custom = (isset($tile['overall']['class'])) ? implode($tile['overall']['class'], " ") : "";
		$classes.= " ".$class_custom;
		if (isset($tile['link']) && isset($tile['link']['class']) && isset($tile['link']['class']['link_tile'])) $classes.= ' wmt_link_tile ';//link entire tile to main link 

		//handle data attr
		$data="";
		
		$data_arr = array("tc"=>".wmt_title, .wmt_tagline, .wmt_description, .wmt_tileImages, .wmt_tileImageMain, .wmt_tileImageHover, .wmt_cover, .wmt_hide_vert");
		if (isset($tile['overall']['data'])) $data_arr = array_merge($data_arr, $tile['overall']['data']);
		foreach ($data_arr as $key=>$val) {
			$data .= 'data-wmt-'.$key.'="'.$val.'" ';
		}

		//Relative widths
		$width = (isset($tile['overall']['style']) &&  isset($tile['overall']['style']['relative-width']))? $tile['overall']['style']['relative-width'] : 1;
		$height = (isset($tile['overall']['style']) && isset($tile['overall']['style']['relative-height'])) ? $tile['overall']['style']['relative-height']: 1;		

		//Parse overall for style
		wmt_parse_for_style ($tile['overall']);

		isset($tile['overall']['style']) ? $style=$tile['overall']['style'] : $style="";
		isset($tile['overall']['style-normal']) ? $style_normal=$tile['overall']['style-normal'] : $style_normal="";
		isset($tile['overall']['style-hover']) ? $style_hover=$tile['overall']['style-hover'] : $style_hover="";

		$filter = (isset($tile['filter']) && isset($tile['filter']['content'])) ? $tile['filter']['content']: ' '; 

		//Print out tile's opening HTML
		$h.='<li class="wmt_tileWrap '.$classes.'" style="'.$style.'" '.$data.' data-wmt-filter="'.$filter.'" data-wmt-style-hover ="'.$style_hover.'" data-wmt-style-normal ="'.$style_normal.'" data-wmt-relative-width="'.$width.'" data-wmt-relative-height="'.$height.'">';

		//Factory - loop for inner elements of tile
		$used = array(); // only referred to for items with multiple class arrays within main array, only for 'elements', not group
		for ($i=0;$i<count($sequence);$i++) {
			$element = $sequence[$i];
			if (isset($layout['groups']) && isset($layout['groups'][$element])) {//Dealing with Group
				$h.= wmt_process_group($element, $layout, $tile, $used);
			} else {//Free Elements
				$h.= wmt_process_element($element, $layout, $tile, $used);
			}
		}

		$h.='</li>';
	}
	$h.='</ul>';

	//adding pagination markup		
	if ($paj !== "" ) $h.= '<div class="wmt_paj_container wmt_paj_'.$arr['set']['paj']['paj-nav-size'].' wmt_paj_show_index_'.$arr['set']['paj']['paj-show-index'].'" data-wmt-total-entries ="'.$arr['set']['total-posts'].'"><div class="wmt_paj_n wmt_paj" data-wmt-paj-d="next" style='.$paj_style.'><i class="fa '.$arr['set']['paj']['nav-arrows-next'].'"></i></div><div class="wmt_paj_p wmt_paj" data-wmt-paj-d="prev" style='.$paj_style.'><i class="fa '.$arr['set']['paj']['nav-arrows-prev'].'"></i></div></div>';
	return $h;
}

//Factory helper functions
function wmt_process_group (&$element, $layout, &$tile, &$used) {

	//classes
	$classes="";
	if (isset($layout["classes"][$element])) $classes = implode(" ", $layout["classes"][$element]);
	//data
	$data="";
	if (isset($layout["data"][$element])) {
		$data_arr = $layout["data"][$element];					
		foreach ($data_arr as $key=>$val) {
			$data .= 'data-wmt-'.$key.'="'.$val.'" ';
		}
	};

	//style
	(isset($tile[$element] ) && isset($tile[$element]['style-normal'])) ? $style_normal=$tile[$element]['style-normal'] : $style_normal="";
	(isset($tile[$element] ) && isset($tile[$element]['style-hover'])) ? $style_hover=$tile[$element]['style-hover'] : $style_hover="";
	(isset($tile[$element] ) && isset($tile[$element]['style'])) ? $style=$tile[$element]['style'] : $style="";

	$h ='<div class="'.$classes.'" '.$data.' data-wmt-style-normal="'.$style_normal.'"  data-wmt-style-hover="'.$style_hover.'" style="'.$style.'">';
	$_h = '';

	//Print Sub Elements
	for ($q=0;$q<count($layout['groups'][$element]);$q++) {
		$sub_element = $layout['groups'][$element][$q];
		if (isset($layout['groups']) && isset($layout['groups'][$sub_element]) ) $_h.= wmt_process_group ($sub_element, $layout, $tile, $used);
		else $_h.= wmt_process_element($sub_element, $layout, $tile, $used);
	}

	$h = $_h === '' ? '' : $h.$_h.'</div>';
	return $h;
}


//Will be called over per element, per tile
function wmt_process_element (&$element, $layout, &$tile, &$used) {

	$classes = "";
	if (isset($layout["classes"][$element]) ) {
		$x = $layout["classes"][$element];
		if (is_array($x[0])) {
			$x = in_array($element, $used) ? $x[1] : $x[0];//use second arr if elm is already used once
			array_push($used, $element); //note as used;
		}
		$classes = implode(" ", $x);
	}

	//handle data attr
	$data="";
	if (isset($layout["data"][$element])) {
		$data_arr = $layout["data"][$element];
		foreach ($data_arr as $key=>$val) {
			$data .= 'data-wmt-'.$key.'="'.$val.'" ';
		}
	};

	if (isset($tile[$element]['data'])) {
		foreach ($tile[$element]['data'] as $key=>$val) {
			$data .= 'data-wmt-'.$key.'="'.$val.'" ';
		};
	};

	isset($tile[$element]['content']) ? $content=$tile[$element]['content'] : $content="";
	isset($tile[$element]['style-normal']) ? $style_normal=$tile[$element]['style-normal'] : $style_normal="";
	isset($tile[$element]['style-hover']) ? $style_hover=$tile[$element]['style-hover'] : $style_hover="";
	isset($tile[$element]['style']) ? $style=$tile[$element]['style'] : $style="";
	isset($tile[$element]['style-original']) ? $style_original=$tile[$element]['style-original'] : $style_original="";
	isset($tile[$element]['style-flex']) ? $style_flex=$tile[$element]['style-flex'] : $style_flex="";
	isset($tile[$element]['style-mobile']) ? $style_mobile=$tile[$element]['style-mobile'] : $style_mobile="";

	$extra_data = "";
	$extra_class= isset($tile[$element]["class"]) ? implode(" ", $tile[$element]["class"]) : " ";

	//case of image
	if ($element === "image") {
		if (isset($tile[$element]['blur']) && $tile[$element]['blur']  === 'true') $extra_class .= " wmt_blur_image ";
		if (isset($tile[$element]['grayscale']) && $tile[$element]['grayscale']  === 'true') $extra_class .= " wmt_grayscale_image ";
	}

	//case of lightbox
	if ($element === "lightbox") {
		if (isset($tile['lightbox']['enable-lightbox-image']) && $tile['lightbox']['enable-lightbox-image'] ==="true") { //image lightbox, needs to be enbaled
			if (empty($tile['lightbox']['layout'])) $tile['lightbox']['layout']="";
			$extra_class = ' wmt_lightbox wmt_lightbox_img_loading mfp-hide wmt_lightbox_type_'.$tile['lightbox']['layout'];
			$d ="";
			if (isset($tile['lightbox']['lightbox-display-title'])) $d.="title,";
			if (isset($tile['lightbox']['lightbox-display-tagline'])) $d.="tagline,";
			if (isset($tile['lightbox']['lightbox-display-description'])) $d.="description,";
			if (isset($tile['lightbox']['lightbox-display-links'])) $d.="links";
			
			if (empty($tile['lightbox']['lightbox-bg-opacity'])) $tile['lightbox']['lightbox-bg-opacity'] = "";
			if (empty($tile['lightbox']['lightbox-bg-color'])) $tile['lightbox']['lightbox-bg-color'] = "";
			if (empty($tile['lightbox']['lightbox-bg-image'])) $tile['lightbox']['lightbox-bg-image'] = "";
			
			$extra_data = ' data-wmt-lightbox-image="'.$tile['lightbox']['content'].'" data-wmt-lightbox-display="'.$d.'" data-wmt-lightbox-bg-op="'.$tile['lightbox']['lightbox-bg-opacity'].'" data-wmt-lightbox-bg-color="'.$tile['lightbox']['lightbox-bg-color'].'" data-wmt-lightbox-bg-image="'.$tile['lightbox']['lightbox-bg-image'].'" '; 
			$content = "enabled";
		} elseif (isset($tile['lightbox']['lightbox-video'])) { //could be video source, lightbox needn't be enabled
			$extra_class = ' wmt_lightbox mfp-hide';
			$extra_data =  ' data-wmt-lightbox-video="'.$tile['lightbox']['lightbox-video'].'" ';
			$content = "enabled";
		}
	}

	//gather markup
	if ($content !== "")
	$h='<'.$tile[$element]['tag'].'  class="'.$classes.' '.$extra_class.'" style="'.$style.'" '.$extra_data.' '.$data.' data-wmt-style-hover ="'.$style_hover.'" data-wmt-style-flex ="'.$style_flex.'" data-wmt-style-mobile ="'.$style_mobile.'" data-wmt-style-original ="'.$style_original.'" data-wmt-style-normal ="'.$style_normal.'">'.$content.'</'.$tile[$element]['tag'].' >';

	else $h = "";
	return $h;
};


//Refines an array set with wmt input values

function wmt_refine_set_arr (&$arr) {

	//iterate over tile arrays
	$wmt_woo = (isset($arr['set']['content-type']) && $arr['set']['content-type'] === 'woocomm') ? true : false;//woocomm check
	
	if (empty($arr['tiles'])) return;
	foreach ($arr['tiles'] as $tile_index=>&$tile_elements) {
		//add additional elements if layout requires
		global $wmt_mk;
		if (!isset($tile_elements['type'])) return;
		$purpose = $tile_elements['type']['purpose'];
		$option = $tile_elements['type']['option'];		
		if (!isset($option)) $option = 2;//default
		if (strlen($option) > 1) $option = substr($option, 0, 1);//extract option		
		$layout = $wmt_mk[$purpose][$option];//arrived at the layout array
		if (is_array($layout['sequence']) && in_array("cover", $layout['sequence']) || in_array("flipper", $layout['sequence'])) {
			$tile_elements['cover'] = array();
			$tile_elements['cover']['style'] = $tile_elements['overall']['style'];
			$tile_elements['cover']['style-hover'] = $tile_elements['overall']['style-hover'];
		}

		//iterate over tile elements
		foreach ($tile_elements as $tile_element_name=>&$tile_element_arr) {//$tile_element_name @ title, image, tagline ...
			$name = $tile_element_name;
			$tea = $tile_element_arr;
			if (($name === "title" ||$name === "tagline" || $name === "description") && !empty($tea['style']['display']) && (empty($tea['class']) || empty($tea['class']['tooltip'])) && empty($tile_elements['lightbox']['lightbox-display-'.$tile_element_name])) { //no cause to display item
				$tile_element_arr['content'] = "";
				continue;
			}			

			if ($tile_element_name === "filter") continue;
			$tile_element_arr = stripslashes_deep($tile_element_arr); //stripslashes			

			//Lightbox
			if ($tile_element_name ==="lightbox") {
				//adding image normal mode image to lightbox if it not have one
				if (!isset($tile_elements['lightbox']['content']) &&  isset($tile_elements['lightbox']['enable-lightbox-image']) && $tile_elements['lightbox']['enable-lightbox-image'] ==="true") {
					isset($tile_elements['image']['source']) ? $tile_element_arr['content'] = $tile_elements['image']['source'] : $tile_element_arr['content'] = $tile_elements['image']['content'];
				}
				//adding video
				if (isset($tile_elements['video']['content'])  && $tile_elements['video']['content'] !== "") {
					$tile_element_arr['lightbox-video'] = $tile_elements['video']['content'];
				}
			}

			//Description
			if ($tile_element_name ==="description" && isset($tile_element_arr['content'])) {
				if ($tile_element_arr['content'] === '<br>') $tile_element_arr['content'] = '';
				$if_oembed = wp_oembed_get(strip_tags(trim($tile_element_arr['content'])));
				$tile_element_arr['content'] = ( $if_oembed == false) ? $tile_element_arr['content'] : $if_oembed;
				$tile_element_arr['content'] = apply_filters('the_content', $tile_element_arr['content']);
				if ($tile_element_arr['content'] === '<p></p>') $tile_element_arr['content'] = '';
			}

			//Image
			if ($tile_element_name ==="image" || $tile_element_name==="image-hover" ) {
				$single_image = false;
				if (empty($tile_elements['image']['do-icon']) && empty($tile_elements['image-hover']['content']) && empty($tile_elements['image']['style']['grayscale'])  && empty($tile_elements['image']['style']['blur'])) $single_image = true;
				if ($single_image && $tile_element_name==="image-hover") continue;//no hover image
				if ($tile_element_name === "image") { //set 'images' element
					$tile_elements['images'] = array();
					$tile_elements['images']['style'] = $tile_element_arr['style'];
					$tile_elements['images']['style-normal'] = isset($tile_element_arr['style-normal']) ? $tile_element_arr['style-normal'] : "";
					$tile_elements['images']['style-hover'] = isset($tile_element_arr['style-hover']) ? $tile_element_arr['style-hover'] : "";
					if ($single_image && empty($tile_element_arr['style-hover']['opacity'])) $tile_element_arr['style-hover']['opacity'] = "1";
					if (!$single_image && empty($tile_element_arr['style-hover']['opacity'])) $tile_element_arr['style-hover'] = array("opacity"=>"1");
					else if (!$single_image) $tile_element_arr['style-hover'] = array("opacity"=>"0");
					if (!$single_image && isset($tile_elements['image-hover']) && empty($tile_elements['image-hover']['content'])) {
						$tile_elements['image-hover']['content'] = isset($tile_elements['image']['source']) ? $tile_elements['image']['source'] : $tile_elements['image']['content'];
					};
				}

				if ($tile_element_name === "image-hover") {
					$normal = (isset($tile_elements['image']['do-icon'])) ? false : true;
					$tile_element_arr['style'] = (isset($tile_element_arr['style-hover']) ? $tile_element_arr['style-hover'] : "");
					if (isset($tile_element_arr['style']['opacity'])) {
						$opacity = $tile_element_arr['style']['opacity'];
						$tile_element_arr['style-hover']= array("opacity"=>$opacity);
						$tile_element_arr['style']['opacity']= 0;
					} else {
						unset($tile_element_arr['style-hover']);
					}

					if(empty($tile_element_arr['content'])) {
						$tile_element_arr['content'] = isset($tile_elements['image']['source']) ? $tile_elements['image']['source'] : $tile_elements['image']['content'];
					};
				}

				if (isset($tile_elements['image']['do-icon']) && $tile_elements['image']['do-icon'] === "true") {//icon mode
					$tile_element_arr['content'] = '<div class="fa '.$tile_elements['icon']['content'].'"></div>';
				} else {//image mode
					(!isset($tile_elements["title"]["content"])) ?  $x="" : $x = $tile_elements["title"]["content"];
					$title = ' title="'.$x.'" ';
					$alt = ' alt="'.$x.'" ';
					$tile_element_arr['source'] = $tile_element_arr['content'];
					$dims = (!empty($tile_element_arr['content'])) ? wmt_getimagesize($tile_element_arr['content']) : array(" " , " ");
					$tile_element_arr['width'] = $dims[0];
					$tile_element_arr['height'] = $dims[1];
					$darken = (isset($tile_element_arr['style']['darken']) && $tile_element_name === "image" )? '<div class="wmt_darken"></div>' : '';
					if (!empty($tile_element_arr['content']))  $tile_element_arr['content'] = '<img src="'.$tile_element_arr['content'].'" '.$alt.' '.$title.' data-wmt-width="'.$tile_element_arr['width'].'" data-wmt-height="'.$tile_element_arr['height'].'">'.$darken;
//					if (!empty($tile_element_arr['content']))  $tile_element_arr['content'] = '<img src="'.$tile_element_arr['content'].'" '.$alt.' '.$title.'>'.$darken;
				}
			}

			//Link
			if ($tile_element_name ==="link") {
				$link_html=""; //building link content
				$content = isset($tile_element_arr['content']) ? $tile_element_arr['content'] : "";
				unset($tile_element_arr['content']);
				foreach($tile_element_arr as $sub_tile_element_index => &$sub_tile_element_arr) {
					if ($sub_tile_element_index !== "enable-link-icons" && $sub_tile_element_index !== "content" ) {
						if (isset($sub_tile_element_arr['style']['url']) && $sub_tile_element_arr['style']['url'] === 'wmt_main_link' && $wmt_woo) {
							continue;//don't print main link if we are dealing with woo comm
						} elseif (isset($sub_tile_element_arr['style']['url']) && ($sub_tile_element_arr['style']['url'] === 'wmt_main_link' || $sub_tile_element_arr['style']['url'] === 'woo_page') ) {//Main link
							$sub_tile_element_arr['style']['url'] = $content;
						} elseif (isset($sub_tile_element_arr['style']['url']) && $sub_tile_element_arr['style']['url'] === 'woo_cart') {
							if (empty($tile_element_arr['cart'])) $tile_element_arr['cart'] = "";
							$sub_tile_element_arr['style']['url'] = $tile_element_arr['cart'];
						} elseif (isset($sub_tile_element_arr['style']['url']) && $sub_tile_element_arr['style']['url'] === 'wmt_lightbox') {//Lightbox
							if ( (!isset($tile_elements['video']['content']) || $tile_elements['video']['content'] === "") && (!isset($tile_elements['lightbox']['enable-lightbox-image']) || $tile_elements['lightbox']['enable-lightbox-image'] == false)) continue;
						}

						if ( !isset($sub_tile_element_arr['style']['url']) || $sub_tile_element_arr['style']['url'] === "") continue; //if you aint got a url you aint getting thru
						if (!isset($sub_tile_element_arr['style']['icon-animation'])) $sub_tile_element_arr['style']['icon-animation'] = "";
						if (!isset($sub_tile_element_arr['style']['button-animation'])) $sub_tile_element_arr['style']['button-animation'] = "";
						if (!isset($sub_tile_element_arr['style']['color'])) $sub_tile_element_arr['style']['color'] = '#ffffff';
						if (!isset($sub_tile_element_arr['style-hover']['color'])) $sub_tile_element_arr['style-hover']['color'] = '#ffffff';
						if (!isset($sub_tile_element_arr['style']['background-color'])) $sub_tile_element_arr['style']['background-color'] = '#000000';
						if (!isset($sub_tile_element_arr['style-hover']['background-color'])) $sub_tile_element_arr['style-hover']['background-color'] = '#444444';
						if (!isset($sub_tile_element_arr['style']['icon']) && !isset($sub_tile_element_arr['style']['text'])) { //excuse if text is there
							if ($sub_tile_element_arr['style']['url'] == 'wmt_lightbox') $sub_tile_element_arr['style']['icon'] = 'fa-search';
							else $sub_tile_element_arr['style']['icon'] = 'fa-link';
						};

						$icon = $sub_tile_element_arr['style']['icon'] ? $sub_tile_element_arr['style']['icon'] : "";
						$target = isset($sub_tile_element_arr['style']['target']) ? ' target="'.$sub_tile_element_arr['style']['target'].'" ' : ' target="_blank" ';
						$text_style = "";
						$text_style .= isset($sub_tile_element_arr['style']['font-family']) ? " font-family:".$sub_tile_element_arr['style']['font-family']."; " : "";
						$text_style .= isset($sub_tile_element_arr['style']['font-size']) ? " font-size:".wmt_treat_dimension($sub_tile_element_arr['style']['font-size'])."; " : "";
						$text = isset($sub_tile_element_arr['style']['text']) ? '<span class="wmt_link_text" style="'.$text_style.'" >'.$sub_tile_element_arr['style']['text'].'</span>' : '';
						$class = $text ==""? "" : " wmt_hasText "; 
						$link_html .= '<div class="'.$sub_tile_element_arr['style']['size'].' '.$sub_tile_element_arr['style']['button-animation'].' '.$class.'" data-wmt-link="'.$sub_tile_element_arr['style']['url'].'"><a href="'.$sub_tile_element_arr['style']['url'].'" class=" '.$sub_tile_element_arr['style']['icon-animation'].' wmt_triggerable" ';

						unset($sub_tile_element_arr['style']['animation']);
						unset($sub_tile_element_arr['style']['text']);
						unset($sub_tile_element_arr['style']['size']);
						unset($sub_tile_element_arr['style']['icon']);
						unset($sub_tile_element_arr['style']['url']);
						unset($sub_tile_element_arr['style']['target']);
						unset($sub_tile_element_arr['style']['button-animation']);
						unset($sub_tile_element_arr['style']['icon-animation']);
						unset($sub_tile_element_arr['style']['font-size']);
						unset($sub_tile_element_arr['style']['font-family']);

						if (isset($sub_tile_element_arr['style'])) $sub_tile_element_arr['style-normal'] = $sub_tile_element_arr['style'];
						$bob = $sub_tile_element_arr;
						wmt_parse_for_style ($bob);
						$sub_tile_element_arr = $bob;

						$style= isset($sub_tile_element_arr["style"]) ?  $sub_tile_element_arr["style"] : "";
						$style_normal= isset($sub_tile_element_arr["style-normal"]) ?  $sub_tile_element_arr["style-normal"] : "";
						
						$style_hover= isset($sub_tile_element_arr["style-hover"]) ?  $sub_tile_element_arr["style-hover"] : "";

						$link_html .=' data-wmt-style-normal="'.$style_normal.'"  data-wmt-style-hover="'.$style_hover.'" style="'.$style.'" '.$target.'><i class="fa '.$icon.'"></i>'.$text.'</a></div>';
					}
				}
				$tile_element_arr['content'] = $link_html;
			}
			
			//Handing out parent tags
			if ($tile_element_name ==="image"||$tile_element_name==="image-hover") $tile_element_arr['tag'] = "div";
			if ($tile_element_name ==="title") $tile_element_arr['tag'] = "h2";
			if ($tile_element_name ==="lightbox") $tile_element_arr['tag'] = "div";
			if ($tile_element_name ==="tagline") $tile_element_arr['tag'] = "p";
			if ($tile_element_name ==="description") $tile_element_arr['tag'] = "div";
			if ($tile_element_name ==="link") $tile_element_arr['tag'] = "div";
			
			//mobile font
			global $wmt_mobile;
			if ($wmt_mobile && (isset($tile_element_arr['style'], $tile_element_arr['style']['mobile-font-size']) || isset($tile_element_arr['style'], $tile_element_arr['style']['mobile-font-size'])) ) {
				if (isset($tile_element_arr['style']['mobile-font-size'])) $tile_element_arr['style']['font-size'] = $tile_element_arr['style']['mobile-font-size'];
				if (isset($tile_element_arr['style']['mobile-line-height'])) $tile_element_arr['style']['line-height'] = $tile_element_arr['style']['mobile-line-height'];
			}

			if (isset($tile_element_arr['style'])) $tile_element_arr['style-normal'] = $tile_element_arr['style'];
			if ($tile_element_name !== "overall") wmt_parse_for_style ($tile_element_arr);
		}
	}
}

function wmt_parse_for_style (&$sub_tile_element_arr) {
	if (!empty($sub_tile_element_arr['style'])) $sub_tile_element_arr['style-arr'] = $sub_tile_element_arr['style'];
	if (!empty($sub_tile_element_arr['style-hover'])) $sub_tile_element_arr['style-hover-arr'] = $sub_tile_element_arr['style-hover'];	
	foreach ($sub_tile_element_arr as $sub_element_name=>&$sub_element_arr) { //$sub_element_name @ content, style, style-hover...
		if (!is_array($sub_element_arr)) continue;
		if (in_array($sub_element_name, array('style', 'style-normal', 'style-hover')) ) wmt_assemble_shadows($sub_element_arr);//shadows
		if ( $sub_element_name==="style-normal" || $sub_element_name==="style-hover" ) {
			//Delete non-css entries
			$unset = array('all', 'text_color_preset', 'relative-height', 'relative-width', 'title_color_preset', 'content', 'do-icon', 'icon', 'style', 'blur', 'darken', 'grayscale', 'flex-line-height', 'mobile-line-height', 'flex-font-size', 'mobile-font-size', 'element-shadow-direction', 'element-shadow-strength', 'element-shadow-color', 'text-shadow-direction', 'text-shadow-strength', 'text-shadow-color');
			foreach ($unset as $value) {
				if (isset($sub_element_arr[$value])) unset($sub_element_arr[$value]);
			};		
			if(!isset($sub_element_arr['background-color'])) $sub_element_arr['background-color'] = "transparent";
			if (is_array($sub_element_arr)) {//create json objs for styles
				$h="{";
				$add = "";
				if(isset($sub_element_arr['background-color-opacity']) && isset($sub_element_arr['background-color']) && $sub_element_arr['background-color-opacity'] !== "transparent" && $sub_element_arr['background-color-opacity'] !== " ") { //background color opacity;
//						if ($sub_element_arr['background-color'] === "transparent") $sub_element_arr['background-color'] = '#000000';
					$add.= '&#34;background-color&#34;: &#34;'. wmt_convertHextoRGBA ($sub_element_arr['background-color'] , $sub_element_arr['background-color-opacity']) .'&#34;,'; // we want this prop added 'after' the hex bg for ie8
					unset($sub_element_arr['background-color-opacity']);
				};
				foreach($sub_element_arr as $key=>&$value) {
					if ($key === 'background-image') $value='url('.$value.')';
					wmt_treat_vals($key, $sub_element_arr);
					if ($key==="margin-top" || $key==="margin-left" || $key==="margin-right" || $key==="margin-bottom" || $key==="padding-top" || $key==="padding-right" || $key==="padding-left" || $key==="padding-bottom" ||  $key==="line-height" ||  $key==="font-size") $value = wmt_treat_dimension ($value);
					$h.='&#34;'.$key.'&#34;:&#34;'.$value.'&#34;,';//imp: we use commas here for css jsons vs semicolons for inline style strings below
				};
				$h.= $add;
				$h = strlen($h) > 1 ?  substr($h, 0, -1) : $h; //Json parse crashes at that last comma
				$h.="}";
				$sub_element_arr = $h;
			}
		}
		
		if ( $sub_element_name==="style") {

			//orig style set
			$orig = array();
			if (isset($sub_element_arr['font-size'])) $orig['font-size'] = wmt_treat_dimension ($sub_element_arr['font-size']);
			if (isset($sub_element_arr['line-height'])) $orig['line-height'] = wmt_treat_dimension ($sub_element_arr['line-height']);
			if (count($orig))$sub_tile_element_arr['style-original'] = str_replace('"', "&quot;", json_encode($orig));
			//flex style set
			$flex = array();
			if (isset($sub_element_arr['flex-font-size'])) $flex['font-size'] = wmt_treat_dimension ($sub_element_arr['flex-font-size']);
			if (isset($sub_element_arr['flex-line-height'])) $flex['line-height'] = wmt_treat_dimension ($sub_element_arr['flex-line-height']);
			if (count($flex)) $sub_tile_element_arr['style-flex'] = str_replace('"', "&quot;", json_encode($flex));
			//mobile style set
			$mobile = array();
			if (isset($sub_element_arr['mobile-font-size'])) $mobile['font-size'] = wmt_treat_dimension ($sub_element_arr['mobile-font-size']);
			if (isset($sub_element_arr['mobile-line-height'])) $mobile['line-height'] = wmt_treat_dimension ($sub_element_arr['mobile-line-height']);
			if (count($mobile)) $sub_tile_element_arr['style-mobile'] = str_replace('"', "&quot;", json_encode($mobile));
			//Delete non-css entries
			$unset = array('all', 'text_color_preset', 'relative-height', 'relative-width', 'title_color_preset', 'content', 'do-icon', 'icon', 'style', 'blur', 'darken', 'grayscale', 'flex-line-height', 'mobile-line-height', 'flex-font-size', 'mobile-font-size', 'element-shadow-direction', 'element-shadow-strength', 'element-shadow-color', 'text-shadow-direction', 'text-shadow-strength', 'text-shadow-color');
			foreach ($unset as $value) {
				if (isset($sub_element_arr[$value])) unset($sub_element_arr[$value]);
			};
		
			//all styles
			if(!isset($sub_element_arr['background-color'])) $sub_element_arr['background-color'] = "transparent";			
			if (is_array($sub_element_arr)) {//turn a string for the normal style
				$h="";
				$add = "";
				if(isset($sub_element_arr['background-color-opacity']) && isset($sub_element_arr['background-color']) && $sub_element_arr['background-color'] !== " " && $sub_element_arr['background-color-opacity'] !== "transparent" && $sub_element_arr['background-color-opacity'] !== " ") { //background color opacity;
					$add.= 'background-color:'. wmt_convertHextoRGBA ($sub_element_arr['background-color'] , $sub_element_arr['background-color-opacity']) .'; ';// we want this prop added 'after' the hex bg for ie8
					unset($sub_element_arr['background-color-opacity']);
				};
				foreach($sub_element_arr as $key=>&$value) {
					if ($key === 'background-image') $value='url('.$value.')';
					wmt_treat_vals($key, $sub_element_arr);
					if ($key==="margin-top" || $key==="margin-left" || $key==="margin-right" || $key==="margin-bottom" || $key==="padding-top" || $key==="padding-right" || $key==="padding-left" || $key==="padding-bottom" ||  $key==="line-height" ||  $key==="font-size") $value = wmt_treat_dimension ($value);
					$h.=$key.':'.$value.';';
				};
				$h.= $add;
				$sub_element_arr = $h;
			}
		}
	}
};

/*Shadows*/
$wmt_element_shadows = array(
	"top-left"=>array(
			"none",
			"-2px -2px 2px",
			"-5px -5px 5px",
			"-9px -9px 10px",
			"-15px -15px 15px",
			"-20px -20px 20px"
		),
	"left"=>array(
			"none",
			"-2px 0 2px",
			"-5px 0 5px",
			"-9px 0 10px",
			"-15px 0 15px",
			"-20px 0 20px"
		),
	"bottom-left"=>array(
			"none",
			"-2px 2px 2px",
			"-5px 5px 5px",
			"-9px 9px 10px",
			"-15px 15px 15px",
			"-20px 20px 20px"
		),
	"bottom"=>array(
			"none",
			"0 2px 2px",
			"0 5px 5px",
			"0 9px 10px",
			"0 15px 15px",
			"0 20px 20px"
		),
	"bottom-right"=>array(
			"none",
			"2px 2px 2px",
			"5px 5px 5px",
			"9px 9px 10px",
			"15px 15px 15px",
			"20px 20px 20px"
		),
	"right"=>array(
			"none",
			"2px 0 2px",
			"5px 0 5px",
			"9px 0 10px",
			"15px 0 15px",
			"20px 0 20px"
		),
	"top-right"=>array(
			"none",
			"2px -2px 2px",
			"5px -5px 5px",
			"9px -9px 10px",
			"15px -15px 15px",
			"20px -20px 20px"
		),
	"top"=>array(
			"none",
			"0 -2px 2px",
			"0 -5px 5px",
			"0 -9px 10px",
			"0 -15px 15px",
			"0 -20px 20px"
		),
	"glow"=>array(
			"none",
			"0 0 2px",
			"0 0 5px",
			"0 0 10px",
			"0 0 15px",
			"0 0 20px"
		),
);

$wmt_text_shadows = array(

	"top-left"=>array(

			"none",

			"-1px -1px 1px",

			"-2px -2px 1px",

			"-3px -3px 2px",

			"-6px -6px 3px",

			"-15px -15px 5px"

		),

	"left"=>array(

			"none",

			"-1px 0 1px",

			"-2px 0 1px",

			"-3px 0 2px",

			"-6px 0 3px",

			"-15px 0 5px"

		),

	"bottom-left"=>array(

			"none",

			"-1px 1px 1px",

			"-2px 2px 1px",

			"-3px 3px 2px",

			"-6px 6px 3px",

			"-15px 15px 5px"

		),

	"bottom"=>array(

			"none",

			"0 1px 1px",

			"0 2px 1px",

			"0 3px 2px",

			"0 6px 3px",

			"0 15px 5px"

		),

	"bottom-right"=>array(

			"none",

			"1px 1px 1px",

			"2px 2px 1px",

			"3px 3px 2px",

			"6px 6px 3px",

			"15px 15px 5px"

		),

	"right"=>array(

			"none",

			"1px 0 1px",

			"2px 0 1px",

			"3px 0 2px",

			"6px 0 3px",

			"15px 0 5px"

		),

	"top-right"=>array(

			"none",

			"1px -1px 1px",

			"2px -2px 1px",

			"3px -3px 2px",

			"6px -6px 3px",

			"15px -15px 5px"

		),

	"top"=>array(

			"none",

			"0 -1px 1px",

			"0 -2px 1px",

			"0 -3px 2px",

			"0 -6px 3px",

			"0 -15px 5px"

		),

	"glow"=>array(

			"none",

			"0 0 1px",

			"0 0 3px",

			"0 0 7px",

			"0 0 15px",

			"0 0 20px"

		),

);



function wmt_assemble_shadows (&$arr) {

	$dir = "bottom-left";
	$col = "#333333";

	global $wmt_element_shadows, $wmt_text_shadows;

	if (!empty($arr['element-shadow-strength'])) {
		if (!empty($arr['element-shadow-direction'])) $dir = $arr['element-shadow-direction'];
		if (!empty($arr['element-shadow-color'])) $col = $arr['element-shadow-color'];
		$arr['box-shadow'] = $wmt_element_shadows[$dir][(int)$arr['element-shadow-strength']].' '.$col;
	} else {
		$arr['box-shadow'] = "0 0 0 transparent";
	}

	if (!empty($arr['text-shadow-strength'])) {
		if (!empty($arr['text-shadow-direction'])) $dir = $arr['text-shadow-direction'];
		if (!empty($arr['text-shadow-color'])) $col = $arr['text-shadow-color'];
		$arr['text-shadow'] = $wmt_text_shadows[$dir][$arr['text-shadow-strength']].' '.$col;
	} else {
		$arr['text-shadow'] = "0 0 0 transparent";	
	}
};

function wmt_treat_dimension ($val) {
	if($val == 0 ) return $val; 
	if (!$val) return '';
	//if it has px/em leave it like that, but if it is has neither, add px, if it is not a number, then make it just '0'
	if (!is_numeric($val)) {
		if (strlen($val) < 3 && substr($val, -1) !== '%') return 0;
		if (substr($val, -1) === '%' && is_numeric(substr($val, -1)) )  return $val;
		$val_ = substr($val, 0, -2);
		if (!is_numeric($val_)) return 0;
	} else {
		$val = $val.'px';
	}
	return $val;
}

function wmt_treat_vals ($key, &$arr) {
	if ($key === "line-height") {
		$arr[$key] = wmt_treat_dimension ($arr[$key]);
		if ($arr[$key] === 0) $arr[$key] = '1em';
	} else if ($key==="margin-top" || $key==="margin-left" || $key==="margin-right" || $key==="margin-bottom" || $key==="padding-top" || $key==="padding-right" || $key==="padding-left" || $key==="padding-bottom" ||  $key==="font-size" || $key==="border-top-width" || $key==="border-right-width" || $key==="border-left-width" || $key==="border-bottom-width" || $key==="border-top-left-radius" || $key==="border-top-right-radius" || $key==="border-bottom-left-radius" || $key==="border-bottom-right-radius" || $key==="min-height" || $key==="max-height" || $key==="min-width" || $key==="max-width" || $key==="width" || $key==="height" )  {
		$arr[$key] = wmt_treat_dimension ($arr[$key]);
	}
}

//Hex to RGBA color conversion
function wmt_convertHextoRGBA ($hex, $opacity = 100) {
	if ($hex === "transparent" || !isset($hex) ) return "transparent";
	if (!is_numeric($opacity) || $opacity > 100 ) $opacity = 100;
	if (!$hex || $hex === "") return;
	$hex = str_replace('#','',$hex);
	if (strlen($hex) < 6) {
		while(strlen($hex) < 6) {
			$hex = $hex.$hex;
		}
	}		
	$r = intval(substr($hex, 0,2), 16);
	$g = intval(substr($hex, 2,2), 16);
	$b = intval(substr($hex, 4,2), 16);
	$result = 'rgba(' .$r. ',' .$g. ',' .$b. ',' . ($opacity/100) . ')';
	
	return $result;
}

//get image size if its on the server
$wmt_site_url = is_multisite() ? network_site_url(): site_url();
function wmt_getimagesize ($url) {
	global $wmt_site_url;
	if (strpos($url, $wmt_site_url) !== false) return (getimagesize($url)); 
	else return array("", "");
}

?>