<?php
function wmt_query ($arr) {
	//prepare query
	if ($arr['set']['content-type'] ==='post') { //For Post
		if (is_array ($arr['set']['post-category']))   $arr['set']['post-category'] = implode(",",$arr['set']['post-category']);
		$args = array(
							'cat' => $arr['set']['post-category'],
							'offset' => isset($arr['set']['offset']) ? $arr['set']['offset'] : "",
							'posts_per_page' => $arr['set']['entries']
							);
	} else if ($arr['set']['content-type'] ==='woocomm') {//For WooCommerce
		if (is_array ($arr['set']['woocomm-category']))   $arr['set']['woocomm-category'] = implode(",",$arr['set']['woocomm-category']);
		$args = array(
							'post_type' => 'product', 
							'offset' => (isset($arr['set']['offset']) ? $arr['set']['offset'] : ""), 
							'posts_per_page' => (isset($arr['set']['entries']) ? $arr['set']['entries'] : ""), 
							'tax_query' => array(
														array(
															'taxonomy' => 'product_cat', 
															'field' => 'id', 
															'terms' =>  $arr['set']['woocomm-category'],
																)
														) 
							);
	} else if ($arr['set']['content-type'] ==='other-post-type') {//For Other Post Type
		$args = array(
							'post_type' => is_array($arr['set']['post-type']) ? $arr['set']['post-type'] : explode(",",$arr['set']['post-type']),
							'offset' => (isset($arr['set']['offset']) ? $arr['set']['offset'] : ""), 
							'posts_per_page' => (isset($arr['set']['entries']) ? $arr['set']['entries'] : "") 
							);
	} else if ($arr['set']['content-type'] ==='page') {//For Pages
		$args = array(
							'post_type' => 'page',
							'post_parent' => $arr['set']['parent-page'],
							'offset' => (isset($arr['set']['offset']) ? $arr['set']['offset'] : ""), 
							'posts_per_page' => (isset($arr['set']['entries']) ? $arr['set']['entries'] : 1)
							);
	};
	if (!isset($arr['set']['excerpt']) || $arr['set']['excerpt'] === "") $arr['set']['excerpt'] = 0;
	// The Query
	$the_query = new WP_Query( $args );
	$c = 0; // Count
	$arr['set']['total-posts'] = $the_query->found_posts; //total posts in category
	if (isset($arr['tiles']['style'])) unset($arr['tiles']['style']);
	$total_tiles = count($arr['tiles']);
	$original = 0; // index of the original tile that is being used to create a copy
	//The Loop
	while ( $the_query->have_posts() ):
		$a = $arr['tiles'][$original]; // create a tile copy from this original tile
		$original++;
		if ($original >= $total_tiles) $original = 0; //next iteration, start copying from original tile again
		$the_query->the_post();//Start
		if (isset($a['filter'])) {
			$category = "";
			$cats = get_the_category();
			$length = count($cats);
			$index = 0;
			foreach ($cats as $cat) {
				$index++;
				$category .= $cat->cat_name;
				if ($index < $length) $category .= ", ";
			}
			$a['filter']['content'] = $category;
		}
		$a['title']['content'] = get_the_title();//Title
		$a['image']['content'] = wp_get_attachment_image_src( get_post_thumbnail_id() , 'full' );//Image
		$a['image']['content'] = $a['image']['content'][0];//Image
		$dims = getimagesize($a['image']['content']);
		$a['image']['width'] = $dims[0];
		$a['image']['height'] = $dims[1];
		$a['description']['content'] = wmt_limWords( strip_shortcodes( strip_tags(wp_trim_excerpt(get_the_content())) ), $arr['set']['excerpt']);//Content
		if ($arr['set']['content-type']==='post') { //Post
			$date = ""; $author = ""; $category=""; $comments="";
			if (isset($arr['set']['include-date'])) {//Date
				$date = '<span class="fa fa-clock-o"></span><span class="wmt_meta wmt_tagline_time">'.get_the_time("M j, Y").'</span>';
			};
			if (isset($arr['set']['include-author'])) {//Author
				$author = ' <span class="fa fa-user"></span><span class="wmt_meta wmt_tagline_author">'.get_the_author().'</span>';
			};
			if (isset($arr['set']['include-comments'])) {//Comments
				$o = wp_count_comments(get_the_ID());
				$comments = ' <span class="fa fa-comments"></span><span class="wmt_meta wmt_tagline_comments">'.$o->approved.'</span>';
			};
			$a['tagline']['content'] = $date.$author.$comments;//Meta
			//Link
			$a['link']['content'] = get_permalink();
		} else if ($arr['set']['content-type']==='woocomm') { //Woocomm
			global $product;
			$a['tagline']['content'] = $product->get_price_html();//Price
			$a['link']['cart'] = apply_filters( 'woocommerce_add_to_cart_url', remove_query_arg( 'added-to-cart', add_query_arg( 'add-to-cart', get_the_ID() ) ) );
			$a['link']['content'] = get_permalink();
		};
		$arr['tiles'][$c]= $a;
		$c++; //Count
	endwhile;		
	wp_reset_postdata();
	return $arr;
}
?>